//::///////////////////////////////////////////////
//:: Associate: On Spawn In
//:: 69_hen_spawnin
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Nov 19, 2001
//:://////////////////////////////////////////////

#include "69_INC_HENAI"

void EpicBonuses()
{
    object oPC = OBJECT_SELF; //I know it's not a PC, but it makes it easier to just copy the code from the PC's heartbeat
    int nACBonus;
    int nSRBonus;
    int nLevel = GetHitDice(oPC);
    effect eEffect;

    if ( GetTag(GetItemInSlot(INVENTORY_SLOT_HEAD, oPC)) == "anc_it_epiche" || GetItemPossessedBy(oPC, "anc_it_actrinket") != OBJECT_INVALID) //if the NPC has an epic helmet equipped or an AC trinket in their inventory
    {
    switch (nLevel)
        {
        case 40: nACBonus = 12; break;
        case 39: nACBonus = 12; break;
        case 38: nACBonus = 11; break;
        case 37: nACBonus = 11; break;
        case 36: nACBonus = 11; break;
        case 35: nACBonus = 10; break;
        case 34: nACBonus = 9; break;
        case 33: nACBonus = 8; break;
        case 32: nACBonus = 8; break;
        case 31: nACBonus = 7; break;
        case 30: nACBonus = 7; break;
        case 29: nACBonus = 7; break;
        case 28: nACBonus = 7; break;
        case 27: nACBonus = 6; break;
        case 26: nACBonus = 6; break;
        case 25: nACBonus = 5; break;
        case 24: nACBonus = 5; break;
        case 23: nACBonus = 4; break;
        case 22: nACBonus = 4; break;
        default: nACBonus = 3; break;
        }

    eEffect = ExtraordinaryEffect(EffectACIncrease(nACBonus, AC_DEFLECTION_BONUS));
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eEffect, oPC, 6.0);

    }

    if (GetTag(GetItemInSlot(INVENTORY_SLOT_CHEST, oPC)) == "anc_it_epicar") //if the NPC has an epic armor equipped
    {
    switch (nLevel)
        {
        case 40: nACBonus = 13; break;
        case 39: nACBonus = 13; break;
        case 38: nACBonus = 12; break;
        case 37: nACBonus = 12; break;
        case 36: nACBonus = 12; break;
        case 35: nACBonus = 10; break;
        case 34: nACBonus = 9; break;
        case 33: nACBonus = 9; break;
        case 32: nACBonus = 9; break;
        case 31: nACBonus = 8; break;
        case 30: nACBonus = 8; break;
        case 29: nACBonus = 7; break;
        case 28: nACBonus = 7; break;
        case 27: nACBonus = 6; break;
        case 26: nACBonus = 6; break;
        case 25: nACBonus = 6; break;
        case 24: nACBonus = 6; break;
        case 23: nACBonus = 4; break;
        case 22: nACBonus = 4; break;
        default: nACBonus = 3; break;
        }

    eEffect = ExtraordinaryEffect(EffectACIncrease(nACBonus, AC_ARMOUR_ENCHANTMENT_BONUS));
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eEffect, oPC, 6.0);

    }

    if (GetTag(GetItemInSlot(INVENTORY_SLOT_BELT, oPC)) == "anc_it_epicsr") //if the NPC has an epic belt equipped
    {
    nSRBonus = nLevel-18;
    if (nLevel < 21) nSRBonus = 12;
    nSRBonus = nSRBonus*2 + 10;

    eEffect = ExtraordinaryEffect(EffectSpellResistanceIncrease(nSRBonus));
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eEffect, oPC, 6.0);
    }

    //Apply Dwarven Defender damage reduction
        if (GetHasFeat(1118, oPC))
            {
            int nReduction;
            switch (GetLevelByClass(CLASS_TYPE_DWARVEN_DEFENDER, oPC))
                {
                case 6: nReduction = 3; break;
                case 7: nReduction = 3; break;
                case 8: nReduction = 3; break;
                case 9: nReduction = 3; break;
                case 10: nReduction = 6; break;
                case 11: nReduction = 6; break;
                case 12: nReduction = 6; break;
                case 13: nReduction = 6; break;
                case 14: nReduction = 9; break;
                case 15: nReduction = 9; break;
                case 16: nReduction = 9; break;
                case 17: nReduction = 9; break;
                case 18: nReduction = 12; break;
                case 19: nReduction = 12; break;
                case 20: nReduction = 12; break;
                case 21: nReduction = 12; break;
                case 22: nReduction = 15; break;
                case 23: nReduction = 15; break;
                case 24: nReduction = 15; break;
                case 25: nReduction = 15; break;
                case 26: nReduction = 18; break;
                case 27: nReduction = 18; break;
                case 28: nReduction = 18; break;
                case 29: nReduction = 18; break;
                case 30: nReduction = 21; break;
                }
            effect eReduction = EffectDamageReduction(nReduction, DAMAGE_POWER_PLUS_FIVE);
            eReduction = SupernaturalEffect(eReduction);
            AssignCommand(GetModule(), ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eReduction, oPC, 6.0));
            }
        //Done applying damage reduction

        //Check for Parry being used and apply bonus then
        if (GetActionMode(oPC, ACTION_MODE_PARRY)==TRUE)
        {
        int nParryAC = GetSkillRank(SKILL_PARRY, oPC) / 5;
        if(nParryAC>6)nParryAC=6;
        effect eParryAC = SupernaturalEffect(EffectACIncrease(nParryAC, AC_DODGE_BONUS));
        ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eParryAC, oPC, 6.0);
        }
        //End of Parry part

        //Halve the normal Tumble AC bonus and restrict Pale Master AC bonus to 6
        if (GetSkillRank(SKILL_TUMBLE, oPC, TRUE) != 0 || GetLevelByClass(CLASS_TYPE_PALE_MASTER, oPC) > 11)
        {
        int nOld = GetSkillRank(SKILL_TUMBLE, oPC, TRUE)/5;
        int nNew = GetSkillRank(SKILL_TUMBLE, oPC, TRUE)/10;
        int nPalePenalty;
        switch (GetLevelByClass(CLASS_TYPE_PALE_MASTER, oPC))
            {
            case 30: nPalePenalty = 10; break;
            case 29: nPalePenalty = 10; break;
            case 28: nPalePenalty = 10; break;
            case 27: nPalePenalty = 8; break;
            case 26: nPalePenalty = 8; break;
            case 25: nPalePenalty = 8; break;
            case 24: nPalePenalty = 8; break;
            case 23: nPalePenalty = 6; break;
            case 22: nPalePenalty = 6; break;
            case 21: nPalePenalty = 6; break;
            case 20: nPalePenalty = 6; break;
            case 19: nPalePenalty = 4; break;
            case 18: nPalePenalty = 4; break;
            case 17: nPalePenalty = 4; break;
            case 16: nPalePenalty = 4; break;
            case 15: nPalePenalty = 2; break;
            case 14: nPalePenalty = 2; break;
            case 13: nPalePenalty = 2; break;
            case 12: nPalePenalty = 2; break;
            }
        int nPenalty = nOld - nNew;
        if ( GetLevelByClass(CLASS_TYPE_PALE_MASTER, oPC) > 11) nPenalty = nPenalty + nPalePenalty;
        effect eEffect = SupernaturalEffect(EffectACDecrease(nPenalty, AC_DODGE_BONUS));
        AssignCommand(GetModule(), ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eEffect, oPC, 6.0));
        }

        // Grant the PC dragon immunity if he has that feat
        if ( GetHasFeat(1116, oPC) == TRUE )
        {
        int nType;
        switch(GetCreatureWingType(oPC))
        {
        case 4: nType = DAMAGE_TYPE_FIRE; break; //red dragon disciple
        case 34: nType = DAMAGE_TYPE_ACID; break; //black dragon disciple
        case 35: nType = DAMAGE_TYPE_ELECTRICAL; break; //blue dragon disciple
        case 36: nType = DAMAGE_TYPE_FIRE; break; //brass dragon disciple
        case 37: nType = DAMAGE_TYPE_ELECTRICAL; break; //bronze dragon disciple
        case 38: nType = DAMAGE_TYPE_ACID; break; //copper dragon disciple
        case 39: nType = DAMAGE_TYPE_FIRE; break; //gold dragon disciple
        case 40: nType = DAMAGE_TYPE_ACID; break; //green dragon disciple
        case 41: nType = DAMAGE_TYPE_COLD; break; //silver dragon disciple
        case 42: nType = DAMAGE_TYPE_COLD; break; //white dragon disciple
        default: nType = DAMAGE_TYPE_FIRE; break;
        }
        effect eImmunity = ExtraordinaryEffect(EffectDamageImmunityIncrease(nType, 100));
        AssignCommand(GetModule(), ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eImmunity, oPC, 6.0));
        }

        DelayCommand(6.0, EpicBonuses());

}

void main()
{

    EpicBonuses(); //launch the pseudo-heartbeat for all the dynamic penalties/bonuses for the henchman

    //RESPAWN WAYPOINT INSTRUCTIONS
    //Create a specific respawn location for henchman with a waypoint with TAG "WP_Respawn_'TAG'"
    //where 'TAG' is the TAG of the NPC
    //Create a default general respawn location with waypoint with TAG "NW_DEATH_TEMPLE"
    //Create a Home waypoint with TAG "WP_Home_'TAG'" where 'TAG' is the TAG of the NPC
    //     This is where the Hench will go when they quit the PC

    //Sets default level up package based on settings in henchman's blueprint
    //This may be changed through henchman dialog, do not edit
    SetLocalInt(OBJECT_SELF, "ClassPackage", GetCreatureStartingPackage(OBJECT_SELF));
    //Set variable for level up, do not edit
    SetLocalInt(OBJECT_SELF, "NewClass", -1);

    //Sets up the HENCH_LAG for this henchman,
    //Replace the 0 with any number the henchman lags(+)
    //or leads(-) in level. Save this script as something
    //else per this henchman. This allows multileveled
    //henchman
    //Minimum of -1,-2,-3... Maximum of 1,2,3... Same Level = 0
    SetLocalInt(OBJECT_SELF, "HenchLag", 0);

    //Sets the Maximum Level the Henchman may level
    //Default: 40
    SetLocalInt(OBJECT_SELF, "HENCH_MAXLEVEL", 40);

    //Sets whether or not PC is allowed into henchman inventory
    //TRUE: Inventory is accessible
    //FALSE: Inventory is not accessible
    //Default: TRUE
    SetLocalInt(OBJECT_SELF, "HenchInv", TRUE);

    //Sets whether or not initial henchman inventory is no drop
    //TRUE: Inventory is droppable
    //FALSE: Inventory is not droppable
    //Default: TRUE
    SetLocalInt(OBJECT_SELF, "HenchInvDrop", FALSE);

    //Sets the distance from the enemy that the henchman will switch to melee weapons
    SetLocalFloat(OBJECT_SELF, "HenchRange", 5.0);

    //Sets up the special henchmen listening patterns
    SetAssociateListenPatterns();
    // Set additional henchman listening patterns
    bkSetListeningPatterns();

    //Equips melee weapon by default
    //Equips ranged weapons by default if TRUE.
    SetAssociateState(NW_ASC_USE_RANGED_WEAPON, TRUE);

    //Sets the default distance that the henchman will follow
    //the PC, only uncomment one of the following three
    SetAssociateState(NW_ASC_DISTANCE_2_METERS);
    //SetAssociateState(NW_ASC_DISTANCE_4_METERS);
    //SetAssociateState(NW_ASC_DISTANCE_6_METERS);
    //End default distances

    SetAssociateState(NW_ASC_POWER_CASTING);
    SetAssociateState(NW_ASC_HEAL_AT_50);
    SetAssociateState(NW_ASC_RETRY_OPEN_LOCKS);
    SetAssociateState(NW_ASC_DISARM_TRAPS);
    SetAssociateState(NW_ASC_MODE_DEFEND_MASTER, FALSE);

    // April 2002: Summoned monsters, associates and familiars need to stay
    // further back due to their size.
    if (GetAssociate(ASSOCIATE_TYPE_HENCHMAN, GetMaster()) == OBJECT_SELF  ||
        GetAssociate(ASSOCIATE_TYPE_ANIMALCOMPANION, GetMaster()) == OBJECT_SELF  ||
        GetAssociate(ASSOCIATE_TYPE_DOMINATED, GetMaster()) == OBJECT_SELF  ||
        GetAssociate(ASSOCIATE_TYPE_FAMILIAR, GetMaster()) == OBJECT_SELF  ||
        GetAssociate(ASSOCIATE_TYPE_SUMMONED, GetMaster()) == OBJECT_SELF)
    {
        SetAssociateState(NW_ASC_DISTANCE_4_METERS);
    }

    // SPECIAL CONVERSATION SETTTINGS
    //SetSpawnInCondition(NW_FLAG_SPECIAL_CONVERSATION);
    //SetSpawnInCondition(NW_FLAG_SPECIAL_COMBAT_CONVERSATION);
            // This causes the creature to say a special greeting in their conversation file
            // upon Perceiving the player. Attach the [NW_D2_GenCheck.nss] script to the desired
            // greeting in order to designate it. As the creature is actually saying this to
            // himself, don't attach any player responses to the greeting.

    //Set starting location
    SetAssociateStartLocation();

    // For some general behavior while we don't have a master,
    // let's do some immobile animations
    // SetSpawnInCondition(NW_FLAG_IMMOBILE_AMBIENT_ANIMATIONS);

    // For some general behavior while we don't have a master,
    // let's do some mobile animations
    // SetSpawnInCondition(NW_FLAG_AMBIENT_ANIMATIONS);


    // **** Special Combat Tactics *****//
    // * These are special flags that can be set on creatures to
    // * make them follow certain specialized combat tactics.
    // * NOTE: ONLY ONE OF THESE SHOULD BE SET ON A SINGLE CREATURE.

    // * Ranged attacker
    // * Will attempt to stay at ranged distance from their
    // * target.
    // SetCombatCondition(X0_COMBAT_FLAG_RANGED);

    // * Defensive attacker
    // * Will use defensive combat feats and parry
    // SetCombatCondition(X0_COMBAT_FLAG_DEFENSIVE);

    // * Ambusher
    // * Will go stealthy/invisible and attack, then
    // * run away and try to go stealthy again before
    // * attacking anew.
    // SetCombatCondition(X0_COMBAT_FLAG_AMBUSHER);

    // * Cowardly
    // * Cowardly creatures will attempt to flee
    // * attackers.
    // SetCombatCondition(X0_COMBAT_FLAG_COWARDLY);

// CUSTOM USER DEFINED EVENTS
/*
    The following settings will allow the user to fire one of the blank user defined events in the NW_D2_DefaultD.  Like the
    On Spawn In script this script is meant to be customized by the end user to allow for unique behaviors.  The user defined
    events user 1000 - 1010
*/
    //SetSpawnInCondition(NW_FLAG_PERCIEVE_EVENT);         //OPTIONAL BEHAVIOR - Fire User Defined Event 1002
    //SetSpawnInCondition(NW_FLAG_ATTACK_EVENT);           //OPTIONAL BEHAVIOR - Fire User Defined Event 1005
    //SetSpawnInCondition(NW_FLAG_DAMAGED_EVENT);          //OPTIONAL BEHAVIOR - Fire User Defined Event 1006
    //SetSpawnInCondition(NW_FLAG_DISTURBED_EVENT);        //OPTIONAL BEHAVIOR - Fire User Defined Event 1008
    //SetSpawnInCondition(NW_FLAG_END_COMBAT_ROUND_EVENT); //OPTIONAL BEHAVIOR - Fire User Defined Event 1003
    //SetSpawnInCondition(NW_FLAG_ON_DIALOGUE_EVENT);      //OPTIONAL BEHAVIOR - Fire User Defined Event 1004
    //SetSpawnInCondition(NW_FLAG_DEATH_EVENT);            //OPTIONAL BEHAVIOR - Fire User Defined Event 1007

    if(GetLocalInt(OBJECT_SELF, "HenchInvDrop") == FALSE)
    {
      HenchmanNoDropItems69(TRUE, OBJECT_SELF);
    }
}
