//::///////////////////////////////////////////////
//:: Shadooow's Pseudo-list impementation
//:: FileName _sh_inc_list
//:://////////////////////////////////////////////

//                                     1234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890  -> 160elements max
const string LIST_ELEMENTS_ALPHABET = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ!#$%&()*+,-./:;<=>?@_~|{}[\]^`'å弣،";//note a space should work too, a "'" character is not recommended as it could mess SQL command, a  character doesnt work with string commands
//                                              1         2         3         4         5         6         7         8         9        10        11        12        13        14        15        16

//This function destroy valid List with same sName on same oList and nStoreMethod
//or... Do nothing!
// oList - object that hold the list
object ListCreate(string sName);

//Add new element to end of List with sName
//Each element can contain one integer, one float, one string and one object.
//If there is not valid List with such name, new List is created.
// oList - object that hold the list
void ListAddElement(object oList, int nInt=0 ,string sString="", object oObject=OBJECT_INVALID, float fFloat=0.0);

//Add new int to end of List with sName. It's same as element with only int value.
//You ask why use this function? Well, elements store all types and checks if is every data type valid and
//then store it. So, if you use element for add one int it will do 3 extra commands.
//If there is not valid List with such name, new List is created.
// oList - object that hold the list
void ListAddInt(object oList, int nInt);

//Set nInt to nth element of List with sName.
//But nInt is stored only if List has nTh element!
// oList - object that hold the list
void ListSetInt(object oList, int nTh, int nInt);

//Set sString to nth element of List with sName.
//But sString is stored only if List has nTh element!
// oList - object that hold the list
void ListSetString(object oList, int nTh, string sString);

//Set oObject to nth element of List with sName.
//But oObject is stored only if List has nTh element!
// oList - object that hold the list
void ListSetObject(object oList, int nTh, object oObject);

//Set fFloat to nth element of List with sName.
//But fFloat is stored only if List has nTh element!
// oList - object that hold the list
void ListSetFloat(object oList, int nTh, float fFloat);

//Add new string to end of List with sName. It's same as element with only int value.
//You ask why use this function? Well, elements store all types and checks if is every data type valid and
//then store it. So, if you use element for add one int it will do 3 extra commands.
//If there is not valid List with such name, new List is created.
void ListAddString(object oList, string sString);

//Add new float to end of List with sName. It's same as element with only int value.
//You ask why use this function? Well, elements store all types and checks if is every data type valid and
//then store it. So, if you use element for add one int it will do 3 extra commands.
//If there is not valid List with such name, new List is created.
void ListAddFloat(object oList, float fFloat);

//Add new object to end of List with sName. It's same as element with only int value.
//You ask why use this function? Well, elements store all types and checks if is every data type valid and
//then store it. So, if you use element for add one int it will do 3 extra commands.
//If there is not valid List with such name, new List is created.
// oList - object that hold the list
void ListAddObject(object oList, object oObject);


//Returns nTh value stored in List with sName
int ListGetInt(object oList, int nTh);


//Returns nTh value stored in List with sName
// oList - object that hold the list
string ListGetString(object oList, int nTh);


//Returns nTh value stored in List with sName
// oList - object that hold the list
float ListGetFloat(object oList, int nTh);

//Returns nTh value stored in List with sName
// oList - object that hold the list
object ListGetObject(object oList, int nTh);

//Returns nTh element from List with sName
// oList - object that hold the list
struct element ListGetNthElement(object oList, int nTh);

//Returns TRUE if List's element is valid, FALSE otherwise.
int ListGetIsElementValid(struct element eElement);

//Remove nTh element from List with sName
//This move every element that was behind nTh by 1 backwards.
// oList - object that hold the list
void ListRemoveElement(object oList, int nTh);

//Returns how many elements contain List with sName
// oList - object that hold the list
int ListGetElementCount(object oList);

//Returns nTh element name
string ListGetElementName(object oList, int nTh);

int ListGetIntArray(object oList, int nTh, int nArrayTh);
void ListSetIntArray(object oList, int nTh, int nArrayTh, int nInt);

struct element
{
int Int;
string String;
float Float;
object Object;
/*location Location;
itemproperty ItemProperty;
vector Vector;
struct map_pin MapPin;*/
};

////////////////////////////////////////////////////////////////////////////////
//             function definitions                //
////////////////////////////////////////////////////////////////////////////////

string GetFirstUnusedChar(object oList)//pseudo-list private function
{
string sChar, pool = GetLocalString(oList,"POOL");
 if(pool != "")
 {
 SetLocalString(oList,"POOL",GetStringRight(pool,GetStringLength(pool)-2));
 return GetStringLeft(pool,2);
 }
int max = GetLocalInt(oList,"MAX");
SetLocalInt(oList,"MAX",max+1);
int y = max/150;
return GetSubString(LIST_ELEMENTS_ALPHABET,y,1)+GetSubString(LIST_ELEMENTS_ALPHABET,max-y*150,1);
}

object ListCreate(string sName)
{
sName = "LIST_"+sName;
object oList = GetObjectByTag(sName);
 if(!GetIsObjectValid(oList))
 {
 oList = CreateObject(OBJECT_TYPE_WAYPOINT,"nw_waypoint001",GetStartingLocation(),FALSE,sName);
 }
return oList;
}

void ListAddElement(object oList, int nInt=0 ,string sString="", object oObject=OBJECT_INVALID, float fFloat=0.0)
{
string sChar = GetFirstUnusedChar(oList);
SetLocalString(oList,"LIST",GetLocalString(oList,"LIST")+sChar);
 if(nInt)
 SetLocalInt(oList,sChar,nInt);
 if(sString != "")
 SetLocalString(oList,sChar,sString);
 if(fFloat != 0.0)
 SetLocalFloat(oList,sChar,fFloat);
 if(oObject != OBJECT_INVALID)
 SetLocalObject(oList,sChar,oObject);
}

struct element ListGetNthElement(object oList, int nTh)
{
struct element e;
string sChar = ListGetElementName(oList,nTh);
e.Int = GetLocalInt(oList,sChar);
e.String = GetLocalString(oList,sChar);
e.Float = GetLocalFloat(oList,sChar);
e.Object = GetLocalObject(oList,sChar);
return e;
}

void ListRemoveElement(object oList, int nTh)
{
nTh = (nTh-1)*2;
string sList = GetLocalString(oList,"LIST");
string sChar = GetSubString(sList,nTh,2);
int numElements = GetStringLength(sList);
 if(numElements < 2)
 {
 DeleteLocalString(oList,"LIST");
 }
 else
 {
 SetLocalString(oList,"LIST",GetStringLeft(sList,nTh)+GetStringRight(sList,numElements-nTh-2));
 }
SetLocalString(oList,"POOL",GetLocalString(oList,"POOL")+sChar);
DeleteLocalInt(oList,sChar);
DeleteLocalString(oList,sChar);
DeleteLocalFloat(oList,sChar);
DeleteLocalObject(oList,sChar);
}

int ListGetElementCount(object oList)
{
return GetStringLength(GetLocalString(oList,"LIST"))/2;
}

string ListGetElementName(object oList, int nTh)
{
return GetSubString(GetLocalString(oList,"LIST"),(nTh-1)*2,2);
}

int ListGetIsElementValid(struct element eElement)
{
 if(eElement.Int)
 return TRUE;
 else if(eElement.String != "")
 return TRUE;
 else if(eElement.Float != 0.0)
 return TRUE;
 else if(eElement.Object != OBJECT_INVALID)
 return TRUE;
return FALSE;
}

void ListAddInt(object oList, int nInt)
{
string sChar = GetFirstUnusedChar(oList);
SetLocalString(oList,"LIST",GetLocalString(oList,"LIST")+sChar);
SetLocalInt(oList,sChar,nInt);
}

int ListGetInt(object oList, int nTh)
{
return GetLocalInt(oList,ListGetElementName(oList,nTh));
}

void ListAddString(object oList, string sString)
{
string sChar = GetFirstUnusedChar(oList);
SetLocalString(oList,"LIST",GetLocalString(oList,"LIST")+sChar);
SetLocalString(oList,sChar,sString);
}

string ListGetString(object oList, int nTh)
{
return GetLocalString(oList,ListGetElementName(oList,nTh));
}

void ListAddFloat(object oList, float fFloat)
{
string sChar = GetFirstUnusedChar(oList);
SetLocalString(oList,"LIST",GetLocalString(oList,"LIST")+sChar);
SetLocalFloat(oList,sChar,fFloat);
}

float ListGetFloat(object oList, int nTh)
{
return GetLocalFloat(oList,ListGetElementName(oList,nTh));
}

void ListAddObject(object oList, object oObject)
{
string sChar = GetFirstUnusedChar(oList);
SetLocalString(oList,"LIST",GetLocalString(oList,"LIST")+sChar);
SetLocalObject(oList,sChar,oObject);
}

object ListGetObject(object oList, int nTh)
{
return GetLocalObject(oList,ListGetElementName(oList,nTh));
}

void ListSetInt(object oList, int nTh, int nInt)
{
string sChar = ListGetElementName(oList,nTh);
 if(sChar != "")
 {
 SetLocalInt(oList,sChar,nInt);
 }
}

void ListSetIntArray(object oList, int nTh, int nArrayTh, int nInt)
{
string sChar = ListGetElementName(oList,nTh);
 if(sChar != "")
 {
 SetLocalInt(oList,sChar+"_"+IntToString(nArrayTh),nInt);
 }
}

int ListGetIntArray(object oList, int nTh, int nArrayTh)
{
return GetLocalInt(oList,ListGetElementName(oList,nTh)+"_"+IntToString(nArrayTh));
}

void ListSetString(object oList, int nTh, string sString)
{
string sChar = ListGetElementName(oList,nTh);
 if(sChar != "")
 {
 SetLocalString(oList,sChar,sString);
 }
}

void ListSetObject(object oList, int nTh, object oObject)
{
string sChar = ListGetElementName(oList,nTh);
 if(sChar != "")
 {
 SetLocalObject(oList,sChar,oObject);
 }
}

void ListSetFloat(object oList, int nTh, float fFloat)
{
string sChar = ListGetElementName(oList,nTh);
 if(sChar != "")
 {
 SetLocalFloat(oList,sChar,fFloat);
 }
}

