//::///////////////////////////////////////////////
//:: Example XP2 OnItemAcquireScript
//:: x4_mod_def_aqu
//:: (c) 2014 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Put into: OnItemAcquire Event

*/
//:://////////////////////////////////////////////
//:: Created By: Georg Zoeller
//:: Created On: 2003-07-16
//:://////////////////////////////////////////////

#include "x2_inc_switches"
#include "x4_inc_functions"
#include "prc_class_const"

void main()
{
     object oItem = GetModuleItemAcquired();
     object oPC = GetModuleItemAcquiredBy();
	 
	int nLevel = GetLevelByClass(CLASS_TYPE_ROGUE, oPC) 
				+ GetLevelByClass(CLASS_TYPE_ASSASSIN, oPC)	
				+ GetLevelByClass(CLASS_TYPE_BEGUILER, oPC)
				+ GetLevelByClass(CLASS_TYPE_FACTOTUM, oPC)
				+ GetLevelByClass(CLASS_TYPE_NINJA, oPC)
				+ GetLevelByClass(CLASS_TYPE_PSYCHIC_ROGUE, oPC)
				+ GetLevelByClass(CLASS_TYPE_SCOUT, oPC)
				+ GetLevelByClass(CLASS_TYPE_ARCTRICK, oPC)
				+ GetLevelByClass(CLASS_TYPE_BFZ, oPC)
				+ GetLevelByClass(CLASS_TYPE_GHOST_FACED_KILLER, oPC)
				+ GetLevelByClass(CLASS_TYPE_HANDOTWM, oPC)
				+ GetLevelByClass(CLASS_TYPE_HARPER, oPC)
				+ GetLevelByClass(CLASS_TYPE_NIGHTSHADE, oPC)
				+ GetLevelByClass(CLASS_TYPE_NINJA_SPY, oPC)
				+ GetLevelByClass(CLASS_TYPE_SHADOWBANE_INQUISITOR, oPC)
				+ GetLevelByClass(CLASS_TYPE_SHADOWBANE_STALKER	, oPC)		
				+ GetLevelByClass(CLASS_TYPE_SHADOWBLADE, oPC)
				+ GetLevelByClass(CLASS_TYPE_SHADOWDANCER, oPC)
				+ GetLevelByClass(CLASS_TYPE_SHADOWLORD, oPC)
				+ GetLevelByClass(CLASS_TYPE_SHADOWMIND, oPC)
				+ GetLevelByClass(CLASS_TYPE_SHADOWSMITH, oPC)
				+ GetLevelByClass(CLASS_TYPE_SHADOW_SUN_NINJA, oPC)
				+ GetLevelByClass(CLASS_TYPE_SHADOW_THIEF_AMN, oPC)
				+ GetLevelByClass(CLASS_TYPE_SLAYER_OF_DOMIEL, oPC)
				+ GetLevelByClass(CLASS_TYPE_UNSEEN_SEER, oPC);	

     //Let's save the henchman to the database each time their inventory is altered
     int nHenchPosition = GetLocalInt(oPC, "HenchPosition");
     if (nHenchPosition > 0 && GetLocalInt(oPC, "JustSpawned") == FALSE)
     {
        string sHenchPosition = IntToString(nHenchPosition);
        string sHenchName = GetName(oPC);

        StoreCampaignObject(CharacterDB(GetMaster(oPC)), "HENCH_"+sHenchPosition, oPC);
        DelayCommand(0.4, SetCampaignString(CharacterDB(GetMaster(oPC)), "HENCH_"+sHenchPosition+"_NAME", sHenchName));
     }

     //This is a workaround to restrict epic traps to rogues
     string sTag = GetTag(oItem);
     if ((sTag == "anc_trapfire5" || sTag == "anc_trapfrost5" || sTag == "anc_trapelec5" || sTag == "anc_trapsonic5") && nLevel == 0)
     {
        DestroyObject(oItem);
        CreateItemOnObject(GetTag(oItem)+"re", oPC);
     }
     else if ((sTag == "anc_trapfire5re" || sTag == "anc_trapfrost5re" || sTag == "anc_trapelec5re" || sTag == "anc_trapsonic5re") && nLevel != 0)
     {
        DestroyObject(oItem);
        if (sTag == "anc_trapfire5re") sTag = "anc_trapfire5";
        if (sTag == "anc_trapfrost5re") sTag = "anc_trapfrost5";
        if (sTag == "anc_trapsonic5re") sTag = "anc_trapsonic5";
        if (sTag == "anc_trapelec5re") sTag = "anc_trapelec5";
        CreateItemOnObject(sTag, oPC);
     }

     {
     //Put your custom code here.
     }

     // * Generic Item Script Execution Code
     // * If MODULE_SWITCH_EXECUTE_TAGBASED_SCRIPTS is set to TRUE on the module,
     // * it will execute a script that has the same name as the item's tag
     // * inside this script you can manage scripts for all events by checking against
     // * GetUserDefinedItemEventNumber(). See x2_it_example.nss
     if (GetModuleSwitchValue(MODULE_SWITCH_ENABLE_TAGBASED_SCRIPTS) == TRUE)
     {
        SetUserDefinedItemEventNumber(X2_ITEM_EVENT_ACQUIRE);
        int nRet =   ExecuteScriptAndReturnInt(GetUserDefinedItemEventScriptName(oItem),OBJECT_SELF);
        if (nRet == X2_EXECUTE_SCRIPT_END)
        {
           return;
        }

     }

}
