//::///////////////////////////////////////////////
//:: Example XP2 OnItemUnAcquireScript
//:: x4_mod_def_unaqu
//:: (c) 2014 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Put into: OnItemUnAcquire Event

*/
//:://////////////////////////////////////////////
//:: Created By: Georg Zoeller
//:: Created On: 2003-07-16
//:://////////////////////////////////////////////

#include "x2_inc_switches"
#include "x2_inc_itemprop"
#include "x4_inc_functions"

void main()
{
     object oPC = GetModuleItemLostBy();
     object oItem = GetModuleItemLost();
     object oOwner = GetItemPossessor(oItem);

     //Let's save the henchman to the database each time their inventory is altered
     int nHenchPosition = GetLocalInt(oPC, "HenchPosition");
     if (nHenchPosition > 0 && GetLocalInt(oPC, "JustSpawned") == FALSE)
     {
        string sHenchPosition = IntToString(nHenchPosition);
        string sHenchName = GetName(oPC);

        StoreCampaignObject(CharacterDB(GetMaster(oPC)), "HENCH_"+sHenchPosition, oPC);
        DelayCommand(0.4, SetCampaignString(CharacterDB(GetMaster(oPC)), "HENCH_"+sHenchPosition+"_NAME", sHenchName));
     }

      ///////////////////////////////////////////////////////////////////////////

     //::Added to place disarmed weapons back into a player inventory.
     ///////////////////////////////////////////////////////////////////////////
     int iLoopStop = GetLocalInt(oItem, "LOOP_STOP");

     if (GetIsPC(oPC) && GetIsInCombat(oPC))
        {
        if (IPGetIsMeleeWeapon(oItem) || IPGetIsRangedWeapon(oItem))
            {
            if (iLoopStop != TRUE)
                {
                SetLocalInt(oItem, "LOOP_STOP", TRUE);
                SetLocalInt(oItem, "EQUIP_DELAY", TRUE);
                object oCopy;
                if (GetPlotFlag(oItem))
                {
                SetPlotFlag(oItem, FALSE);
                oCopy = CopyItem(oItem, oPC, TRUE);
                SetPlotFlag(oCopy, TRUE);
                }
                else oCopy = CopyItem(oItem, oPC, TRUE);
                DelayCommand(2.0, DeleteLocalInt(oCopy, "LOOP_STOP"));
                //Equip delay below:
                DelayCommand(18.0, DeleteLocalInt(oCopy, "EQUIP_DELAY"));
                DestroyObject(oItem, 0.0);
            }
            }

        }
     ///////////////////////////////////////////////////////////////////////////

     //1.70 Patch by Mavrixio, solution for overfilled stores causing huge lags
     if (GetLocalInt(OBJECT_SELF,"70_OVERFILLED_STORES_ISSUE_FIX") && GetIsPC(oPC) && GetObjectType(oOwner) == OBJECT_TYPE_STORE)
     {
         object oStore = oOwner;
         int nLastItemIndex = GetLocalInt(oStore, "MOD_CLEAN_STORE_LAST");
         SetLocalObject(oStore, "MOD_CLEAN_STORE_ITEM"+IntToString(nLastItemIndex), oItem);
         nLastItemIndex++;
         SetLocalInt(oStore, "MOD_CLEAN_STORE_LAST", nLastItemIndex);
         if (nLastItemIndex > GetLocalInt(OBJECT_SELF,"70_OVERFILLED_STORES_ISSUE_FIX"))
         {
             int nFirstItemIndex = GetLocalInt(oStore, "MOD_CLEAN_STORE_FIRST");
             object oItem = GetLocalObject(oStore, "MOD_CLEAN_STORE_ITEM"+IntToString(nFirstItemIndex));
             if (GetItemPossessor(oItem) == oStore)
             {
                 DestroyObject(oItem);
             }
             DeleteLocalObject(oStore, "MOD_CLEAN_STORE_ITEM"+IntToString(nFirstItemIndex));
             nFirstItemIndex++;
             SetLocalInt(oStore, "MOD_CLEAN_STORE_FIRST", nFirstItemIndex);
         }
     }

     // * Generic Item Script Execution Code
     // * If MODULE_SWITCH_EXECUTE_TAGBASED_SCRIPTS is set to TRUE on the module,
     // * it will execute a script that has the same name as the item's tag
     // * inside this script you can manage scripts for all events by checking against
     // * GetUserDefinedItemEventNumber(). See x2_it_example.nss
     if (GetModuleSwitchValue(MODULE_SWITCH_ENABLE_TAGBASED_SCRIPTS) == TRUE)
     {
        SetUserDefinedItemEventNumber(X2_ITEM_EVENT_UNACQUIRE);
        int nRet = ExecuteScriptAndReturnInt(GetUserDefinedItemEventScriptName(oItem),OBJECT_SELF);
        if (nRet == X2_EXECUTE_SCRIPT_END)
        {
           return;
        }
     }
}
