//::///////////////////////////////////////////////
//:: Name x2_def_ondeath
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Default OnDeath script
*/
//:://////////////////////////////////////////////
//:: Created By: Keith Warner
//:: Created On: June 11/03
//:://////////////////////////////////////////////
#include "quest_inc"

void RevertExp(object oKiller, int nExperience)
{
    SetXP(oKiller, nExperience);
}

void main()
{
    //Travelling merchants drop some gold
    if (GetTag(OBJECT_SELF) == "anc_trmerch" && GetLocalInt(GetArea(OBJECT_SELF), "MerchantTrouble") == FALSE)
    {
        int nGold = GetLocalInt(OBJECT_SELF, "Gold") + GetLocalInt(OBJECT_SELF, "HiddenGold");
        GiveGoldToCreature(OBJECT_SELF, nGold);
        object oItem = GetFirstItemInInventory();
        while (GetIsObjectValid(oItem))
        {
            if (GetTag(oItem) == "NW_IT_GOLD001") SetDroppableFlag(oItem, TRUE);
            oItem = GetNextItemInInventory();
        }
    }

    //If we are one of the monsters from the monsters quest
    if (GetLocalInt(OBJECT_SELF, "QuestMonster") == TRUE)
    {
        object oArea = GetArea(OBJECT_SELF);
        object oCreature = GetFirstObjectInArea(oArea);
        int AllKilled = TRUE;
        while (GetIsObjectValid(oCreature))
            {
                if (GetLocalInt(oCreature, "QuestMonster") == TRUE && !GetIsDead(oCreature) && oCreature != OBJECT_SELF)
                {
                    AllKilled = FALSE;
                    break;
                }
                oCreature = GetNextObjectInArea(oArea);
            }
        object oPC = GetLocalObject(OBJECT_SELF, "oPC");
        if (AllKilled == TRUE) AddRandomQuestJournalEntry(oPC, 2);
    }

    //This will return experience the killing creature had before XP reward for killing us was given
    object oKiller = GetLastKiller();
    int nExp = GetXP(oKiller);
    DelayCommand(0.1, SetXP(oKiller, nExp));

    if(GetLocalInt(OBJECT_SELF, "X4_VANILLA_AI") == TRUE) ExecuteScript("nw_c2_default7_c", OBJECT_SELF);
    else ExecuteScript("nw_c2_default7", OBJECT_SELF);
}
