//::///////////////////////////////////////////////
//:: Name x2_def_endcombat
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Default Combat Round End script
*/
//:://////////////////////////////////////////////
//:: Created By: Keith Warner
//:: Created On: June 11/03
//:://////////////////////////////////////////////

#include "x0_i0_henchman"
void main()
{
    int nCombatRounds = GetLocalInt(OBJECT_SELF, "CombatRounds");
    nCombatRounds++;
    SetLocalInt(OBJECT_SELF, "CombatRounds", nCombatRounds);

    //Check if there aren't enough guardians already (1 + the number of players)
    int nPlayers = GetLocalInt(OBJECT_SELF, "PlayersInParty");
    object oObject = GetFirstObjectInArea(GetArea(OBJECT_SELF));
    int nAdds = 0;
    while (GetIsObjectValid(oObject))
    {
        if (GetTag(oObject) == "dun_add_forgua") nAdds++;
        oObject = GetNextObjectInArea(GetArea(OBJECT_SELF));
    }

    //Summon an add if appropriate
    if (nCombatRounds % 5 == 0 && nAdds <= 1+nPlayers)
    {
        int nLevel = GetHitDice(OBJECT_SELF);
        effect eVis = EffectVisualEffect(460);
        object oCreature = CreateObject(OBJECT_TYPE_CREATURE, "dun_add_forgua", GetLocation(OBJECT_SELF));
        ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, eVis, GetLocation(oCreature));
        LevelHenchmanUpTo(oCreature, nLevel, CLASS_TYPE_INVALID, 0, GetCreatureStartingPackage(oCreature), PACKAGE_INVALID);
        DelayCommand(0.5, ForceRest(oCreature));
        effect eCreatureBonus;

        if (nLevel >= 38 && nLevel <= 40) //levels 38-40 (encounters consisting of two minor enemies)
        {
            eCreatureBonus = EffectACIncrease(14, AC_ARMOUR_ENCHANTMENT_BONUS);
            eCreatureBonus = EffectLinkEffects(EffectAttackIncrease(10), eCreatureBonus);
            eCreatureBonus = EffectLinkEffects(EffectDamageIncrease(7, DAMAGE_TYPE_SLASHING), eCreatureBonus);
            eCreatureBonus = SupernaturalEffect(eCreatureBonus);
            ApplyEffectToObject(DURATION_TYPE_PERMANENT, eCreatureBonus, oCreature);
        }
        else if (nLevel >= 34 && nLevel <= 37) //levels 34-37 (encounters consisting of two minor enemies)
        {
            eCreatureBonus = EffectACIncrease(12, AC_ARMOUR_ENCHANTMENT_BONUS);
            eCreatureBonus = EffectLinkEffects(EffectAttackIncrease(8), eCreatureBonus);
            eCreatureBonus = EffectLinkEffects(EffectDamageIncrease(5, DAMAGE_TYPE_SLASHING), eCreatureBonus);
            eCreatureBonus = SupernaturalEffect(eCreatureBonus);
            ApplyEffectToObject(DURATION_TYPE_PERMANENT, eCreatureBonus, oCreature);
        }
        else if (nLevel >= 31 && nLevel <= 33) //levels 31-33 (encounters consisting of two minor enemies)
        {
            eCreatureBonus = EffectACIncrease(11, AC_ARMOUR_ENCHANTMENT_BONUS);
            eCreatureBonus = EffectLinkEffects(EffectAttackIncrease(6), eCreatureBonus);
            eCreatureBonus = EffectLinkEffects(EffectDamageIncrease(4, DAMAGE_TYPE_SLASHING), eCreatureBonus);
            eCreatureBonus = SupernaturalEffect(eCreatureBonus);
            ApplyEffectToObject(DURATION_TYPE_PERMANENT, eCreatureBonus, oCreature);
        }
        else if (nLevel >= 27 && nLevel <= 30) //levels 27-30 (encounters consisting of two minor enemies)
        {
            eCreatureBonus = EffectACIncrease(10, AC_ARMOUR_ENCHANTMENT_BONUS);
            eCreatureBonus = EffectLinkEffects(EffectAttackIncrease(5), eCreatureBonus);
            eCreatureBonus = EffectLinkEffects(EffectDamageIncrease(2, DAMAGE_TYPE_SLASHING), eCreatureBonus);
            eCreatureBonus = SupernaturalEffect(eCreatureBonus);
            ApplyEffectToObject(DURATION_TYPE_PERMANENT, eCreatureBonus, oCreature);
        }
        else if (nLevel >= 25 && nLevel <= 26) //levels 25-26 (encounters consisting of two minor enemies)
        {
            eCreatureBonus = EffectACIncrease(9, AC_ARMOUR_ENCHANTMENT_BONUS);
            eCreatureBonus = EffectLinkEffects(EffectAttackIncrease(3), eCreatureBonus);
            eCreatureBonus = EffectLinkEffects(EffectDamageIncrease(2, DAMAGE_TYPE_SLASHING), eCreatureBonus);
            eCreatureBonus = SupernaturalEffect(eCreatureBonus);
            ApplyEffectToObject(DURATION_TYPE_PERMANENT, eCreatureBonus, oCreature);
        }
        else
        {
            eCreatureBonus = EffectACIncrease(7, AC_ARMOUR_ENCHANTMENT_BONUS);
            eCreatureBonus = EffectLinkEffects(EffectAttackIncrease(3), eCreatureBonus);
            eCreatureBonus = SupernaturalEffect(eCreatureBonus);
            ApplyEffectToObject(DURATION_TYPE_PERMANENT, eCreatureBonus, oCreature);
        }
    }

    //Give spell scrolls if the creature doesn't have any
    if (GetItemPossessedBy(OBJECT_SELF, "X1_IT_SPARSCR603") == OBJECT_INVALID && GetItemPossessedBy(OBJECT_SELF, "NW_IT_SPARSCR906") == OBJECT_INVALID)
    {
        CreateItemOnObject("X1_IT_SPARSCR603", OBJECT_SELF);
        CreateItemOnObject("NW_IT_SPARSCR906", OBJECT_SELF);
    }

    if(GetLocalInt(OBJECT_SELF, "X4_VANILLA_AI") == TRUE) ExecuteScript("nw_c2_default3_v", OBJECT_SELF);
    else ExecuteScript("nw_c2_default3", OBJECT_SELF);
}
