//::///////////////////////////////////////////////
//:: Name x2_def_endcombat
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Default Combat Round End script
*/
//:://////////////////////////////////////////////
//:: Created By: Keith Warner
//:: Created On: June 11/03
//:://////////////////////////////////////////////

void main()
{
    int nCombatRounds = GetLocalInt(OBJECT_SELF, "CombatRounds");
    nCombatRounds++;
    SetLocalInt(OBJECT_SELF, "CombatRounds", nCombatRounds);

    //Hurt all creatures in proximity every combat round: 1%, 2%, 4%, 8%, 16%, 20%
    {
        int nDamage;
        switch (nCombatRounds)
        {
            case 1: nDamage = 1; break;
            case 2: nDamage = 2; break;
            case 3: nDamage = 4; break;
            case 4: nDamage = 8; break;
            case 5: nDamage = 16; break;
            default: nDamage = 20; break;
        }

        object oCreature = GetFirstObjectInShape(SHAPE_SPHERE, 15.0, GetLocation(OBJECT_SELF));
        int nMaxHP = GetMaxHitPoints(oCreature);
        while (GetIsObjectValid(oCreature))
        {
            if (oCreature != OBJECT_SELF) ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectDamage(nDamage*nMaxHP/100, DAMAGE_TYPE_POSITIVE), oCreature);
            oCreature = GetNextObjectInShape(SHAPE_SPHERE, 15.0, GetLocation(OBJECT_SELF));
        }
    }


    if(GetLocalInt(OBJECT_SELF, "X4_VANILLA_AI") == TRUE) ExecuteScript("nw_c2_default3_v", OBJECT_SELF);
    else ExecuteScript("nw_c2_default3", OBJECT_SELF);
}
