void main()
{
    object oPC = GetPCSpeaker();
    object oModule = GetModule();

    string sDatabase = GetLocalString(oModule, "DB");
    string sHouseName = GetLocalString(oPC, "HouseToSell");
    int nPrice = GetLocalInt(oPC, "HouseToSell_p");

    //Prepare the name of the variable that stores ownership
    string sHouseOwnership = "H_"+sHouseName+"_OWNER";

    //Do the transaction between the agency and the player
    DeleteCampaignVariable(sDatabase, sHouseOwnership);
    GiveGoldToCreature(oPC, nPrice);

    //Identify the area with the estate in question
    string sWaypointName = "WP_AREA_"+sHouseName;
    object oAreaWP = GetWaypointByTag(sWaypointName);
    object oEstate = GetArea(oAreaWP);

    //Kick out all players that might still be present in the sold estate
    object oTarget = GetWaypointByTag("WP_AREA_"+sHouseName+"_OUT");
    object oVisitor = GetFirstPC();
    object oHench;
    int nHench;
    while (GetIsObjectValid(oVisitor) == TRUE)
        {
            if(GetArea(oVisitor)==oEstate)
            {
             // Teleport the PC.
            AssignCommand(oVisitor, ClearAllActions());
            AssignCommand(oVisitor, JumpToObject(oTarget));

            // Also teleport associates.
            oHench = GetAssociate(ASSOCIATE_TYPE_ANIMALCOMPANION, oVisitor);
            AssignCommand(oHench, ClearAllActions());
            AssignCommand(oHench, JumpToObject(oTarget));
            oHench = GetAssociate(ASSOCIATE_TYPE_DOMINATED, oVisitor);
            AssignCommand(oHench, ClearAllActions());
            AssignCommand(oHench, JumpToObject(oTarget));
            oHench = GetAssociate(ASSOCIATE_TYPE_FAMILIAR, oVisitor);
            AssignCommand(oHench, ClearAllActions());
            AssignCommand(oHench, JumpToObject(oTarget));
            oHench = GetAssociate(ASSOCIATE_TYPE_SUMMONED, oVisitor);
            AssignCommand(oHench, ClearAllActions());
            AssignCommand(oHench, JumpToObject(oTarget));

            // Support for multiple henchmen (includes horses).
            nHench = 1;
            oHench = GetHenchman(oVisitor, 1);
            while ( oHench != OBJECT_INVALID )
                {
                AssignCommand(oHench, ClearAllActions());
                AssignCommand(oHench, JumpToObject(oTarget));
                // Next henchman.
                oHench = GetHenchman(oVisitor, ++nHench);
                }
            }
            oVisitor = GetNextPC();
        }

    //Clear the list of the authorized people of the estate
    DeleteCampaignVariable(sDatabase, "H_"+sHouseName+"_AUTH_1");
    DeleteCampaignVariable(sDatabase, "H_"+sHouseName+"_AUTH_2");
    DeleteCampaignVariable(sDatabase, "H_"+sHouseName+"_AUTH_3");
    DeleteCampaignVariable(sDatabase, "H_"+sHouseName+"_AUTH_4");
    DeleteCampaignVariable(sDatabase, "H_"+sHouseName+"_AUTH_5");
    DeleteCampaignVariable(sDatabase, "H_"+sHouseName+"_AUTH_6");
    DeleteCampaignVariable(sDatabase, "H_"+sHouseName+"_AUTH_7");
    DeleteCampaignVariable(sDatabase, "H_"+sHouseName+"_AUTH_8");
    DeleteCampaignVariable(sDatabase, "H_"+sHouseName+"_AUTH_9");
    DeleteCampaignVariable(sDatabase, "H_"+sHouseName+"_AUTH_10");

    //In ONLINE mode, delete the stored date
    if (GetLocalString(oModule, "MODE") == "ONLINE")
    DeleteCampaignVariable(sDatabase, "TIME_"+sHouseName);
}
