#include "x0_i0_henchman"
#include "global_inc"
void main()
{
    //First we need to check if there are fewer than 5 defenders and 5 invaders in town (can be changed, but the town area needs more WPs then)
    object oObject = GetFirstObjectInArea(OBJECT_SELF);
    int nDefenders;
    int nInvaders;
    int nMax = 5;
    while (GetIsObjectValid(oObject))
    {
        if (GetLocalInt(oObject, "Defender") == TRUE && !GetIsDead(oObject)) nDefenders++;
        if (GetLocalInt(oObject, "Invader") == TRUE && !GetIsDead(oObject)) nInvaders++;
        oObject = GetNextObjectInArea(OBJECT_SELF);
    }
    if (nDefenders >= nMax && nInvaders >= nMax) return; //nothing else to do


    //If all defenders have been killed, don't spawn more, else do spawn one; same with invaders
    string sTown = GetLocalString(OBJECT_SELF, "Town");
    string sDB = GetLocalString(GetModule(), "DB");
    int nMaxDef = 30;
    int nMaxInv = 30;
    int nDefKilled = GetCampaignInt(sDB, sTown+"_INV_DEF");
    int nInvKilled = GetCampaignInt(sDB, sTown+"_INV_NUM");
    string sInvader = GetCampaignString(sDB, sTown+"_INV_MON");
    int nLevel = GetCampaignInt(sDB, sTown+"_INV_LVL");
    string sDefender = "def_"+sTown;

    if (sInvader == "") return;

    int nSpawn;
    string sSpawnWP;
    object oNPC;
    string sType;
    int nBonus;
    effect eBonus;

    //if there are any remnants, do nothing - once there are none, delete invasion
    if (nInvKilled >= nMaxInv)
    {
        oObject = GetFirstObjectInArea(OBJECT_SELF);
        int nRemnants = FALSE;
        while (GetIsObjectValid(oObject))
        {
            if (GetLocalInt(oObject, "Invader") == TRUE && !GetIsDead(oObject))
            {
                nRemnants = TRUE;
                break;
            }
            oObject = GetNextObjectInArea(OBJECT_SELF);
        }
        if (nRemnants == FALSE)
        {
            DeleteInvasion(sTown);
            oObject = GetFirstObjectInArea(OBJECT_SELF);
            while (GetIsObjectValid(oObject))
            {
                if (GetIsPC(oObject) == TRUE)
                {
                    SendMessageToPC(oObject, "Victory!");
                }
                oObject = GetNextObjectInArea(OBJECT_SELF);
            }
        }
    }

    //Prepare bonuses
    if (nLevel == 40) nBonus = 4;
    else if (nLevel >= 30) nBonus = 3;
    else if (nLevel >= 20) nBonus = 2;
    else if (nLevel >= 10) nBonus = 1;
    if (nLevel >= 10)
    {
        eBonus = EffectAttackIncrease(nBonus);
        eBonus = EffectLinkEffects(eBonus, EffectACIncrease(nBonus));
        eBonus = SupernaturalEffect(eBonus);
        ApplyEffectToObject(DURATION_TYPE_PERMANENT, eBonus, oNPC);
    }

    //Defenders
    if (nDefKilled < nMaxDef && nDefenders < nMax)
    {
        nSpawn = Random(nMax)+1; //let's randomly select a spawn point number
        sSpawnWP = sTown+"_DEF_"+IntToString(nSpawn);
        oNPC = CreateObject(OBJECT_TYPE_CREATURE, sDefender, GetLocation(GetWaypointByTag(sSpawnWP)));
        if (nLevel >= 10) ApplyEffectToObject(DURATION_TYPE_PERMANENT, eBonus, oNPC);
        SetLocalInt(oNPC, "Defender", TRUE);
        LevelHenchmanUpTo(oNPC, nLevel, CLASS_TYPE_INVALID, 0, GetCreatureStartingPackage(oNPC), PACKAGE_INVALID);
        int i;
        for (i=1; i>0; i++) //let's go and find us some enemy to fight!
        {
            oObject = GetNearestCreature(CREATURE_TYPE_IS_ALIVE, TRUE, oNPC, i);
            if (GetIsObjectValid(oObject) == FALSE) break;
            if (GetIsEnemy(oObject, oNPC) == TRUE)
            {
                AssignCommand(oNPC, ClearAllActions());
                AssignCommand(oNPC, ActionMoveToObject(oObject));
                AssignCommand(oNPC, ActionAttack(oObject));
                break;
            }
        }
    }

    //Invaders
    if (nInvKilled < nMaxInv && nInvaders < nMax)
    {
        if (sInvader == "dem" || sInvader == "gia") sType = "1"; //some monsters have only one type, others have two
        else sType = IntToString(Random(2)+1);
        nSpawn = Random(nMax)+1; //let's randomly select a spawn point number
        sSpawnWP = sTown+"_INV_"+IntToString(nSpawn);
        oNPC = CreateObject(OBJECT_TYPE_CREATURE, "inv_mon_"+sInvader+"_"+sType, GetLocation(GetWaypointByTag(sSpawnWP)));
        if (nLevel >= 10) ApplyEffectToObject(DURATION_TYPE_PERMANENT, eBonus, oNPC);
        SetLocalInt(oNPC, "Invader", TRUE);
        LevelHenchmanUpTo(oNPC, nLevel, CLASS_TYPE_INVALID, 0, GetCreatureStartingPackage(oNPC), PACKAGE_INVALID);
        int i;
        for (i=1; i>0; i++) //let's go and find us some enemy to fight!
        {
            oObject = GetNearestCreature(CREATURE_TYPE_IS_ALIVE, TRUE, oNPC, i);
            if (GetIsObjectValid(oObject) == FALSE) break;
            if (GetIsEnemy(oObject, oNPC) == TRUE)
            {
                AssignCommand(oNPC, ClearAllActions());
                AssignCommand(oNPC, ActionMoveToObject(oObject));
                AssignCommand(oNPC, ActionAttack(oObject));
                break;
            }
        }
    }
}
