//::///////////////////////////////////////////////
//:: Default: End of Combat Round
//:: NW_C2_DEFAULT3
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Calls the end of combat script every round
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Oct 16, 2001
//:://////////////////////////////////////////////

#include "hench_i0_ai"
#include "prc_inc_racial"

void main()
{
//    Jug_Debug("*****" + GetName(OBJECT_SELF) + " end combat round action " + IntToString(GetCurrentAction()));

    if (!GetLocalInt(GetModule(),"X3_NO_MOUNTED_COMBAT_FEAT"))
    { // set variables on target for mounted combat
        DeleteLocalInt(OBJECT_SELF,"bX3_LAST_ATTACK_PHYSICAL");
        DeleteLocalInt(OBJECT_SELF,"nX3_HP_BEFORE");
        DeleteLocalInt(OBJECT_SELF,"bX3_ALREADY_MOUNTED_COMBAT");
        if (GetHasFeat(FEAT_MOUNTED_COMBAT,OBJECT_SELF))
        { // check for AC increase
            int nRoll=d20()+GetSkillRank(SKILL_RIDE);
            nRoll=nRoll-10;
            if (nRoll>4)
            { // ac increase
                nRoll=nRoll/5;
                ApplyEffectToObject(DURATION_TYPE_TEMPORARY,EffectACIncrease(nRoll),OBJECT_SELF,8.5);
            } // ac increase
        } // check for AC increase
    } // set variables on target for mounted combat

    DeleteLocalInt(OBJECT_SELF, HENCH_AI_SCRIPT_RUN_STATE);

    //Getting friendly NPCs and determining which needs healing the most, as well as how many friendly NPCs need healing
    object oCreature;
    int nInjuredCount;
    int nLowestHP = 100;
    object oMostInjured;
    oCreature = GetFirstObjectInShape(SHAPE_SPHERE, 10.0, GetLocation(OBJECT_SELF), TRUE, OBJECT_TYPE_CREATURE);
    while (GetIsObjectValid(oCreature))
        {
            if (GetIsFriend(oCreature) && !GetIsDead(oCreature) && GetPercentageHPLoss(oCreature) < 50)
                {
                     if (GetPercentageHPLoss(oCreature) < nLowestHP)
                        {
                            nLowestHP = GetPercentageHPLoss(oCreature);
                            oMostInjured = oCreature;
                        }
                     nInjuredCount++;
                }
            oCreature = GetNextObjectInShape(SHAPE_SPHERE, 30.0, GetLocation(OBJECT_SELF), TRUE, OBJECT_TYPE_CREATURE);
        }
    //Done

    if(GetBehaviorState(NW_FLAG_BEHAVIOR_SPECIAL))
    {
        HenchDetermineSpecialBehavior();
    }
    else if(!GetSpawnInCondition(NW_FLAG_SET_WARNINGS))
    {
        if (GetLocalInt(OBJECT_SELF, "X4_HEALER") == TRUE && GetPercentageHPLoss(OBJECT_SELF) < 50)
            {
                if (nInjuredCount >= 2)
                    {
                        if (GetHasSpell(SPELL_MASS_HEAL, OBJECT_SELF) && MyPRCGetRacialType(OBJECT_SELF) != RACIAL_TYPE_UNDEAD) ActionCastSpellAtObject(SPELL_MASS_HEAL, OBJECT_SELF);
                        else if (GetHasSpell(SPELL_HEALING_CIRCLE, OBJECT_SELF) && MyPRCGetRacialType(OBJECT_SELF) != RACIAL_TYPE_UNDEAD) ActionCastSpellAtObject(SPELL_HEALING_CIRCLE, OBJECT_SELF);
                        else if (GetHasSpell(SPELL_CIRCLE_OF_DOOM, OBJECT_SELF) && MyPRCGetRacialType(OBJECT_SELF) == RACIAL_TYPE_UNDEAD && nInjuredCount >= 3) ActionCastSpellAtObject(SPELL_CIRCLE_OF_DOOM, OBJECT_SELF);
                        else TalentHeal();
                    }
                else if (TalentHeal() == FALSE) HenchDetermineCombatRound();
            }
        else if (GetLocalInt(OBJECT_SELF, "X4_HEALER") == TRUE && GetIsObjectValid(oMostInjured) == TRUE)
            {
                if (nInjuredCount >= 2)
                    {
                        if (GetHasSpell(SPELL_MASS_HEAL, OBJECT_SELF) && MyPRCGetRacialType(oMostInjured) != RACIAL_TYPE_UNDEAD) ActionCastSpellAtObject(SPELL_MASS_HEAL, oMostInjured);
                        else if (GetHasSpell(SPELL_HEALING_CIRCLE, OBJECT_SELF) && MyPRCGetRacialType(oMostInjured) != RACIAL_TYPE_UNDEAD) ActionCastSpellAtObject(SPELL_HEALING_CIRCLE, oMostInjured);
                        else if (GetHasSpell(SPELL_CIRCLE_OF_DOOM, OBJECT_SELF) && MyPRCGetRacialType(oMostInjured) == RACIAL_TYPE_UNDEAD && nInjuredCount >= 3) ActionCastSpellAtObject(SPELL_CIRCLE_OF_DOOM, oMostInjured);
                        else TalentHeal(FALSE, oMostInjured);
                    }
                else if (TalentHeal(FALSE, oMostInjured) == FALSE) HenchDetermineCombatRound();
            }
        else if (GetLocalInt(OBJECT_SELF, "X4_HEALER") == TRUE)
            {
                if (TalentCureCondition() == FALSE) HenchDetermineCombatRound();
            }
        else HenchDetermineCombatRound();
    }
    // special code for host tower level 4
    if(GetSpawnInCondition(NW_FLAG_END_COMBAT_ROUND_EVENT) && GetTag(OBJECT_SELF) != "2Q6_HelmHorror")
    {
        SignalEvent(OBJECT_SELF, EventUserDefined(EVENT_END_COMBAT_ROUND));
    }
	
	ExecuteScript("prc_npc_combat", OBJECT_SELF);
}


