//Roulette modified by Stephen Spann  (sspann@worldnet.att.net)
//originally from Charles Adam's 'Casino Bertix' module
//now includes the 00 slot, Five-Number bets, Corner Bets, and Split Bets.
//and uses SetListenPattern() cues instead of a conversation.
//::///////////////////////////////////////////////
//:: Default: On Spawn In
//:: NW_C2_DEFAULT9
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Determines the course of action to be taken
    after having just been spawned in
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Oct 25, 2001
//:://////////////////////////////////////////////
#include "NW_O2_CONINCLUDE"
#include "NW_I0_GENERIC"
#include "roulette_include"

void main()
{
// OPTIONAL BEHAVIORS (Comment In or Out to Activate ) ****************************************************************************
     //SetSpawnInCondition(NW_FLAG_SPECIAL_CONVERSATION);
     //SetSpawnInCondition(NW_FLAG_SPECIAL_COMBAT_CONVERSATION);
                // This causes the creature to say a special greeting in their conversation file
                // upon Perceiving the player. Attach the [NW_D2_GenCheck.nss] script to the desired
                // greeting in order to designate it. As the creature is actually saying this to
                // himself, don't attach any player responses to the greeting.

     //SetSpawnInCondition(NW_FLAG_SHOUT_ATTACK_MY_TARGET);
                // This will set the listening pattern on the NPC to attack when allies call
     //SetSpawnInCondition(NW_FLAG_STEALTH);
                // If the NPC has stealth and they are a rogue go into stealth mode
     //SetSpawnInCondition(NW_FLAG_SEARCH);
                // If the NPC has Search go into Search Mode
     //SetSpawnInCondition(NW_FLAG_SET_WARNINGS);
                // This will set the NPC to give a warning to non-enemies before attacking

     //SetSpawnInCondition(NW_FLAG_SLEEP);
                //Creatures that spawn in during the night will be asleep.
     //SetSpawnInCondition(NW_FLAG_DAY_NIGHT_POSTING);
     //SetSpawnInCondition(NW_FLAG_APPEAR_SPAWN_IN_ANIMATION);
     //SetSpawnInCondition(NW_FLAG_IMMOBILE_AMBIENT_ANIMATIONS);
     //SetSpawnInCondition(NW_FLAG_AMBIENT_ANIMATIONS);
                //This will play Ambient Animations until the NPC sees an enemy or is cleared.
                //NOTE that these animations will play automatically for Encounter Creatures.

    // NOTE: ONLY ONE OF THE FOLOOWING ESCAPE COMMANDS SHOULD EVER BE ACTIVATED AT ANY ONE TIME.
    //SetSpawnInCondition(NW_FLAG_ESCAPE_RETURN);    // OPTIONAL BEHAVIOR (Flee to a way point and return a short time later.)
    //SetSpawnInCondition(NW_FLAG_ESCAPE_LEAVE);     // OPTIONAL BEHAVIOR (Flee to a way point and do not return.)
    //SetSpawnInCondition(NW_FLAG_TELEPORT_LEAVE);   // OPTIONAL BEHAVIOR (Teleport to safety and do not return.)
    //SetSpawnInCondition(NW_FLAG_TELEPORT_RETURN);  // OPTIONAL BEHAVIOR (Teleport to safety and return a short time later.)

// CUSTOM USER DEFINED EVENTS
/*
    The following settings will allow the user to fire one of the blank user defined events in the NW_D2_DefaultD.  Like the
    On Spawn In script this script is meant to be customized by the end user to allow for unique behaviors.  The user defined
    events user 1000 - 1010
*/
    //SetSpawnInCondition(NW_FLAG_HEARTBEAT_EVENT);        //OPTIONAL BEHAVIOR - Fire User Defined Event 1001
    //SetSpawnInCondition(NW_FLAG_PERCIEVE_EVENT);         //OPTIONAL BEHAVIOR - Fire User Defined Event 1002
    //SetSpawnInCondition(NW_FLAG_ATTACK_EVENT);           //OPTIONAL BEHAVIOR - Fire User Defined Event 1005
    //SetSpawnInCondition(NW_FLAG_DAMAGED_EVENT);          //OPTIONAL BEHAVIOR - Fire User Defined Event 1006
    //SetSpawnInCondition(NW_FLAG_DISTURBED_EVENT);        //OPTIONAL BEHAVIOR - Fire User Defined Event 1008
    //SetSpawnInCondition(NW_FLAG_END_COMBAT_ROUND_EVENT); //OPTIONAL BEHAVIOR - Fire User Defined Event 1003
    SetSpawnInCondition(NW_FLAG_ON_DIALOGUE_EVENT);      //OPTIONAL BEHAVIOR - Fire User Defined Event 1004
    //SetSpawnInCondition(NW_FLAG_DEATH_EVENT);            //OPTIONAL BEHAVIOR - Fire User Defined Event 1007

// DEFAULT GENERIC BEHAVIOR (DO NOT TOUCH) *****************************************************************************************
    SetListeningPatterns();    // Goes through and sets up which shouts the NPC will listen to.
    WalkWayPoints();           // Optional Parameter: void WalkWayPoints(int nRun = FALSE, float fPause = 1.0)
                               // 1. Looks to see if any Way Points in the module have the tag "WP_" + NPC TAG + "_0X", if so walk them
                               // 2. If the tag of the Way Point is "POST_" + NPC TAG the creature will return this way point after
                               //    combat.
    //GenerateNPCTreasure();     //* Use this to create a small amount of treasure on the creature
    SetListening(OBJECT_SELF, TRUE);
if (nBet1)
    {
    SetListenPattern(OBJECT_SELF, "1 Five", 1001);
    SetListenPattern(OBJECT_SELF, "1 Red", 1002);
    SetListenPattern(OBJECT_SELF, "1 Black", 1003);
    SetListenPattern(OBJECT_SELF, "1 Odd", 1004);
    SetListenPattern(OBJECT_SELF, "1 Even", 1005);
    SetListenPattern(OBJECT_SELF, "1 High", 1006);
    SetListenPattern(OBJECT_SELF, "1 Low", 1007);
    SetListenPattern(OBJECT_SELF, "1 Column 1", 1008);
    SetListenPattern(OBJECT_SELF, "1 Column 2", 1009);
    SetListenPattern(OBJECT_SELF, "1 Column 3", 1010);
    SetListenPattern(OBJECT_SELF, "1 Dozen 1", 1011);
    SetListenPattern(OBJECT_SELF, "1 Dozen 2", 1012);
    SetListenPattern(OBJECT_SELF, "1 Dozen 3", 1013);
    SetListenPattern(OBJECT_SELF, "1 Line 1-6", 1014);
    SetListenPattern(OBJECT_SELF, "1 Line 4-9", 1015);
    SetListenPattern(OBJECT_SELF, "1 Line 7-12", 1016);
    SetListenPattern(OBJECT_SELF, "1 Line 10-15", 1017);
    SetListenPattern(OBJECT_SELF, "1 Line 13-18", 1018);
    SetListenPattern(OBJECT_SELF, "1 Line 16-21", 10019);
    SetListenPattern(OBJECT_SELF, "1 Line 19-24", 1020);
    SetListenPattern(OBJECT_SELF, "1 Line 22-27", 1021);
    SetListenPattern(OBJECT_SELF, "1 Line 25-30", 1022);
    SetListenPattern(OBJECT_SELF, "1 Line 28-33", 1023);
    SetListenPattern(OBJECT_SELF, "1 Line 31-36", 1024);
    SetListenPattern(OBJECT_SELF, "1 Street 1-3", 1025);
    SetListenPattern(OBJECT_SELF, "1 Street 4-6", 1026);
    SetListenPattern(OBJECT_SELF, "1 Street 7-9", 1027);
    SetListenPattern(OBJECT_SELF, "1 Street 10-12", 1028);
    SetListenPattern(OBJECT_SELF, "1 Street 13-15", 1029);
    SetListenPattern(OBJECT_SELF, "1 Street 16-18", 1030);
    SetListenPattern(OBJECT_SELF, "1 Street 19-21", 1031);
    SetListenPattern(OBJECT_SELF, "1 Street 22-24", 1032);
    SetListenPattern(OBJECT_SELF, "1 Street 25-27", 1033);
    SetListenPattern(OBJECT_SELF, "1 Street 28-30", 1034);
    SetListenPattern(OBJECT_SELF, "1 Street 31-33", 1035);
    SetListenPattern(OBJECT_SELF, "1 Street 34-36", 1036);
    SetListenPattern(OBJECT_SELF, "1 Corner 1-5", 1037);
    SetListenPattern(OBJECT_SELF, "1 Corner 2-6", 1038);
    SetListenPattern(OBJECT_SELF, "1 Corner 4-8", 1039);
    SetListenPattern(OBJECT_SELF, "1 Corner 5-9", 1040);
    SetListenPattern(OBJECT_SELF, "1 Corner 7-11", 1041);
    SetListenPattern(OBJECT_SELF, "1 Corner 8-12", 1042);
    SetListenPattern(OBJECT_SELF, "1 Corner 10-14", 1043);
    SetListenPattern(OBJECT_SELF, "1 Corner 11-15", 1044);
    SetListenPattern(OBJECT_SELF, "1 Corner 13-17", 1045);
    SetListenPattern(OBJECT_SELF, "1 Corner 14-18", 1046);
    SetListenPattern(OBJECT_SELF, "1 Corner 16-20", 1047);
    SetListenPattern(OBJECT_SELF, "1 Corner 17-21", 1048);
    SetListenPattern(OBJECT_SELF, "1 Corner 19-23", 1049);
    SetListenPattern(OBJECT_SELF, "1 Corner 20-24", 1050);
    SetListenPattern(OBJECT_SELF, "1 Corner 22-26", 1051);
    SetListenPattern(OBJECT_SELF, "1 Corner 23-27", 1052);
    SetListenPattern(OBJECT_SELF, "1 Corner 25-29", 1053);
    SetListenPattern(OBJECT_SELF, "1 Corner 26-30", 1054);
    SetListenPattern(OBJECT_SELF, "1 Corner 28-32", 1055);
    SetListenPattern(OBJECT_SELF, "1 Corner 29-33", 1056);
    SetListenPattern(OBJECT_SELF, "1 Corner 31-35", 1057);
    SetListenPattern(OBJECT_SELF, "1 Corner 32-36", 1058);
    SetListenPattern(OBJECT_SELF, "1 Number 0", 1059);
    SetListenPattern(OBJECT_SELF, "1 Number 00", 1060);
    SetListenPattern(OBJECT_SELF, "1 Number 1", 1061);
    SetListenPattern(OBJECT_SELF, "1 Number 2", 1062);
    SetListenPattern(OBJECT_SELF, "1 Number 3", 1063);
    SetListenPattern(OBJECT_SELF, "1 Number 4", 1064);
    SetListenPattern(OBJECT_SELF, "1 Number 5", 1065);
    SetListenPattern(OBJECT_SELF, "1 Number 6", 1066);
    SetListenPattern(OBJECT_SELF, "1 Number 7", 1067);
    SetListenPattern(OBJECT_SELF, "1 Number 8", 1068);
    SetListenPattern(OBJECT_SELF, "1 Number 9", 1069);
    SetListenPattern(OBJECT_SELF, "1 Number 10", 1070);
    SetListenPattern(OBJECT_SELF, "1 Number 11", 1071);
    SetListenPattern(OBJECT_SELF, "1 Number 12", 1072);
    SetListenPattern(OBJECT_SELF, "1 Number 13", 1073);
    SetListenPattern(OBJECT_SELF, "1 Number 14", 1074);
    SetListenPattern(OBJECT_SELF, "1 Number 15", 1075);
    SetListenPattern(OBJECT_SELF, "1 Number 16", 1076);
    SetListenPattern(OBJECT_SELF, "1 Number 17", 1077);
    SetListenPattern(OBJECT_SELF, "1 Number 18", 1078);
    SetListenPattern(OBJECT_SELF, "1 Number 19", 1079);
    SetListenPattern(OBJECT_SELF, "1 Number 20", 1080);
    SetListenPattern(OBJECT_SELF, "1 Number 21", 1081);
    SetListenPattern(OBJECT_SELF, "1 Number 22", 1082);
    SetListenPattern(OBJECT_SELF, "1 Number 23", 1083);
    SetListenPattern(OBJECT_SELF, "1 Number 24", 1084);
    SetListenPattern(OBJECT_SELF, "1 Number 25", 1085);
    SetListenPattern(OBJECT_SELF, "1 Number 26", 1086);
    SetListenPattern(OBJECT_SELF, "1 Number 27", 1087);
    SetListenPattern(OBJECT_SELF, "1 Number 28", 1088);
    SetListenPattern(OBJECT_SELF, "1 Number 29", 1089);
    SetListenPattern(OBJECT_SELF, "1 Number 30", 1090);
    SetListenPattern(OBJECT_SELF, "1 Number 31", 1091);
    SetListenPattern(OBJECT_SELF, "1 Number 32", 1092);
    SetListenPattern(OBJECT_SELF, "1 Number 33", 1093);
    SetListenPattern(OBJECT_SELF, "1 Number 34", 1094);
    SetListenPattern(OBJECT_SELF, "1 Number 35", 1095);
    SetListenPattern(OBJECT_SELF, "1 Number 36", 1096);
    SetListenPattern(OBJECT_SELF, "1 Split 0 00", 1097);
    SetListenPattern(OBJECT_SELF, "1 Split 0 1", 1098);
    SetListenPattern(OBJECT_SELF, "1 Split 0 2", 1099);
    SetListenPattern(OBJECT_SELF, "1 Split 00 2", 1100);
    SetListenPattern(OBJECT_SELF, "1 Split 00 3", 1101);
    SetListenPattern(OBJECT_SELF, "1 Split 1 2", 1102);
    SetListenPattern(OBJECT_SELF, "1 Split 1 4", 1103);
    SetListenPattern(OBJECT_SELF, "1 Split 2 3", 1104);
    SetListenPattern(OBJECT_SELF, "1 Split 2 5", 1105);
    SetListenPattern(OBJECT_SELF, "1 Split 3 6", 1106);
    SetListenPattern(OBJECT_SELF, "1 Split 4 5", 1107);
    SetListenPattern(OBJECT_SELF, "1 Split 4 7", 1108);
    SetListenPattern(OBJECT_SELF, "1 Split 5 6", 1109);
    SetListenPattern(OBJECT_SELF, "1 Split 5 8", 1110);
    SetListenPattern(OBJECT_SELF, "1 Split 6 9", 1111);
    SetListenPattern(OBJECT_SELF, "1 Split 7 8", 1112);
    SetListenPattern(OBJECT_SELF, "1 Split 7 10", 1113);
    SetListenPattern(OBJECT_SELF, "1 Split 8 9", 1114);
    SetListenPattern(OBJECT_SELF, "1 Split 8 11", 1115);
    SetListenPattern(OBJECT_SELF, "1 Split 9 12", 1116);
    SetListenPattern(OBJECT_SELF, "1 Split 10 11", 1117);
    SetListenPattern(OBJECT_SELF, "1 Split 10 13", 1118);
    SetListenPattern(OBJECT_SELF, "1 Split 11 12", 1119);
    SetListenPattern(OBJECT_SELF, "1 Split 11 14", 1120);
    SetListenPattern(OBJECT_SELF, "1 Split 12 15", 1121);
    SetListenPattern(OBJECT_SELF, "1 Split 13 14", 1122);
    SetListenPattern(OBJECT_SELF, "1 Split 13 16", 1123);
    SetListenPattern(OBJECT_SELF, "1 Split 14 15", 1124);
    SetListenPattern(OBJECT_SELF, "1 Split 14 17", 1125);
    SetListenPattern(OBJECT_SELF, "1 Split 15 18", 1126);
    SetListenPattern(OBJECT_SELF, "1 Split 16 17", 1127);
    SetListenPattern(OBJECT_SELF, "1 Split 16 19", 1128);
    SetListenPattern(OBJECT_SELF, "1 Split 17 18", 1129);
    SetListenPattern(OBJECT_SELF, "1 Split 17 20", 1130);
    SetListenPattern(OBJECT_SELF, "1 Split 18 21", 1131);
    SetListenPattern(OBJECT_SELF, "1 Split 19 20", 1132);
    SetListenPattern(OBJECT_SELF, "1 Split 19 22", 1133);
    SetListenPattern(OBJECT_SELF, "1 Split 20 21", 1134);
    SetListenPattern(OBJECT_SELF, "1 Split 20 23", 1135);
    SetListenPattern(OBJECT_SELF, "1 Split 21 24", 1136);
    SetListenPattern(OBJECT_SELF, "1 Split 22 23", 1137);
    SetListenPattern(OBJECT_SELF, "1 Split 22 25", 1138);
    SetListenPattern(OBJECT_SELF, "1 Split 23 24", 1139);
    SetListenPattern(OBJECT_SELF, "1 Split 23 26", 1140);
    SetListenPattern(OBJECT_SELF, "1 Split 24 27", 1141);
    SetListenPattern(OBJECT_SELF, "1 Split 25 26", 1142);
    SetListenPattern(OBJECT_SELF, "1 Split 25 28", 1143);
    SetListenPattern(OBJECT_SELF, "1 Split 26 27", 1144);
    SetListenPattern(OBJECT_SELF, "1 Split 26 29", 1145);
    SetListenPattern(OBJECT_SELF, "1 Split 27 30", 1146);
    SetListenPattern(OBJECT_SELF, "1 Split 28 29", 1147);
    SetListenPattern(OBJECT_SELF, "1 Split 28 31", 1148);
    SetListenPattern(OBJECT_SELF, "1 Split 29 30", 1149);
    SetListenPattern(OBJECT_SELF, "1 Split 29 32", 1150);
    SetListenPattern(OBJECT_SELF, "1 Split 30 33", 1151);
    SetListenPattern(OBJECT_SELF, "1 Split 31 33", 1152);
    SetListenPattern(OBJECT_SELF, "1 Split 31 34", 1153);
    SetListenPattern(OBJECT_SELF, "1 Split 32 33", 1154);
    SetListenPattern(OBJECT_SELF, "1 Split 32 35", 1155);
    SetListenPattern(OBJECT_SELF, "1 Split 33 36", 1156);
    SetListenPattern(OBJECT_SELF, "1 Split 34 35", 1157);
    SetListenPattern(OBJECT_SELF, "1 Split 35 36", 1158);
    }
if (nBet5)
    {
    SetListenPattern(OBJECT_SELF, "5 Five", 5001);
    SetListenPattern(OBJECT_SELF, "5 Red", 5002);
    SetListenPattern(OBJECT_SELF, "5 Black", 5003);
    SetListenPattern(OBJECT_SELF, "5 Odd", 5004);
    SetListenPattern(OBJECT_SELF, "5 Even", 5005);
    SetListenPattern(OBJECT_SELF, "5 High", 5006);
    SetListenPattern(OBJECT_SELF, "5 Low", 5007);
    SetListenPattern(OBJECT_SELF, "5 Column 1", 5008);
    SetListenPattern(OBJECT_SELF, "5 Column 2", 5009);
    SetListenPattern(OBJECT_SELF, "5 Column 3", 5010);
    SetListenPattern(OBJECT_SELF, "5 Dozen 1", 5011);
    SetListenPattern(OBJECT_SELF, "5 Dozen 2", 5012);
    SetListenPattern(OBJECT_SELF, "5 Dozen 3", 5013);
    SetListenPattern(OBJECT_SELF, "5 Line 1-6", 5014);
    SetListenPattern(OBJECT_SELF, "5 Line 4-9", 5015);
    SetListenPattern(OBJECT_SELF, "5 Line 7-12", 5016);
    SetListenPattern(OBJECT_SELF, "5 Line 10-15", 5017);
    SetListenPattern(OBJECT_SELF, "5 Line 13-18", 5018);
    SetListenPattern(OBJECT_SELF, "5 Line 16-21", 5019);
    SetListenPattern(OBJECT_SELF, "5 Line 19-24", 5020);
    SetListenPattern(OBJECT_SELF, "5 Line 22-27", 5021);
    SetListenPattern(OBJECT_SELF, "5 Line 25-30", 5022);
    SetListenPattern(OBJECT_SELF, "5 Line 28-33", 5023);
    SetListenPattern(OBJECT_SELF, "5 Line 31-36", 5024);
    SetListenPattern(OBJECT_SELF, "5 Street 1-3", 5025);
    SetListenPattern(OBJECT_SELF, "5 Street 4-6", 5026);
    SetListenPattern(OBJECT_SELF, "5 Street 7-9", 5027);
    SetListenPattern(OBJECT_SELF, "5 Street 10-12", 5028);
    SetListenPattern(OBJECT_SELF, "5 Street 13-15", 5029);
    SetListenPattern(OBJECT_SELF, "5 Street 16-18", 5030);
    SetListenPattern(OBJECT_SELF, "5 Street 19-21", 5031);
    SetListenPattern(OBJECT_SELF, "5 Street 22-24", 5032);
    SetListenPattern(OBJECT_SELF, "5 Street 25-27", 5033);
    SetListenPattern(OBJECT_SELF, "5 Street 28-30", 5034);
    SetListenPattern(OBJECT_SELF, "5 Street 31-33", 5035);
    SetListenPattern(OBJECT_SELF, "5 Street 34-36", 5036);
    SetListenPattern(OBJECT_SELF, "5 Corner 1-5", 5037);
    SetListenPattern(OBJECT_SELF, "5 Corner 2-6", 5038);
    SetListenPattern(OBJECT_SELF, "5 Corner 4-8", 5039);
    SetListenPattern(OBJECT_SELF, "5 Corner 5-9", 5040);
    SetListenPattern(OBJECT_SELF, "5 Corner 7-11", 5041);
    SetListenPattern(OBJECT_SELF, "5 Corner 8-12", 5042);
    SetListenPattern(OBJECT_SELF, "5 Corner 10-14", 5043);
    SetListenPattern(OBJECT_SELF, "5 Corner 11-15", 5044);
    SetListenPattern(OBJECT_SELF, "5 Corner 13-17", 5045);
    SetListenPattern(OBJECT_SELF, "5 Corner 14-18", 5046);
    SetListenPattern(OBJECT_SELF, "5 Corner 16-20", 5047);
    SetListenPattern(OBJECT_SELF, "5 Corner 17-21", 5048);
    SetListenPattern(OBJECT_SELF, "5 Corner 19-23", 5049);
    SetListenPattern(OBJECT_SELF, "5 Corner 20-24", 5050);
    SetListenPattern(OBJECT_SELF, "5 Corner 22-26", 5051);
    SetListenPattern(OBJECT_SELF, "5 Corner 23-27", 5052);
    SetListenPattern(OBJECT_SELF, "5 Corner 25-29", 5053);
    SetListenPattern(OBJECT_SELF, "5 Corner 26-30", 5054);
    SetListenPattern(OBJECT_SELF, "5 Corner 28-32", 5055);
    SetListenPattern(OBJECT_SELF, "5 Corner 29-33", 5056);
    SetListenPattern(OBJECT_SELF, "5 Corner 31-35", 5057);
    SetListenPattern(OBJECT_SELF, "5 Corner 32-36", 5058);
    SetListenPattern(OBJECT_SELF, "5 Number 0", 5059);
    SetListenPattern(OBJECT_SELF, "5 Number 00", 5060);
    SetListenPattern(OBJECT_SELF, "5 Number 1", 5061);
    SetListenPattern(OBJECT_SELF, "5 Number 2", 5062);
    SetListenPattern(OBJECT_SELF, "5 Number 3", 5063);
    SetListenPattern(OBJECT_SELF, "5 Number 4", 5064);
    SetListenPattern(OBJECT_SELF, "5 Number 5", 5065);
    SetListenPattern(OBJECT_SELF, "5 Number 6", 5066);
    SetListenPattern(OBJECT_SELF, "5 Number 7", 5067);
    SetListenPattern(OBJECT_SELF, "5 Number 8", 5068);
    SetListenPattern(OBJECT_SELF, "5 Number 9", 5069);
    SetListenPattern(OBJECT_SELF, "5 Number 10", 5070);
    SetListenPattern(OBJECT_SELF, "5 Number 11", 5071);
    SetListenPattern(OBJECT_SELF, "5 Number 12", 5072);
    SetListenPattern(OBJECT_SELF, "5 Number 13", 5073);
    SetListenPattern(OBJECT_SELF, "5 Number 14", 5074);
    SetListenPattern(OBJECT_SELF, "5 Number 15", 5075);
    SetListenPattern(OBJECT_SELF, "5 Number 16", 5076);
    SetListenPattern(OBJECT_SELF, "5 Number 17", 5077);
    SetListenPattern(OBJECT_SELF, "5 Number 18", 5078);
    SetListenPattern(OBJECT_SELF, "5 Number 19", 5079);
    SetListenPattern(OBJECT_SELF, "5 Number 20", 5080);
    SetListenPattern(OBJECT_SELF, "5 Number 21", 5081);
    SetListenPattern(OBJECT_SELF, "5 Number 22", 5082);
    SetListenPattern(OBJECT_SELF, "5 Number 23", 5083);
    SetListenPattern(OBJECT_SELF, "5 Number 24", 5084);
    SetListenPattern(OBJECT_SELF, "5 Number 25", 5085);
    SetListenPattern(OBJECT_SELF, "5 Number 26", 5086);
    SetListenPattern(OBJECT_SELF, "5 Number 27", 5087);
    SetListenPattern(OBJECT_SELF, "5 Number 28", 5088);
    SetListenPattern(OBJECT_SELF, "5 Number 29", 5089);
    SetListenPattern(OBJECT_SELF, "5 Number 30", 5090);
    SetListenPattern(OBJECT_SELF, "5 Number 31", 5091);
    SetListenPattern(OBJECT_SELF, "5 Number 32", 5092);
    SetListenPattern(OBJECT_SELF, "5 Number 33", 5093);
    SetListenPattern(OBJECT_SELF, "5 Number 34", 5094);
    SetListenPattern(OBJECT_SELF, "5 Number 35", 5095);
    SetListenPattern(OBJECT_SELF, "5 Number 36", 5096);
    SetListenPattern(OBJECT_SELF, "5 Split 0 00", 5097);
    SetListenPattern(OBJECT_SELF, "5 Split 0 1", 5098);
    SetListenPattern(OBJECT_SELF, "5 Split 0 2", 5099);
    SetListenPattern(OBJECT_SELF, "5 Split 00 2", 5100);
    SetListenPattern(OBJECT_SELF, "5 Split 00 3", 5101);
    SetListenPattern(OBJECT_SELF, "5 Split 1 2", 5102);
    SetListenPattern(OBJECT_SELF, "5 Split 1 4", 5103);
    SetListenPattern(OBJECT_SELF, "5 Split 2 3", 5104);
    SetListenPattern(OBJECT_SELF, "5 Split 2 5", 5105);
    SetListenPattern(OBJECT_SELF, "5 Split 3 6", 5106);
    SetListenPattern(OBJECT_SELF, "5 Split 4 5", 5107);
    SetListenPattern(OBJECT_SELF, "5 Split 4 7", 5108);
    SetListenPattern(OBJECT_SELF, "5 Split 5 6", 5109);
    SetListenPattern(OBJECT_SELF, "5 Split 5 8", 5110);
    SetListenPattern(OBJECT_SELF, "5 Split 6 9", 5111);
    SetListenPattern(OBJECT_SELF, "5 Split 7 8", 5112);
    SetListenPattern(OBJECT_SELF, "5 Split 7 10", 5113);
    SetListenPattern(OBJECT_SELF, "5 Split 8 9", 5114);
    SetListenPattern(OBJECT_SELF, "5 Split 8 11", 5115);
    SetListenPattern(OBJECT_SELF, "5 Split 9 12", 5116);
    SetListenPattern(OBJECT_SELF, "5 Split 10 11", 5117);
    SetListenPattern(OBJECT_SELF, "5 Split 10 13", 5118);
    SetListenPattern(OBJECT_SELF, "5 Split 11 12", 5119);
    SetListenPattern(OBJECT_SELF, "5 Split 11 14", 5120);
    SetListenPattern(OBJECT_SELF, "5 Split 12 15", 5121);
    SetListenPattern(OBJECT_SELF, "5 Split 13 14", 5122);
    SetListenPattern(OBJECT_SELF, "5 Split 13 16", 5123);
    SetListenPattern(OBJECT_SELF, "5 Split 14 15", 5124);
    SetListenPattern(OBJECT_SELF, "5 Split 14 17", 5125);
    SetListenPattern(OBJECT_SELF, "5 Split 15 18", 5126);
    SetListenPattern(OBJECT_SELF, "5 Split 16 17", 5127);
    SetListenPattern(OBJECT_SELF, "5 Split 16 19", 5128);
    SetListenPattern(OBJECT_SELF, "5 Split 17 18", 5129);
    SetListenPattern(OBJECT_SELF, "5 Split 17 20", 5130);
    SetListenPattern(OBJECT_SELF, "5 Split 18 21", 5131);
    SetListenPattern(OBJECT_SELF, "5 Split 19 20", 5132);
    SetListenPattern(OBJECT_SELF, "5 Split 19 22", 5133);
    SetListenPattern(OBJECT_SELF, "5 Split 20 21", 5134);
    SetListenPattern(OBJECT_SELF, "5 Split 20 23", 5135);
    SetListenPattern(OBJECT_SELF, "5 Split 21 24", 5136);
    SetListenPattern(OBJECT_SELF, "5 Split 22 23", 5137);
    SetListenPattern(OBJECT_SELF, "5 Split 22 25", 5138);
    SetListenPattern(OBJECT_SELF, "5 Split 23 24", 5139);
    SetListenPattern(OBJECT_SELF, "5 Split 23 26", 5140);
    SetListenPattern(OBJECT_SELF, "5 Split 24 27", 5141);
    SetListenPattern(OBJECT_SELF, "5 Split 25 26", 5142);
    SetListenPattern(OBJECT_SELF, "5 Split 25 28", 5143);
    SetListenPattern(OBJECT_SELF, "5 Split 26 27", 5144);
    SetListenPattern(OBJECT_SELF, "5 Split 26 29", 5145);
    SetListenPattern(OBJECT_SELF, "5 Split 27 30", 5146);
    SetListenPattern(OBJECT_SELF, "5 Split 28 29", 5147);
    SetListenPattern(OBJECT_SELF, "5 Split 28 31", 5148);
    SetListenPattern(OBJECT_SELF, "5 Split 29 30", 5149);
    SetListenPattern(OBJECT_SELF, "5 Split 29 32", 5150);
    SetListenPattern(OBJECT_SELF, "5 Split 30 33", 5151);
    SetListenPattern(OBJECT_SELF, "5 Split 31 33", 5152);
    SetListenPattern(OBJECT_SELF, "5 Split 31 34", 5153);
    SetListenPattern(OBJECT_SELF, "5 Split 32 33", 5154);
    SetListenPattern(OBJECT_SELF, "5 Split 32 35", 5155);
    SetListenPattern(OBJECT_SELF, "5 Split 33 36", 5156);
    SetListenPattern(OBJECT_SELF, "5 Split 34 35", 5157);
    SetListenPattern(OBJECT_SELF, "5 Split 35 36", 5158);
    }
if (nBet10)
    {
    SetListenPattern(OBJECT_SELF, "10 Five", 10001);
    SetListenPattern(OBJECT_SELF, "10 Red", 10002);
    SetListenPattern(OBJECT_SELF, "10 Black", 10003);
    SetListenPattern(OBJECT_SELF, "10 Odd", 10004);
    SetListenPattern(OBJECT_SELF, "10 Even", 10005);
    SetListenPattern(OBJECT_SELF, "10 High", 10006);
    SetListenPattern(OBJECT_SELF, "10 Low", 10007);
    SetListenPattern(OBJECT_SELF, "10 Column 1", 10008);
    SetListenPattern(OBJECT_SELF, "10 Column 2", 10009);
    SetListenPattern(OBJECT_SELF, "10 Column 3", 10010);
    SetListenPattern(OBJECT_SELF, "10 Dozen 1", 10011);
    SetListenPattern(OBJECT_SELF, "10 Dozen 2", 10012);
    SetListenPattern(OBJECT_SELF, "10 Dozen 3", 10013);
    SetListenPattern(OBJECT_SELF, "10 Line 1-6", 10014);
    SetListenPattern(OBJECT_SELF, "10 Line 4-9", 10015);
    SetListenPattern(OBJECT_SELF, "10 Line 7-12", 10016);
    SetListenPattern(OBJECT_SELF, "10 Line 10-15", 10017);
    SetListenPattern(OBJECT_SELF, "10 Line 13-18", 10018);
    SetListenPattern(OBJECT_SELF, "10 Line 16-21", 10019);
    SetListenPattern(OBJECT_SELF, "10 Line 19-24", 10020);
    SetListenPattern(OBJECT_SELF, "10 Line 22-27", 10021);
    SetListenPattern(OBJECT_SELF, "10 Line 25-30", 10022);
    SetListenPattern(OBJECT_SELF, "10 Line 28-33", 10023);
    SetListenPattern(OBJECT_SELF, "10 Line 31-36", 10024);
    SetListenPattern(OBJECT_SELF, "10 Street 1-3", 10025);
    SetListenPattern(OBJECT_SELF, "10 Street 4-6", 10026);
    SetListenPattern(OBJECT_SELF, "10 Street 7-9", 10027);
    SetListenPattern(OBJECT_SELF, "10 Street 10-12", 10028);
    SetListenPattern(OBJECT_SELF, "10 Street 13-15", 10029);
    SetListenPattern(OBJECT_SELF, "10 Street 16-18", 10030);
    SetListenPattern(OBJECT_SELF, "10 Street 19-21", 10031);
    SetListenPattern(OBJECT_SELF, "10 Street 22-24", 10032);
    SetListenPattern(OBJECT_SELF, "10 Street 25-27", 10033);
    SetListenPattern(OBJECT_SELF, "10 Street 28-30", 10034);
    SetListenPattern(OBJECT_SELF, "10 Street 31-33", 10035);
    SetListenPattern(OBJECT_SELF, "10 Street 34-36", 10036);
    SetListenPattern(OBJECT_SELF, "10 Corner 1-5", 10037);
    SetListenPattern(OBJECT_SELF, "10 Corner 2-6", 10038);
    SetListenPattern(OBJECT_SELF, "10 Corner 4-8", 10039);
    SetListenPattern(OBJECT_SELF, "10 Corner 5-9", 10040);
    SetListenPattern(OBJECT_SELF, "10 Corner 7-11", 10041);
    SetListenPattern(OBJECT_SELF, "10 Corner 8-12", 10042);
    SetListenPattern(OBJECT_SELF, "10 Corner 10-14", 10043);
    SetListenPattern(OBJECT_SELF, "10 Corner 11-15", 10044);
    SetListenPattern(OBJECT_SELF, "10 Corner 13-17", 10045);
    SetListenPattern(OBJECT_SELF, "10 Corner 14-18", 10046);
    SetListenPattern(OBJECT_SELF, "10 Corner 16-20", 10047);
    SetListenPattern(OBJECT_SELF, "10 Corner 17-21", 10048);
    SetListenPattern(OBJECT_SELF, "10 Corner 19-23", 10049);
    SetListenPattern(OBJECT_SELF, "10 Corner 20-24", 10050);
    SetListenPattern(OBJECT_SELF, "10 Corner 22-26", 10051);
    SetListenPattern(OBJECT_SELF, "10 Corner 23-27", 10052);
    SetListenPattern(OBJECT_SELF, "10 Corner 25-29", 10053);
    SetListenPattern(OBJECT_SELF, "10 Corner 26-30", 10054);
    SetListenPattern(OBJECT_SELF, "10 Corner 28-32", 10055);
    SetListenPattern(OBJECT_SELF, "10 Corner 29-33", 10056);
    SetListenPattern(OBJECT_SELF, "10 Corner 31-35", 10057);
    SetListenPattern(OBJECT_SELF, "10 Corner 32-36", 10058);
    SetListenPattern(OBJECT_SELF, "10 Number 0", 10059);
    SetListenPattern(OBJECT_SELF, "10 Number 00", 10060);
    SetListenPattern(OBJECT_SELF, "10 Number 1", 10061);
    SetListenPattern(OBJECT_SELF, "10 Number 2", 10062);
    SetListenPattern(OBJECT_SELF, "10 Number 3", 10063);
    SetListenPattern(OBJECT_SELF, "10 Number 4", 10064);
    SetListenPattern(OBJECT_SELF, "10 Number 5", 10065);
    SetListenPattern(OBJECT_SELF, "10 Number 6", 10066);
    SetListenPattern(OBJECT_SELF, "10 Number 7", 10067);
    SetListenPattern(OBJECT_SELF, "10 Number 8", 10068);
    SetListenPattern(OBJECT_SELF, "10 Number 9", 10069);
    SetListenPattern(OBJECT_SELF, "10 Number 10", 10070);
    SetListenPattern(OBJECT_SELF, "10 Number 11", 10071);
    SetListenPattern(OBJECT_SELF, "10 Number 12", 10072);
    SetListenPattern(OBJECT_SELF, "10 Number 13", 10073);
    SetListenPattern(OBJECT_SELF, "10 Number 14", 10074);
    SetListenPattern(OBJECT_SELF, "10 Number 15", 10075);
    SetListenPattern(OBJECT_SELF, "10 Number 16", 10076);
    SetListenPattern(OBJECT_SELF, "10 Number 17", 10077);
    SetListenPattern(OBJECT_SELF, "10 Number 18", 10078);
    SetListenPattern(OBJECT_SELF, "10 Number 19", 10079);
    SetListenPattern(OBJECT_SELF, "10 Number 20", 10080);
    SetListenPattern(OBJECT_SELF, "10 Number 21", 10081);
    SetListenPattern(OBJECT_SELF, "10 Number 22", 10082);
    SetListenPattern(OBJECT_SELF, "10 Number 23", 10083);
    SetListenPattern(OBJECT_SELF, "10 Number 24", 10084);
    SetListenPattern(OBJECT_SELF, "10 Number 25", 10085);
    SetListenPattern(OBJECT_SELF, "10 Number 26", 10086);
    SetListenPattern(OBJECT_SELF, "10 Number 27", 10087);
    SetListenPattern(OBJECT_SELF, "10 Number 28", 10088);
    SetListenPattern(OBJECT_SELF, "10 Number 29", 10089);
    SetListenPattern(OBJECT_SELF, "10 Number 30", 10090);
    SetListenPattern(OBJECT_SELF, "10 Number 31", 10091);
    SetListenPattern(OBJECT_SELF, "10 Number 32", 10092);
    SetListenPattern(OBJECT_SELF, "10 Number 33", 10093);
    SetListenPattern(OBJECT_SELF, "10 Number 34", 10094);
    SetListenPattern(OBJECT_SELF, "10 Number 35", 10095);
    SetListenPattern(OBJECT_SELF, "10 Number 36", 10096);
    SetListenPattern(OBJECT_SELF, "10 Split 0 00", 10097);
    SetListenPattern(OBJECT_SELF, "10 Split 0 1", 10098);
    SetListenPattern(OBJECT_SELF, "10 Split 0 2", 10099);
    SetListenPattern(OBJECT_SELF, "10 Split 00 2", 10100);
    SetListenPattern(OBJECT_SELF, "10 Split 00 3", 10101);
    SetListenPattern(OBJECT_SELF, "10 Split 1 2", 10102);
    SetListenPattern(OBJECT_SELF, "10 Split 1 4", 10103);
    SetListenPattern(OBJECT_SELF, "10 Split 2 3", 10104);
    SetListenPattern(OBJECT_SELF, "10 Split 2 5", 10105);
    SetListenPattern(OBJECT_SELF, "10 Split 3 6", 10106);
    SetListenPattern(OBJECT_SELF, "10 Split 4 5", 10107);
    SetListenPattern(OBJECT_SELF, "10 Split 4 7", 10108);
    SetListenPattern(OBJECT_SELF, "10 Split 5 6", 10109);
    SetListenPattern(OBJECT_SELF, "10 Split 5 8", 10110);
    SetListenPattern(OBJECT_SELF, "10 Split 6 9", 10111);
    SetListenPattern(OBJECT_SELF, "10 Split 7 8", 10112);
    SetListenPattern(OBJECT_SELF, "10 Split 7 10", 10113);
    SetListenPattern(OBJECT_SELF, "10 Split 8 9", 10114);
    SetListenPattern(OBJECT_SELF, "10 Split 8 11", 10115);
    SetListenPattern(OBJECT_SELF, "10 Split 9 12", 10116);
    SetListenPattern(OBJECT_SELF, "10 Split 10 11", 10117);
    SetListenPattern(OBJECT_SELF, "10 Split 10 13", 10118);
    SetListenPattern(OBJECT_SELF, "10 Split 11 12", 10119);
    SetListenPattern(OBJECT_SELF, "10 Split 11 14", 10120);
    SetListenPattern(OBJECT_SELF, "10 Split 12 15", 10121);
    SetListenPattern(OBJECT_SELF, "10 Split 13 14", 10122);
    SetListenPattern(OBJECT_SELF, "10 Split 13 16", 10123);
    SetListenPattern(OBJECT_SELF, "10 Split 14 15", 10124);
    SetListenPattern(OBJECT_SELF, "10 Split 14 17", 10125);
    SetListenPattern(OBJECT_SELF, "10 Split 15 18", 10126);
    SetListenPattern(OBJECT_SELF, "10 Split 16 17", 10127);
    SetListenPattern(OBJECT_SELF, "10 Split 16 19", 10128);
    SetListenPattern(OBJECT_SELF, "10 Split 17 18", 10129);
    SetListenPattern(OBJECT_SELF, "10 Split 17 20", 10130);
    SetListenPattern(OBJECT_SELF, "10 Split 18 21", 10131);
    SetListenPattern(OBJECT_SELF, "10 Split 19 20", 10132);
    SetListenPattern(OBJECT_SELF, "10 Split 19 22", 10133);
    SetListenPattern(OBJECT_SELF, "10 Split 20 21", 10134);
    SetListenPattern(OBJECT_SELF, "10 Split 20 23", 10135);
    SetListenPattern(OBJECT_SELF, "10 Split 21 24", 10136);
    SetListenPattern(OBJECT_SELF, "10 Split 22 23", 10137);
    SetListenPattern(OBJECT_SELF, "10 Split 22 25", 10138);
    SetListenPattern(OBJECT_SELF, "10 Split 23 24", 10139);
    SetListenPattern(OBJECT_SELF, "10 Split 23 26", 10140);
    SetListenPattern(OBJECT_SELF, "10 Split 24 27", 10141);
    SetListenPattern(OBJECT_SELF, "10 Split 25 26", 10142);
    SetListenPattern(OBJECT_SELF, "10 Split 25 28", 10143);
    SetListenPattern(OBJECT_SELF, "10 Split 26 27", 10144);
    SetListenPattern(OBJECT_SELF, "10 Split 26 29", 10145);
    SetListenPattern(OBJECT_SELF, "10 Split 27 30", 10146);
    SetListenPattern(OBJECT_SELF, "10 Split 28 29", 10147);
    SetListenPattern(OBJECT_SELF, "10 Split 28 31", 10148);
    SetListenPattern(OBJECT_SELF, "10 Split 29 30", 10149);
    SetListenPattern(OBJECT_SELF, "10 Split 29 32", 10150);
    SetListenPattern(OBJECT_SELF, "10 Split 30 33", 10151);
    SetListenPattern(OBJECT_SELF, "10 Split 31 33", 10152);
    SetListenPattern(OBJECT_SELF, "10 Split 31 34", 10153);
    SetListenPattern(OBJECT_SELF, "10 Split 32 33", 10154);
    SetListenPattern(OBJECT_SELF, "10 Split 32 35", 10155);
    SetListenPattern(OBJECT_SELF, "10 Split 33 36", 10156);
    SetListenPattern(OBJECT_SELF, "10 Split 34 35", 10157);
    SetListenPattern(OBJECT_SELF, "10 Split 35 36", 10158);
    }
if (nBet50)
    {
    SetListenPattern(OBJECT_SELF, "50 Five", 50001);
    SetListenPattern(OBJECT_SELF, "50 Red", 50002);
    SetListenPattern(OBJECT_SELF, "50 Black", 50003);
    SetListenPattern(OBJECT_SELF, "50 Odd", 50004);
    SetListenPattern(OBJECT_SELF, "50 Even", 50005);
    SetListenPattern(OBJECT_SELF, "50 High", 50006);
    SetListenPattern(OBJECT_SELF, "50 Low", 50007);
    SetListenPattern(OBJECT_SELF, "50 Column 1", 50008);
    SetListenPattern(OBJECT_SELF, "50 Column 2", 50009);
    SetListenPattern(OBJECT_SELF, "50 Column 3", 50010);
    SetListenPattern(OBJECT_SELF, "50 Dozen 1", 50011);
    SetListenPattern(OBJECT_SELF, "50 Dozen 2", 50012);
    SetListenPattern(OBJECT_SELF, "50 Dozen 3", 50013);
    SetListenPattern(OBJECT_SELF, "50 Line 1-6", 50014);
    SetListenPattern(OBJECT_SELF, "50 Line 4-9", 50015);
    SetListenPattern(OBJECT_SELF, "50 Line 7-12", 50016);
    SetListenPattern(OBJECT_SELF, "50 Line 10-15", 50017);
    SetListenPattern(OBJECT_SELF, "50 Line 13-18", 50018);
    SetListenPattern(OBJECT_SELF, "50 Line 16-21", 50019);
    SetListenPattern(OBJECT_SELF, "50 Line 19-24", 50020);
    SetListenPattern(OBJECT_SELF, "50 Line 22-27", 50021);
    SetListenPattern(OBJECT_SELF, "50 Line 25-30", 50022);
    SetListenPattern(OBJECT_SELF, "50 Line 28-33", 50023);
    SetListenPattern(OBJECT_SELF, "50 Line 31-36", 50024);
    SetListenPattern(OBJECT_SELF, "50 Street 1-3", 50025);
    SetListenPattern(OBJECT_SELF, "50 Street 4-6", 50026);
    SetListenPattern(OBJECT_SELF, "50 Street 7-9", 50027);
    SetListenPattern(OBJECT_SELF, "50 Street 10-12", 50028);
    SetListenPattern(OBJECT_SELF, "50 Street 13-15", 50029);
    SetListenPattern(OBJECT_SELF, "50 Street 16-18", 50030);
    SetListenPattern(OBJECT_SELF, "50 Street 19-21", 50031);
    SetListenPattern(OBJECT_SELF, "50 Street 22-24", 50032);
    SetListenPattern(OBJECT_SELF, "50 Street 25-27", 50033);
    SetListenPattern(OBJECT_SELF, "50 Street 28-30", 50034);
    SetListenPattern(OBJECT_SELF, "50 Street 31-33", 50035);
    SetListenPattern(OBJECT_SELF, "50 Street 34-36", 50036);
    SetListenPattern(OBJECT_SELF, "50 Corner 1-5", 50037);
    SetListenPattern(OBJECT_SELF, "50 Corner 2-6", 50038);
    SetListenPattern(OBJECT_SELF, "50 Corner 4-8", 50039);
    SetListenPattern(OBJECT_SELF, "50 Corner 5-9", 50040);
    SetListenPattern(OBJECT_SELF, "50 Corner 7-11", 50041);
    SetListenPattern(OBJECT_SELF, "50 Corner 8-12", 50042);
    SetListenPattern(OBJECT_SELF, "50 Corner 10-14", 50043);
    SetListenPattern(OBJECT_SELF, "50 Corner 11-15", 50044);
    SetListenPattern(OBJECT_SELF, "50 Corner 13-17", 50045);
    SetListenPattern(OBJECT_SELF, "50 Corner 14-18", 50046);
    SetListenPattern(OBJECT_SELF, "50 Corner 16-20", 50047);
    SetListenPattern(OBJECT_SELF, "50 Corner 17-21", 50048);
    SetListenPattern(OBJECT_SELF, "50 Corner 19-23", 50049);
    SetListenPattern(OBJECT_SELF, "50 Corner 20-24", 50050);
    SetListenPattern(OBJECT_SELF, "50 Corner 22-26", 50051);
    SetListenPattern(OBJECT_SELF, "50 Corner 23-27", 50052);
    SetListenPattern(OBJECT_SELF, "50 Corner 25-29", 50053);
    SetListenPattern(OBJECT_SELF, "50 Corner 26-30", 50054);
    SetListenPattern(OBJECT_SELF, "50 Corner 28-32", 50055);
    SetListenPattern(OBJECT_SELF, "50 Corner 29-33", 50056);
    SetListenPattern(OBJECT_SELF, "50 Corner 31-35", 50057);
    SetListenPattern(OBJECT_SELF, "50 Corner 32-36", 50058);
    SetListenPattern(OBJECT_SELF, "50 Number 0", 50059);
    SetListenPattern(OBJECT_SELF, "50 Number 00", 50060);
    SetListenPattern(OBJECT_SELF, "50 Number 1", 50061);
    SetListenPattern(OBJECT_SELF, "50 Number 2", 50062);
    SetListenPattern(OBJECT_SELF, "50 Number 3", 50063);
    SetListenPattern(OBJECT_SELF, "50 Number 4", 50064);
    SetListenPattern(OBJECT_SELF, "50 Number 5", 50065);
    SetListenPattern(OBJECT_SELF, "50 Number 6", 50066);
    SetListenPattern(OBJECT_SELF, "50 Number 7", 50067);
    SetListenPattern(OBJECT_SELF, "50 Number 8", 50068);
    SetListenPattern(OBJECT_SELF, "50 Number 9", 50069);
    SetListenPattern(OBJECT_SELF, "50 Number 10", 50070);
    SetListenPattern(OBJECT_SELF, "50 Number 11", 50071);
    SetListenPattern(OBJECT_SELF, "50 Number 12", 50072);
    SetListenPattern(OBJECT_SELF, "50 Number 13", 50073);
    SetListenPattern(OBJECT_SELF, "50 Number 14", 50074);
    SetListenPattern(OBJECT_SELF, "50 Number 15", 50075);
    SetListenPattern(OBJECT_SELF, "50 Number 16", 50076);
    SetListenPattern(OBJECT_SELF, "50 Number 17", 50077);
    SetListenPattern(OBJECT_SELF, "50 Number 18", 50078);
    SetListenPattern(OBJECT_SELF, "50 Number 19", 50079);
    SetListenPattern(OBJECT_SELF, "50 Number 20", 50080);
    SetListenPattern(OBJECT_SELF, "50 Number 21", 50081);
    SetListenPattern(OBJECT_SELF, "50 Number 22", 50082);
    SetListenPattern(OBJECT_SELF, "50 Number 23", 50083);
    SetListenPattern(OBJECT_SELF, "50 Number 24", 50084);
    SetListenPattern(OBJECT_SELF, "50 Number 25", 50085);
    SetListenPattern(OBJECT_SELF, "50 Number 26", 50086);
    SetListenPattern(OBJECT_SELF, "50 Number 27", 50087);
    SetListenPattern(OBJECT_SELF, "50 Number 28", 50088);
    SetListenPattern(OBJECT_SELF, "50 Number 29", 50089);
    SetListenPattern(OBJECT_SELF, "50 Number 30", 50090);
    SetListenPattern(OBJECT_SELF, "50 Number 31", 50091);
    SetListenPattern(OBJECT_SELF, "50 Number 32", 50092);
    SetListenPattern(OBJECT_SELF, "50 Number 33", 50093);
    SetListenPattern(OBJECT_SELF, "50 Number 34", 50094);
    SetListenPattern(OBJECT_SELF, "50 Number 35", 50095);
    SetListenPattern(OBJECT_SELF, "50 Number 36", 50096);
    SetListenPattern(OBJECT_SELF, "50 Split 0 00", 50097);
    SetListenPattern(OBJECT_SELF, "50 Split 0 1", 50098);
    SetListenPattern(OBJECT_SELF, "50 Split 0 2", 50099);
    SetListenPattern(OBJECT_SELF, "50 Split 00 2", 50100);
    SetListenPattern(OBJECT_SELF, "50 Split 00 3", 50101);
    SetListenPattern(OBJECT_SELF, "50 Split 1 2", 50102);
    SetListenPattern(OBJECT_SELF, "50 Split 1 4", 50103);
    SetListenPattern(OBJECT_SELF, "50 Split 2 3", 50104);
    SetListenPattern(OBJECT_SELF, "50 Split 2 5", 50105);
    SetListenPattern(OBJECT_SELF, "50 Split 3 6", 50106);
    SetListenPattern(OBJECT_SELF, "50 Split 4 5", 50107);
    SetListenPattern(OBJECT_SELF, "50 Split 4 7", 50108);
    SetListenPattern(OBJECT_SELF, "50 Split 5 6", 50109);
    SetListenPattern(OBJECT_SELF, "50 Split 5 8", 50110);
    SetListenPattern(OBJECT_SELF, "50 Split 6 9", 50111);
    SetListenPattern(OBJECT_SELF, "50 Split 7 8", 50112);
    SetListenPattern(OBJECT_SELF, "50 Split 7 10", 50113);
    SetListenPattern(OBJECT_SELF, "50 Split 8 9", 50114);
    SetListenPattern(OBJECT_SELF, "50 Split 8 11", 50115);
    SetListenPattern(OBJECT_SELF, "50 Split 9 12", 50116);
    SetListenPattern(OBJECT_SELF, "50 Split 10 11", 50117);
    SetListenPattern(OBJECT_SELF, "50 Split 10 13", 50118);
    SetListenPattern(OBJECT_SELF, "50 Split 11 12", 50119);
    SetListenPattern(OBJECT_SELF, "50 Split 11 14", 50120);
    SetListenPattern(OBJECT_SELF, "50 Split 12 15", 50121);
    SetListenPattern(OBJECT_SELF, "50 Split 13 14", 50122);
    SetListenPattern(OBJECT_SELF, "50 Split 13 16", 50123);
    SetListenPattern(OBJECT_SELF, "50 Split 14 15", 50124);
    SetListenPattern(OBJECT_SELF, "50 Split 14 17", 50125);
    SetListenPattern(OBJECT_SELF, "50 Split 15 18", 50126);
    SetListenPattern(OBJECT_SELF, "50 Split 16 17", 50127);
    SetListenPattern(OBJECT_SELF, "50 Split 16 19", 50128);
    SetListenPattern(OBJECT_SELF, "50 Split 17 18", 50129);
    SetListenPattern(OBJECT_SELF, "50 Split 17 20", 50130);
    SetListenPattern(OBJECT_SELF, "50 Split 18 21", 50131);
    SetListenPattern(OBJECT_SELF, "50 Split 19 20", 50132);
    SetListenPattern(OBJECT_SELF, "50 Split 19 22", 50133);
    SetListenPattern(OBJECT_SELF, "50 Split 20 21", 50134);
    SetListenPattern(OBJECT_SELF, "50 Split 20 23", 50135);
    SetListenPattern(OBJECT_SELF, "50 Split 21 24", 50136);
    SetListenPattern(OBJECT_SELF, "50 Split 22 23", 50137);
    SetListenPattern(OBJECT_SELF, "50 Split 22 25", 50138);
    SetListenPattern(OBJECT_SELF, "50 Split 23 24", 50139);
    SetListenPattern(OBJECT_SELF, "50 Split 23 26", 50140);
    SetListenPattern(OBJECT_SELF, "50 Split 24 27", 50141);
    SetListenPattern(OBJECT_SELF, "50 Split 25 26", 50142);
    SetListenPattern(OBJECT_SELF, "50 Split 25 28", 50143);
    SetListenPattern(OBJECT_SELF, "50 Split 26 27", 50144);
    SetListenPattern(OBJECT_SELF, "50 Split 26 29", 50145);
    SetListenPattern(OBJECT_SELF, "50 Split 27 30", 50146);
    SetListenPattern(OBJECT_SELF, "50 Split 28 29", 50147);
    SetListenPattern(OBJECT_SELF, "50 Split 28 31", 50148);
    SetListenPattern(OBJECT_SELF, "50 Split 29 30", 50149);
    SetListenPattern(OBJECT_SELF, "50 Split 29 32", 50150);
    SetListenPattern(OBJECT_SELF, "50 Split 30 33", 50151);
    SetListenPattern(OBJECT_SELF, "50 Split 31 33", 50152);
    SetListenPattern(OBJECT_SELF, "50 Split 31 34", 50153);
    SetListenPattern(OBJECT_SELF, "50 Split 32 33", 50154);
    SetListenPattern(OBJECT_SELF, "50 Split 32 35", 50155);
    SetListenPattern(OBJECT_SELF, "50 Split 33 36", 50156);
    SetListenPattern(OBJECT_SELF, "50 Split 34 35", 50157);
    SetListenPattern(OBJECT_SELF, "50 Split 35 36", 50158);
    }
if (nBet100)
    {
    SetListenPattern(OBJECT_SELF, "100 Five", 100001);
    SetListenPattern(OBJECT_SELF, "100 Red", 100002);
    SetListenPattern(OBJECT_SELF, "100 Black", 100003);
    SetListenPattern(OBJECT_SELF, "100 Odd", 100004);
    SetListenPattern(OBJECT_SELF, "100 Even", 100005);
    SetListenPattern(OBJECT_SELF, "100 High", 100006);
    SetListenPattern(OBJECT_SELF, "100 Low", 100007);
    SetListenPattern(OBJECT_SELF, "100 Column 1", 100008);
    SetListenPattern(OBJECT_SELF, "100 Column 2", 100009);
    SetListenPattern(OBJECT_SELF, "100 Column 3", 100010);
    SetListenPattern(OBJECT_SELF, "100 Dozen 1", 100011);
    SetListenPattern(OBJECT_SELF, "100 Dozen 2", 100012);
    SetListenPattern(OBJECT_SELF, "100 Dozen 3", 100013);
    SetListenPattern(OBJECT_SELF, "100 Line 1-6", 100014);
    SetListenPattern(OBJECT_SELF, "100 Line 4-9", 100015);
    SetListenPattern(OBJECT_SELF, "100 Line 7-12", 100016);
    SetListenPattern(OBJECT_SELF, "100 Line 10-15", 100017);
    SetListenPattern(OBJECT_SELF, "100 Line 13-18", 100018);
    SetListenPattern(OBJECT_SELF, "100 Line 16-21", 100019);
    SetListenPattern(OBJECT_SELF, "100 Line 19-24", 100020);
    SetListenPattern(OBJECT_SELF, "100 Line 22-27", 100021);
    SetListenPattern(OBJECT_SELF, "100 Line 25-30", 100022);
    SetListenPattern(OBJECT_SELF, "100 Line 28-33", 100023);
    SetListenPattern(OBJECT_SELF, "100 Line 31-36", 100024);
    SetListenPattern(OBJECT_SELF, "100 Street 1-3", 100025);
    SetListenPattern(OBJECT_SELF, "100 Street 4-6", 100026);
    SetListenPattern(OBJECT_SELF, "100 Street 7-9", 100027);
    SetListenPattern(OBJECT_SELF, "100 Street 10-12", 100028);
    SetListenPattern(OBJECT_SELF, "100 Street 13-15", 100029);
    SetListenPattern(OBJECT_SELF, "100 Street 16-18", 100030);
    SetListenPattern(OBJECT_SELF, "100 Street 19-21", 100031);
    SetListenPattern(OBJECT_SELF, "100 Street 22-24", 100032);
    SetListenPattern(OBJECT_SELF, "100 Street 25-27", 100033);
    SetListenPattern(OBJECT_SELF, "100 Street 28-30", 100034);
    SetListenPattern(OBJECT_SELF, "100 Street 31-33", 100035);
    SetListenPattern(OBJECT_SELF, "100 Street 34-36", 100036);
    SetListenPattern(OBJECT_SELF, "100 Corner 1-5", 100037);
    SetListenPattern(OBJECT_SELF, "100 Corner 2-6", 100038);
    SetListenPattern(OBJECT_SELF, "100 Corner 4-8", 100039);
    SetListenPattern(OBJECT_SELF, "100 Corner 5-9", 100040);
    SetListenPattern(OBJECT_SELF, "100 Corner 7-11", 100041);
    SetListenPattern(OBJECT_SELF, "100 Corner 8-12", 100042);
    SetListenPattern(OBJECT_SELF, "100 Corner 10-14", 100043);
    SetListenPattern(OBJECT_SELF, "100 Corner 11-15", 100044);
    SetListenPattern(OBJECT_SELF, "100 Corner 13-17", 100045);
    SetListenPattern(OBJECT_SELF, "100 Corner 14-18", 100046);
    SetListenPattern(OBJECT_SELF, "100 Corner 16-20", 100047);
    SetListenPattern(OBJECT_SELF, "100 Corner 17-21", 100048);
    SetListenPattern(OBJECT_SELF, "100 Corner 19-23", 100049);
    SetListenPattern(OBJECT_SELF, "100 Corner 20-24", 100050);
    SetListenPattern(OBJECT_SELF, "100 Corner 22-26", 100051);
    SetListenPattern(OBJECT_SELF, "100 Corner 23-27", 100052);
    SetListenPattern(OBJECT_SELF, "100 Corner 25-29", 100053);
    SetListenPattern(OBJECT_SELF, "100 Corner 26-30", 100054);
    SetListenPattern(OBJECT_SELF, "100 Corner 28-32", 100055);
    SetListenPattern(OBJECT_SELF, "100 Corner 29-33", 100056);
    SetListenPattern(OBJECT_SELF, "100 Corner 31-35", 100057);
    SetListenPattern(OBJECT_SELF, "100 Corner 32-36", 100058);
    SetListenPattern(OBJECT_SELF, "100 Number 0", 100059);
    SetListenPattern(OBJECT_SELF, "100 Number 00", 100060);
    SetListenPattern(OBJECT_SELF, "100 Number 1", 100061);
    SetListenPattern(OBJECT_SELF, "100 Number 2", 100062);
    SetListenPattern(OBJECT_SELF, "100 Number 3", 100063);
    SetListenPattern(OBJECT_SELF, "100 Number 4", 100064);
    SetListenPattern(OBJECT_SELF, "100 Number 5", 100065);
    SetListenPattern(OBJECT_SELF, "100 Number 6", 100066);
    SetListenPattern(OBJECT_SELF, "100 Number 7", 100067);
    SetListenPattern(OBJECT_SELF, "100 Number 8", 100068);
    SetListenPattern(OBJECT_SELF, "100 Number 9", 100069);
    SetListenPattern(OBJECT_SELF, "100 Number 10", 100070);
    SetListenPattern(OBJECT_SELF, "100 Number 11", 100071);
    SetListenPattern(OBJECT_SELF, "100 Number 12", 100072);
    SetListenPattern(OBJECT_SELF, "100 Number 13", 100073);
    SetListenPattern(OBJECT_SELF, "100 Number 14", 100074);
    SetListenPattern(OBJECT_SELF, "100 Number 15", 100075);
    SetListenPattern(OBJECT_SELF, "100 Number 16", 100076);
    SetListenPattern(OBJECT_SELF, "100 Number 17", 100077);
    SetListenPattern(OBJECT_SELF, "100 Number 18", 100078);
    SetListenPattern(OBJECT_SELF, "100 Number 19", 100079);
    SetListenPattern(OBJECT_SELF, "100 Number 20", 100080);
    SetListenPattern(OBJECT_SELF, "100 Number 21", 100081);
    SetListenPattern(OBJECT_SELF, "100 Number 22", 100082);
    SetListenPattern(OBJECT_SELF, "100 Number 23", 100083);
    SetListenPattern(OBJECT_SELF, "100 Number 24", 100084);
    SetListenPattern(OBJECT_SELF, "100 Number 25", 100085);
    SetListenPattern(OBJECT_SELF, "100 Number 26", 100086);
    SetListenPattern(OBJECT_SELF, "100 Number 27", 100087);
    SetListenPattern(OBJECT_SELF, "100 Number 28", 100088);
    SetListenPattern(OBJECT_SELF, "100 Number 29", 100089);
    SetListenPattern(OBJECT_SELF, "100 Number 30", 100090);
    SetListenPattern(OBJECT_SELF, "100 Number 31", 100091);
    SetListenPattern(OBJECT_SELF, "100 Number 32", 100092);
    SetListenPattern(OBJECT_SELF, "100 Number 33", 100093);
    SetListenPattern(OBJECT_SELF, "100 Number 34", 100094);
    SetListenPattern(OBJECT_SELF, "100 Number 35", 100095);
    SetListenPattern(OBJECT_SELF, "100 Number 36", 100096);
    SetListenPattern(OBJECT_SELF, "100 Split 0 00", 100097);
    SetListenPattern(OBJECT_SELF, "100 Split 0 1", 100098);
    SetListenPattern(OBJECT_SELF, "100 Split 0 2", 100099);
    SetListenPattern(OBJECT_SELF, "100 Split 00 2", 100100);
    SetListenPattern(OBJECT_SELF, "100 Split 00 3", 100101);
    SetListenPattern(OBJECT_SELF, "100 Split 1 2", 100102);
    SetListenPattern(OBJECT_SELF, "100 Split 1 4", 100103);
    SetListenPattern(OBJECT_SELF, "100 Split 2 3", 100104);
    SetListenPattern(OBJECT_SELF, "100 Split 2 5", 100105);
    SetListenPattern(OBJECT_SELF, "100 Split 3 6", 100106);
    SetListenPattern(OBJECT_SELF, "100 Split 4 5", 100107);
    SetListenPattern(OBJECT_SELF, "100 Split 4 7", 100108);
    SetListenPattern(OBJECT_SELF, "100 Split 5 6", 100109);
    SetListenPattern(OBJECT_SELF, "100 Split 5 8", 100110);
    SetListenPattern(OBJECT_SELF, "100 Split 6 9", 100111);
    SetListenPattern(OBJECT_SELF, "100 Split 7 8", 100112);
    SetListenPattern(OBJECT_SELF, "100 Split 7 10", 100113);
    SetListenPattern(OBJECT_SELF, "100 Split 8 9", 100114);
    SetListenPattern(OBJECT_SELF, "100 Split 8 11", 100115);
    SetListenPattern(OBJECT_SELF, "100 Split 9 12", 100116);
    SetListenPattern(OBJECT_SELF, "100 Split 10 11", 100117);
    SetListenPattern(OBJECT_SELF, "100 Split 10 13", 100118);
    SetListenPattern(OBJECT_SELF, "100 Split 11 12", 100119);
    SetListenPattern(OBJECT_SELF, "100 Split 11 14", 100120);
    SetListenPattern(OBJECT_SELF, "100 Split 12 15", 100121);
    SetListenPattern(OBJECT_SELF, "100 Split 13 14", 100122);
    SetListenPattern(OBJECT_SELF, "100 Split 13 16", 100123);
    SetListenPattern(OBJECT_SELF, "100 Split 14 15", 100124);
    SetListenPattern(OBJECT_SELF, "100 Split 14 17", 100125);
    SetListenPattern(OBJECT_SELF, "100 Split 15 18", 100126);
    SetListenPattern(OBJECT_SELF, "100 Split 16 17", 100127);
    SetListenPattern(OBJECT_SELF, "100 Split 16 19", 100128);
    SetListenPattern(OBJECT_SELF, "100 Split 17 18", 100129);
    SetListenPattern(OBJECT_SELF, "100 Split 17 20", 100130);
    SetListenPattern(OBJECT_SELF, "100 Split 18 21", 100131);
    SetListenPattern(OBJECT_SELF, "100 Split 19 20", 100132);
    SetListenPattern(OBJECT_SELF, "100 Split 19 22", 100133);
    SetListenPattern(OBJECT_SELF, "100 Split 20 21", 100134);
    SetListenPattern(OBJECT_SELF, "100 Split 20 23", 100135);
    SetListenPattern(OBJECT_SELF, "100 Split 21 24", 100136);
    SetListenPattern(OBJECT_SELF, "100 Split 22 23", 100137);
    SetListenPattern(OBJECT_SELF, "100 Split 22 25", 100138);
    SetListenPattern(OBJECT_SELF, "100 Split 23 24", 100139);
    SetListenPattern(OBJECT_SELF, "100 Split 23 26", 100140);
    SetListenPattern(OBJECT_SELF, "100 Split 24 27", 100141);
    SetListenPattern(OBJECT_SELF, "100 Split 25 26", 100142);
    SetListenPattern(OBJECT_SELF, "100 Split 25 28", 100143);
    SetListenPattern(OBJECT_SELF, "100 Split 26 27", 100144);
    SetListenPattern(OBJECT_SELF, "100 Split 26 29", 100145);
    SetListenPattern(OBJECT_SELF, "100 Split 27 30", 100146);
    SetListenPattern(OBJECT_SELF, "100 Split 28 29", 100147);
    SetListenPattern(OBJECT_SELF, "100 Split 28 31", 100148);
    SetListenPattern(OBJECT_SELF, "100 Split 29 30", 100149);
    SetListenPattern(OBJECT_SELF, "100 Split 29 32", 100150);
    SetListenPattern(OBJECT_SELF, "100 Split 30 33", 100151);
    SetListenPattern(OBJECT_SELF, "100 Split 31 33", 100152);
    SetListenPattern(OBJECT_SELF, "100 Split 31 34", 100153);
    SetListenPattern(OBJECT_SELF, "100 Split 32 33", 100154);
    SetListenPattern(OBJECT_SELF, "100 Split 32 35", 100155);
    SetListenPattern(OBJECT_SELF, "100 Split 33 36", 100156);
    SetListenPattern(OBJECT_SELF, "100 Split 34 35", 100157);
    SetListenPattern(OBJECT_SELF, "100 Split 35 36", 100158);
    }
if (nBet500)
    {
    SetListenPattern(OBJECT_SELF, "500 Five", 500001);
    SetListenPattern(OBJECT_SELF, "500 Red", 500002);
    SetListenPattern(OBJECT_SELF, "500 Black", 500003);
    SetListenPattern(OBJECT_SELF, "500 Odd", 500004);
    SetListenPattern(OBJECT_SELF, "500 Even", 500005);
    SetListenPattern(OBJECT_SELF, "500 High", 500006);
    SetListenPattern(OBJECT_SELF, "500 Low", 500007);
    SetListenPattern(OBJECT_SELF, "500 Column 1", 500008);
    SetListenPattern(OBJECT_SELF, "500 Column 2", 500009);
    SetListenPattern(OBJECT_SELF, "500 Column 3", 500010);
    SetListenPattern(OBJECT_SELF, "500 Dozen 1", 500011);
    SetListenPattern(OBJECT_SELF, "500 Dozen 2", 500012);
    SetListenPattern(OBJECT_SELF, "500 Dozen 3", 500013);
    SetListenPattern(OBJECT_SELF, "500 Line 1-6", 500014);
    SetListenPattern(OBJECT_SELF, "500 Line 4-9", 500015);
    SetListenPattern(OBJECT_SELF, "500 Line 7-12", 500016);
    SetListenPattern(OBJECT_SELF, "500 Line 10-15", 500017);
    SetListenPattern(OBJECT_SELF, "500 Line 13-18", 500018);
    SetListenPattern(OBJECT_SELF, "500 Line 16-21", 500019);
    SetListenPattern(OBJECT_SELF, "500 Line 19-24", 500020);
    SetListenPattern(OBJECT_SELF, "500 Line 22-27", 500021);
    SetListenPattern(OBJECT_SELF, "500 Line 25-30", 500022);
    SetListenPattern(OBJECT_SELF, "500 Line 28-33", 500023);
    SetListenPattern(OBJECT_SELF, "500 Line 31-36", 500024);
    SetListenPattern(OBJECT_SELF, "500 Street 1-3", 500025);
    SetListenPattern(OBJECT_SELF, "500 Street 4-6", 500026);
    SetListenPattern(OBJECT_SELF, "500 Street 7-9", 500027);
    SetListenPattern(OBJECT_SELF, "500 Street 10-12", 500028);
    SetListenPattern(OBJECT_SELF, "500 Street 13-15", 500029);
    SetListenPattern(OBJECT_SELF, "500 Street 16-18", 500030);
    SetListenPattern(OBJECT_SELF, "500 Street 19-21", 500031);
    SetListenPattern(OBJECT_SELF, "500 Street 22-24", 500032);
    SetListenPattern(OBJECT_SELF, "500 Street 25-27", 500033);
    SetListenPattern(OBJECT_SELF, "500 Street 28-30", 500034);
    SetListenPattern(OBJECT_SELF, "500 Street 31-33", 500035);
    SetListenPattern(OBJECT_SELF, "500 Street 34-36", 500036);
    SetListenPattern(OBJECT_SELF, "500 Corner 1-5", 500037);
    SetListenPattern(OBJECT_SELF, "500 Corner 2-6", 500038);
    SetListenPattern(OBJECT_SELF, "500 Corner 4-8", 500039);
    SetListenPattern(OBJECT_SELF, "500 Corner 5-9", 500040);
    SetListenPattern(OBJECT_SELF, "500 Corner 7-11", 500041);
    SetListenPattern(OBJECT_SELF, "500 Corner 8-12", 500042);
    SetListenPattern(OBJECT_SELF, "500 Corner 10-14", 500043);
    SetListenPattern(OBJECT_SELF, "500 Corner 11-15", 500044);
    SetListenPattern(OBJECT_SELF, "500 Corner 13-17", 500045);
    SetListenPattern(OBJECT_SELF, "500 Corner 14-18", 500046);
    SetListenPattern(OBJECT_SELF, "500 Corner 16-20", 500047);
    SetListenPattern(OBJECT_SELF, "500 Corner 17-21", 500048);
    SetListenPattern(OBJECT_SELF, "500 Corner 19-23", 500049);
    SetListenPattern(OBJECT_SELF, "500 Corner 20-24", 500050);
    SetListenPattern(OBJECT_SELF, "500 Corner 22-26", 500051);
    SetListenPattern(OBJECT_SELF, "500 Corner 23-27", 500052);
    SetListenPattern(OBJECT_SELF, "500 Corner 25-29", 500053);
    SetListenPattern(OBJECT_SELF, "500 Corner 26-30", 500054);
    SetListenPattern(OBJECT_SELF, "500 Corner 28-32", 500055);
    SetListenPattern(OBJECT_SELF, "500 Corner 29-33", 500056);
    SetListenPattern(OBJECT_SELF, "500 Corner 31-35", 500057);
    SetListenPattern(OBJECT_SELF, "500 Corner 32-36", 500058);
    SetListenPattern(OBJECT_SELF, "500 Number 0", 500059);
    SetListenPattern(OBJECT_SELF, "500 Number 00", 500060);
    SetListenPattern(OBJECT_SELF, "500 Number 1", 500061);
    SetListenPattern(OBJECT_SELF, "500 Number 2", 500062);
    SetListenPattern(OBJECT_SELF, "500 Number 3", 500063);
    SetListenPattern(OBJECT_SELF, "500 Number 4", 500064);
    SetListenPattern(OBJECT_SELF, "500 Number 5", 500065);
    SetListenPattern(OBJECT_SELF, "500 Number 6", 500066);
    SetListenPattern(OBJECT_SELF, "500 Number 7", 500067);
    SetListenPattern(OBJECT_SELF, "500 Number 8", 500068);
    SetListenPattern(OBJECT_SELF, "500 Number 9", 500069);
    SetListenPattern(OBJECT_SELF, "500 Number 10", 500070);
    SetListenPattern(OBJECT_SELF, "500 Number 11", 500071);
    SetListenPattern(OBJECT_SELF, "500 Number 12", 500072);
    SetListenPattern(OBJECT_SELF, "500 Number 13", 500073);
    SetListenPattern(OBJECT_SELF, "500 Number 14", 500074);
    SetListenPattern(OBJECT_SELF, "500 Number 15", 500075);
    SetListenPattern(OBJECT_SELF, "500 Number 16", 500076);
    SetListenPattern(OBJECT_SELF, "500 Number 17", 500077);
    SetListenPattern(OBJECT_SELF, "500 Number 18", 500078);
    SetListenPattern(OBJECT_SELF, "500 Number 19", 500079);
    SetListenPattern(OBJECT_SELF, "500 Number 20", 500080);
    SetListenPattern(OBJECT_SELF, "500 Number 21", 500081);
    SetListenPattern(OBJECT_SELF, "500 Number 22", 500082);
    SetListenPattern(OBJECT_SELF, "500 Number 23", 500083);
    SetListenPattern(OBJECT_SELF, "500 Number 24", 500084);
    SetListenPattern(OBJECT_SELF, "500 Number 25", 500085);
    SetListenPattern(OBJECT_SELF, "500 Number 26", 500086);
    SetListenPattern(OBJECT_SELF, "500 Number 27", 500087);
    SetListenPattern(OBJECT_SELF, "500 Number 28", 500088);
    SetListenPattern(OBJECT_SELF, "500 Number 29", 500089);
    SetListenPattern(OBJECT_SELF, "500 Number 30", 500090);
    SetListenPattern(OBJECT_SELF, "500 Number 31", 500091);
    SetListenPattern(OBJECT_SELF, "500 Number 32", 500092);
    SetListenPattern(OBJECT_SELF, "500 Number 33", 500093);
    SetListenPattern(OBJECT_SELF, "500 Number 34", 500094);
    SetListenPattern(OBJECT_SELF, "500 Number 35", 500095);
    SetListenPattern(OBJECT_SELF, "500 Number 36", 500096);
    SetListenPattern(OBJECT_SELF, "500 Split 0 00", 500097);
    SetListenPattern(OBJECT_SELF, "500 Split 0 1", 500098);
    SetListenPattern(OBJECT_SELF, "500 Split 0 2", 500099);
    SetListenPattern(OBJECT_SELF, "500 Split 00 2", 500100);
    SetListenPattern(OBJECT_SELF, "500 Split 00 3", 500101);
    SetListenPattern(OBJECT_SELF, "500 Split 1 2", 500102);
    SetListenPattern(OBJECT_SELF, "500 Split 1 4", 500103);
    SetListenPattern(OBJECT_SELF, "500 Split 2 3", 500104);
    SetListenPattern(OBJECT_SELF, "500 Split 2 5", 500105);
    SetListenPattern(OBJECT_SELF, "500 Split 3 6", 500106);
    SetListenPattern(OBJECT_SELF, "500 Split 4 5", 500107);
    SetListenPattern(OBJECT_SELF, "500 Split 4 7", 500108);
    SetListenPattern(OBJECT_SELF, "500 Split 5 6", 500109);
    SetListenPattern(OBJECT_SELF, "500 Split 5 8", 500110);
    SetListenPattern(OBJECT_SELF, "500 Split 6 9", 500111);
    SetListenPattern(OBJECT_SELF, "500 Split 7 8", 500112);
    SetListenPattern(OBJECT_SELF, "500 Split 7 10", 500113);
    SetListenPattern(OBJECT_SELF, "500 Split 8 9", 500114);
    SetListenPattern(OBJECT_SELF, "500 Split 8 11", 500115);
    SetListenPattern(OBJECT_SELF, "500 Split 9 12", 500116);
    SetListenPattern(OBJECT_SELF, "500 Split 10 11", 500117);
    SetListenPattern(OBJECT_SELF, "500 Split 10 13", 500118);
    SetListenPattern(OBJECT_SELF, "500 Split 11 12", 500119);
    SetListenPattern(OBJECT_SELF, "500 Split 11 14", 500120);
    SetListenPattern(OBJECT_SELF, "500 Split 12 15", 500121);
    SetListenPattern(OBJECT_SELF, "500 Split 13 14", 500122);
    SetListenPattern(OBJECT_SELF, "500 Split 13 16", 500123);
    SetListenPattern(OBJECT_SELF, "500 Split 14 15", 500124);
    SetListenPattern(OBJECT_SELF, "500 Split 14 17", 500125);
    SetListenPattern(OBJECT_SELF, "500 Split 15 18", 500126);
    SetListenPattern(OBJECT_SELF, "500 Split 16 17", 500127);
    SetListenPattern(OBJECT_SELF, "500 Split 16 19", 500128);
    SetListenPattern(OBJECT_SELF, "500 Split 17 18", 500129);
    SetListenPattern(OBJECT_SELF, "500 Split 17 20", 500130);
    SetListenPattern(OBJECT_SELF, "500 Split 18 21", 500131);
    SetListenPattern(OBJECT_SELF, "500 Split 19 20", 500132);
    SetListenPattern(OBJECT_SELF, "500 Split 19 22", 500133);
    SetListenPattern(OBJECT_SELF, "500 Split 20 21", 500134);
    SetListenPattern(OBJECT_SELF, "500 Split 20 23", 500135);
    SetListenPattern(OBJECT_SELF, "500 Split 21 24", 500136);
    SetListenPattern(OBJECT_SELF, "500 Split 22 23", 500137);
    SetListenPattern(OBJECT_SELF, "500 Split 22 25", 500138);
    SetListenPattern(OBJECT_SELF, "500 Split 23 24", 500139);
    SetListenPattern(OBJECT_SELF, "500 Split 23 26", 500140);
    SetListenPattern(OBJECT_SELF, "500 Split 24 27", 500141);
    SetListenPattern(OBJECT_SELF, "500 Split 25 26", 500142);
    SetListenPattern(OBJECT_SELF, "500 Split 25 28", 500143);
    SetListenPattern(OBJECT_SELF, "500 Split 26 27", 500144);
    SetListenPattern(OBJECT_SELF, "500 Split 26 29", 500145);
    SetListenPattern(OBJECT_SELF, "500 Split 27 30", 500146);
    SetListenPattern(OBJECT_SELF, "500 Split 28 29", 500147);
    SetListenPattern(OBJECT_SELF, "500 Split 28 31", 500148);
    SetListenPattern(OBJECT_SELF, "500 Split 29 30", 500149);
    SetListenPattern(OBJECT_SELF, "500 Split 29 32", 500150);
    SetListenPattern(OBJECT_SELF, "500 Split 30 33", 500151);
    SetListenPattern(OBJECT_SELF, "500 Split 31 33", 500152);
    SetListenPattern(OBJECT_SELF, "500 Split 31 34", 500153);
    SetListenPattern(OBJECT_SELF, "500 Split 32 33", 500154);
    SetListenPattern(OBJECT_SELF, "500 Split 32 35", 500155);
    SetListenPattern(OBJECT_SELF, "500 Split 33 36", 500156);
    SetListenPattern(OBJECT_SELF, "500 Split 34 35", 500157);
    SetListenPattern(OBJECT_SELF, "500 Split 35 36", 500158);
    }
if (nBet1000)
    {
    SetListenPattern(OBJECT_SELF, "1000 Five", 1000001);
    SetListenPattern(OBJECT_SELF, "1000 Red", 1000002);
    SetListenPattern(OBJECT_SELF, "1000 Black", 1000003);
    SetListenPattern(OBJECT_SELF, "1000 Odd", 1000004);
    SetListenPattern(OBJECT_SELF, "1000 Even", 1000005);
    SetListenPattern(OBJECT_SELF, "1000 High", 1000006);
    SetListenPattern(OBJECT_SELF, "1000 Low", 1000007);
    SetListenPattern(OBJECT_SELF, "1000 Column 1", 1000008);
    SetListenPattern(OBJECT_SELF, "1000 Column 2", 1000009);
    SetListenPattern(OBJECT_SELF, "1000 Column 3", 1000010);
    SetListenPattern(OBJECT_SELF, "1000 Dozen 1", 1000011);
    SetListenPattern(OBJECT_SELF, "1000 Dozen 2", 1000012);
    SetListenPattern(OBJECT_SELF, "1000 Dozen 3", 1000013);
    SetListenPattern(OBJECT_SELF, "1000 Line 1-6", 1000014);
    SetListenPattern(OBJECT_SELF, "1000 Line 4-9", 1000015);
    SetListenPattern(OBJECT_SELF, "1000 Line 7-12", 1000016);
    SetListenPattern(OBJECT_SELF, "1000 Line 10-15", 1000017);
    SetListenPattern(OBJECT_SELF, "1000 Line 13-18", 1000018);
    SetListenPattern(OBJECT_SELF, "1000 Line 16-21", 1000019);
    SetListenPattern(OBJECT_SELF, "1000 Line 19-24", 1000020);
    SetListenPattern(OBJECT_SELF, "1000 Line 22-27", 1000021);
    SetListenPattern(OBJECT_SELF, "1000 Line 25-30", 1000022);
    SetListenPattern(OBJECT_SELF, "1000 Line 28-33", 1000023);
    SetListenPattern(OBJECT_SELF, "1000 Line 31-36", 1000024);
    SetListenPattern(OBJECT_SELF, "1000 Street 1-3", 1000025);
    SetListenPattern(OBJECT_SELF, "1000 Street 4-6", 1000026);
    SetListenPattern(OBJECT_SELF, "1000 Street 7-9", 1000027);
    SetListenPattern(OBJECT_SELF, "1000 Street 10-12", 1000028);
    SetListenPattern(OBJECT_SELF, "1000 Street 13-15", 1000029);
    SetListenPattern(OBJECT_SELF, "1000 Street 16-18", 1000030);
    SetListenPattern(OBJECT_SELF, "1000 Street 19-21", 1000031);
    SetListenPattern(OBJECT_SELF, "1000 Street 22-24", 1000032);
    SetListenPattern(OBJECT_SELF, "1000 Street 25-27", 1000033);
    SetListenPattern(OBJECT_SELF, "1000 Street 28-30", 1000034);
    SetListenPattern(OBJECT_SELF, "1000 Street 31-33", 1000035);
    SetListenPattern(OBJECT_SELF, "1000 Street 34-36", 1000036);
    SetListenPattern(OBJECT_SELF, "1000 Corner 1-5", 1000037);
    SetListenPattern(OBJECT_SELF, "1000 Corner 2-6", 1000038);
    SetListenPattern(OBJECT_SELF, "1000 Corner 4-8", 1000039);
    SetListenPattern(OBJECT_SELF, "1000 Corner 5-9", 1000040);
    SetListenPattern(OBJECT_SELF, "1000 Corner 7-11", 1000041);
    SetListenPattern(OBJECT_SELF, "1000 Corner 8-12", 1000042);
    SetListenPattern(OBJECT_SELF, "1000 Corner 10-14", 1000043);
    SetListenPattern(OBJECT_SELF, "1000 Corner 11-15", 1000044);
    SetListenPattern(OBJECT_SELF, "1000 Corner 13-17", 1000045);
    SetListenPattern(OBJECT_SELF, "1000 Corner 14-18", 1000046);
    SetListenPattern(OBJECT_SELF, "1000 Corner 16-20", 1000047);
    SetListenPattern(OBJECT_SELF, "1000 Corner 17-21", 1000048);
    SetListenPattern(OBJECT_SELF, "1000 Corner 19-23", 1000049);
    SetListenPattern(OBJECT_SELF, "1000 Corner 20-24", 1000050);
    SetListenPattern(OBJECT_SELF, "1000 Corner 22-26", 1000051);
    SetListenPattern(OBJECT_SELF, "1000 Corner 23-27", 1000052);
    SetListenPattern(OBJECT_SELF, "1000 Corner 25-29", 1000053);
    SetListenPattern(OBJECT_SELF, "1000 Corner 26-30", 1000054);
    SetListenPattern(OBJECT_SELF, "1000 Corner 28-32", 1000055);
    SetListenPattern(OBJECT_SELF, "1000 Corner 29-33", 1000056);
    SetListenPattern(OBJECT_SELF, "1000 Corner 31-35", 1000057);
    SetListenPattern(OBJECT_SELF, "1000 Corner 32-36", 1000058);
    SetListenPattern(OBJECT_SELF, "1000 Number 0", 1000059);
    SetListenPattern(OBJECT_SELF, "1000 Number 00", 1000060);
    SetListenPattern(OBJECT_SELF, "1000 Number 1", 1000061);
    SetListenPattern(OBJECT_SELF, "1000 Number 2", 1000062);
    SetListenPattern(OBJECT_SELF, "1000 Number 3", 1000063);
    SetListenPattern(OBJECT_SELF, "1000 Number 4", 1000064);
    SetListenPattern(OBJECT_SELF, "1000 Number 5", 1000065);
    SetListenPattern(OBJECT_SELF, "1000 Number 6", 1000066);
    SetListenPattern(OBJECT_SELF, "1000 Number 7", 1000067);
    SetListenPattern(OBJECT_SELF, "1000 Number 8", 1000068);
    SetListenPattern(OBJECT_SELF, "1000 Number 9", 1000069);
    SetListenPattern(OBJECT_SELF, "1000 Number 10", 1000070);
    SetListenPattern(OBJECT_SELF, "1000 Number 11", 1000071);
    SetListenPattern(OBJECT_SELF, "1000 Number 12", 1000072);
    SetListenPattern(OBJECT_SELF, "1000 Number 13", 1000073);
    SetListenPattern(OBJECT_SELF, "1000 Number 14", 1000074);
    SetListenPattern(OBJECT_SELF, "1000 Number 15", 1000075);
    SetListenPattern(OBJECT_SELF, "1000 Number 16", 1000076);
    SetListenPattern(OBJECT_SELF, "1000 Number 17", 1000077);
    SetListenPattern(OBJECT_SELF, "1000 Number 18", 1000078);
    SetListenPattern(OBJECT_SELF, "1000 Number 19", 1000079);
    SetListenPattern(OBJECT_SELF, "1000 Number 20", 1000080);
    SetListenPattern(OBJECT_SELF, "1000 Number 21", 1000081);
    SetListenPattern(OBJECT_SELF, "1000 Number 22", 1000082);
    SetListenPattern(OBJECT_SELF, "1000 Number 23", 1000083);
    SetListenPattern(OBJECT_SELF, "1000 Number 24", 1000084);
    SetListenPattern(OBJECT_SELF, "1000 Number 25", 1000085);
    SetListenPattern(OBJECT_SELF, "1000 Number 26", 1000086);
    SetListenPattern(OBJECT_SELF, "1000 Number 27", 1000087);
    SetListenPattern(OBJECT_SELF, "1000 Number 28", 1000088);
    SetListenPattern(OBJECT_SELF, "1000 Number 29", 1000089);
    SetListenPattern(OBJECT_SELF, "1000 Number 30", 1000090);
    SetListenPattern(OBJECT_SELF, "1000 Number 31", 1000091);
    SetListenPattern(OBJECT_SELF, "1000 Number 32", 1000092);
    SetListenPattern(OBJECT_SELF, "1000 Number 33", 1000093);
    SetListenPattern(OBJECT_SELF, "1000 Number 34", 1000094);
    SetListenPattern(OBJECT_SELF, "1000 Number 35", 1000095);
    SetListenPattern(OBJECT_SELF, "1000 Number 36", 1000096);
    SetListenPattern(OBJECT_SELF, "1000 Split 0 00", 1000097);
    SetListenPattern(OBJECT_SELF, "1000 Split 0 1", 1000098);
    SetListenPattern(OBJECT_SELF, "1000 Split 0 2", 1000099);
    SetListenPattern(OBJECT_SELF, "1000 Split 00 2", 1000100);
    SetListenPattern(OBJECT_SELF, "1000 Split 00 3", 1000101);
    SetListenPattern(OBJECT_SELF, "1000 Split 1 2", 1000102);
    SetListenPattern(OBJECT_SELF, "1000 Split 1 4", 1000103);
    SetListenPattern(OBJECT_SELF, "1000 Split 2 3", 1000104);
    SetListenPattern(OBJECT_SELF, "1000 Split 2 5", 1000105);
    SetListenPattern(OBJECT_SELF, "1000 Split 3 6", 1000106);
    SetListenPattern(OBJECT_SELF, "1000 Split 4 5", 1000107);
    SetListenPattern(OBJECT_SELF, "1000 Split 4 7", 1000108);
    SetListenPattern(OBJECT_SELF, "1000 Split 5 6", 1000109);
    SetListenPattern(OBJECT_SELF, "1000 Split 5 8", 1000110);
    SetListenPattern(OBJECT_SELF, "1000 Split 6 9", 1000111);
    SetListenPattern(OBJECT_SELF, "1000 Split 7 8", 1000112);
    SetListenPattern(OBJECT_SELF, "1000 Split 7 10", 1000113);
    SetListenPattern(OBJECT_SELF, "1000 Split 8 9", 1000114);
    SetListenPattern(OBJECT_SELF, "1000 Split 8 11", 1000115);
    SetListenPattern(OBJECT_SELF, "1000 Split 9 12", 1000116);
    SetListenPattern(OBJECT_SELF, "1000 Split 10 11", 1000117);
    SetListenPattern(OBJECT_SELF, "1000 Split 10 13", 1000118);
    SetListenPattern(OBJECT_SELF, "1000 Split 11 12", 1000119);
    SetListenPattern(OBJECT_SELF, "1000 Split 11 14", 1000120);
    SetListenPattern(OBJECT_SELF, "1000 Split 12 15", 1000121);
    SetListenPattern(OBJECT_SELF, "1000 Split 13 14", 1000122);
    SetListenPattern(OBJECT_SELF, "1000 Split 13 16", 1000123);
    SetListenPattern(OBJECT_SELF, "1000 Split 14 15", 1000124);
    SetListenPattern(OBJECT_SELF, "1000 Split 14 17", 1000125);
    SetListenPattern(OBJECT_SELF, "1000 Split 15 18", 1000126);
    SetListenPattern(OBJECT_SELF, "1000 Split 16 17", 1000127);
    SetListenPattern(OBJECT_SELF, "1000 Split 16 19", 1000128);
    SetListenPattern(OBJECT_SELF, "1000 Split 17 18", 1000129);
    SetListenPattern(OBJECT_SELF, "1000 Split 17 20", 1000130);
    SetListenPattern(OBJECT_SELF, "1000 Split 18 21", 1000131);
    SetListenPattern(OBJECT_SELF, "1000 Split 19 20", 1000132);
    SetListenPattern(OBJECT_SELF, "1000 Split 19 22", 1000133);
    SetListenPattern(OBJECT_SELF, "1000 Split 20 21", 1000134);
    SetListenPattern(OBJECT_SELF, "1000 Split 20 23", 1000135);
    SetListenPattern(OBJECT_SELF, "1000 Split 21 24", 1000136);
    SetListenPattern(OBJECT_SELF, "1000 Split 22 23", 1000137);
    SetListenPattern(OBJECT_SELF, "1000 Split 22 25", 1000138);
    SetListenPattern(OBJECT_SELF, "1000 Split 23 24", 1000139);
    SetListenPattern(OBJECT_SELF, "1000 Split 23 26", 1000140);
    SetListenPattern(OBJECT_SELF, "1000 Split 24 27", 1000141);
    SetListenPattern(OBJECT_SELF, "1000 Split 25 26", 1000142);
    SetListenPattern(OBJECT_SELF, "1000 Split 25 28", 1000143);
    SetListenPattern(OBJECT_SELF, "1000 Split 26 27", 1000144);
    SetListenPattern(OBJECT_SELF, "1000 Split 26 29", 1000145);
    SetListenPattern(OBJECT_SELF, "1000 Split 27 30", 1000146);
    SetListenPattern(OBJECT_SELF, "1000 Split 28 29", 1000147);
    SetListenPattern(OBJECT_SELF, "1000 Split 28 31", 1000148);
    SetListenPattern(OBJECT_SELF, "1000 Split 29 30", 1000149);
    SetListenPattern(OBJECT_SELF, "1000 Split 29 32", 1000150);
    SetListenPattern(OBJECT_SELF, "1000 Split 30 33", 1000151);
    SetListenPattern(OBJECT_SELF, "1000 Split 31 33", 1000152);
    SetListenPattern(OBJECT_SELF, "1000 Split 31 34", 1000153);
    SetListenPattern(OBJECT_SELF, "1000 Split 32 33", 1000154);
    SetListenPattern(OBJECT_SELF, "1000 Split 32 35", 1000155);
    SetListenPattern(OBJECT_SELF, "1000 Split 33 36", 1000156);
    SetListenPattern(OBJECT_SELF, "1000 Split 34 35", 1000157);
    SetListenPattern(OBJECT_SELF, "1000 Split 35 36", 1000158);
    }
if (nBet5000)
    {
    SetListenPattern(OBJECT_SELF, "5000 Five", 5000001);
    SetListenPattern(OBJECT_SELF, "5000 Red", 5000002);
    SetListenPattern(OBJECT_SELF, "5000 Black", 5000003);
    SetListenPattern(OBJECT_SELF, "5000 Odd", 5000004);
    SetListenPattern(OBJECT_SELF, "5000 Even", 5000005);
    SetListenPattern(OBJECT_SELF, "5000 High", 5000006);
    SetListenPattern(OBJECT_SELF, "5000 Low", 5000007);
    SetListenPattern(OBJECT_SELF, "5000 Column 1", 5000008);
    SetListenPattern(OBJECT_SELF, "5000 Column 2", 5000009);
    SetListenPattern(OBJECT_SELF, "5000 Column 3", 5000010);
    SetListenPattern(OBJECT_SELF, "5000 Dozen 1", 5000011);
    SetListenPattern(OBJECT_SELF, "5000 Dozen 2", 5000012);
    SetListenPattern(OBJECT_SELF, "5000 Dozen 3", 5000013);
    SetListenPattern(OBJECT_SELF, "5000 Line 1-6", 5000014);
    SetListenPattern(OBJECT_SELF, "5000 Line 4-9", 5000015);
    SetListenPattern(OBJECT_SELF, "5000 Line 7-12", 5000016);
    SetListenPattern(OBJECT_SELF, "5000 Line 10-15", 5000017);
    SetListenPattern(OBJECT_SELF, "5000 Line 13-18", 5000018);
    SetListenPattern(OBJECT_SELF, "5000 Line 16-21", 5000019);
    SetListenPattern(OBJECT_SELF, "5000 Line 19-24", 5000020);
    SetListenPattern(OBJECT_SELF, "5000 Line 22-27", 5000021);
    SetListenPattern(OBJECT_SELF, "5000 Line 25-30", 5000022);
    SetListenPattern(OBJECT_SELF, "5000 Line 28-33", 5000023);
    SetListenPattern(OBJECT_SELF, "5000 Line 31-36", 5000024);
    SetListenPattern(OBJECT_SELF, "5000 Street 1-3", 5000025);
    SetListenPattern(OBJECT_SELF, "5000 Street 4-6", 5000026);
    SetListenPattern(OBJECT_SELF, "5000 Street 7-9", 5000027);
    SetListenPattern(OBJECT_SELF, "5000 Street 10-12", 5000028);
    SetListenPattern(OBJECT_SELF, "5000 Street 13-15", 5000029);
    SetListenPattern(OBJECT_SELF, "5000 Street 16-18", 5000030);
    SetListenPattern(OBJECT_SELF, "5000 Street 19-21", 5000031);
    SetListenPattern(OBJECT_SELF, "5000 Street 22-24", 5000032);
    SetListenPattern(OBJECT_SELF, "5000 Street 25-27", 5000033);
    SetListenPattern(OBJECT_SELF, "5000 Street 28-30", 5000034);
    SetListenPattern(OBJECT_SELF, "5000 Street 31-33", 5000035);
    SetListenPattern(OBJECT_SELF, "5000 Street 34-36", 5000036);
    SetListenPattern(OBJECT_SELF, "5000 Corner 1-5", 5000037);
    SetListenPattern(OBJECT_SELF, "5000 Corner 2-6", 5000038);
    SetListenPattern(OBJECT_SELF, "5000 Corner 4-8", 5000039);
    SetListenPattern(OBJECT_SELF, "5000 Corner 5-9", 5000040);
    SetListenPattern(OBJECT_SELF, "5000 Corner 7-11", 5000041);
    SetListenPattern(OBJECT_SELF, "5000 Corner 8-12", 5000042);
    SetListenPattern(OBJECT_SELF, "5000 Corner 10-14", 5000043);
    SetListenPattern(OBJECT_SELF, "5000 Corner 11-15", 5000044);
    SetListenPattern(OBJECT_SELF, "5000 Corner 13-17", 5000045);
    SetListenPattern(OBJECT_SELF, "5000 Corner 14-18", 5000046);
    SetListenPattern(OBJECT_SELF, "5000 Corner 16-20", 5000047);
    SetListenPattern(OBJECT_SELF, "5000 Corner 17-21", 5000048);
    SetListenPattern(OBJECT_SELF, "5000 Corner 19-23", 5000049);
    SetListenPattern(OBJECT_SELF, "5000 Corner 20-24", 5000050);
    SetListenPattern(OBJECT_SELF, "5000 Corner 22-26", 5000051);
    SetListenPattern(OBJECT_SELF, "5000 Corner 23-27", 5000052);
    SetListenPattern(OBJECT_SELF, "5000 Corner 25-29", 5000053);
    SetListenPattern(OBJECT_SELF, "5000 Corner 26-30", 5000054);
    SetListenPattern(OBJECT_SELF, "5000 Corner 28-32", 5000055);
    SetListenPattern(OBJECT_SELF, "5000 Corner 29-33", 5000056);
    SetListenPattern(OBJECT_SELF, "5000 Corner 31-35", 5000057);
    SetListenPattern(OBJECT_SELF, "5000 Corner 32-36", 5000058);
    SetListenPattern(OBJECT_SELF, "5000 Number 0", 5000059);
    SetListenPattern(OBJECT_SELF, "5000 Number 00", 5000060);
    SetListenPattern(OBJECT_SELF, "5000 Number 1", 5000061);
    SetListenPattern(OBJECT_SELF, "5000 Number 2", 5000062);
    SetListenPattern(OBJECT_SELF, "5000 Number 3", 5000063);
    SetListenPattern(OBJECT_SELF, "5000 Number 4", 5000064);
    SetListenPattern(OBJECT_SELF, "5000 Number 5", 5000065);
    SetListenPattern(OBJECT_SELF, "5000 Number 6", 5000066);
    SetListenPattern(OBJECT_SELF, "5000 Number 7", 5000067);
    SetListenPattern(OBJECT_SELF, "5000 Number 8", 5000068);
    SetListenPattern(OBJECT_SELF, "5000 Number 9", 5000069);
    SetListenPattern(OBJECT_SELF, "5000 Number 10", 5000070);
    SetListenPattern(OBJECT_SELF, "5000 Number 11", 5000071);
    SetListenPattern(OBJECT_SELF, "5000 Number 12", 5000072);
    SetListenPattern(OBJECT_SELF, "5000 Number 13", 5000073);
    SetListenPattern(OBJECT_SELF, "5000 Number 14", 5000074);
    SetListenPattern(OBJECT_SELF, "5000 Number 15", 5000075);
    SetListenPattern(OBJECT_SELF, "5000 Number 16", 5000076);
    SetListenPattern(OBJECT_SELF, "5000 Number 17", 5000077);
    SetListenPattern(OBJECT_SELF, "5000 Number 18", 5000078);
    SetListenPattern(OBJECT_SELF, "5000 Number 19", 5000079);
    SetListenPattern(OBJECT_SELF, "5000 Number 20", 5000080);
    SetListenPattern(OBJECT_SELF, "5000 Number 21", 5000081);
    SetListenPattern(OBJECT_SELF, "5000 Number 22", 5000082);
    SetListenPattern(OBJECT_SELF, "5000 Number 23", 5000083);
    SetListenPattern(OBJECT_SELF, "5000 Number 24", 5000084);
    SetListenPattern(OBJECT_SELF, "5000 Number 25", 5000085);
    SetListenPattern(OBJECT_SELF, "5000 Number 26", 5000086);
    SetListenPattern(OBJECT_SELF, "5000 Number 27", 5000087);
    SetListenPattern(OBJECT_SELF, "5000 Number 28", 5000088);
    SetListenPattern(OBJECT_SELF, "5000 Number 29", 5000089);
    SetListenPattern(OBJECT_SELF, "5000 Number 30", 5000090);
    SetListenPattern(OBJECT_SELF, "5000 Number 31", 5000091);
    SetListenPattern(OBJECT_SELF, "5000 Number 32", 5000092);
    SetListenPattern(OBJECT_SELF, "5000 Number 33", 5000093);
    SetListenPattern(OBJECT_SELF, "5000 Number 34", 5000094);
    SetListenPattern(OBJECT_SELF, "5000 Number 35", 5000095);
    SetListenPattern(OBJECT_SELF, "5000 Number 36", 5000096);
    SetListenPattern(OBJECT_SELF, "5000 Split 0 00", 5000097);
    SetListenPattern(OBJECT_SELF, "5000 Split 0 1", 5000098);
    SetListenPattern(OBJECT_SELF, "5000 Split 0 2", 5000099);
    SetListenPattern(OBJECT_SELF, "5000 Split 00 2", 5000100);
    SetListenPattern(OBJECT_SELF, "5000 Split 00 3", 5000101);
    SetListenPattern(OBJECT_SELF, "5000 Split 1 2", 5000102);
    SetListenPattern(OBJECT_SELF, "5000 Split 1 4", 5000103);
    SetListenPattern(OBJECT_SELF, "5000 Split 2 3", 5000104);
    SetListenPattern(OBJECT_SELF, "5000 Split 2 5", 5000105);
    SetListenPattern(OBJECT_SELF, "5000 Split 3 6", 5000106);
    SetListenPattern(OBJECT_SELF, "5000 Split 4 5", 5000107);
    SetListenPattern(OBJECT_SELF, "5000 Split 4 7", 5000108);
    SetListenPattern(OBJECT_SELF, "5000 Split 5 6", 5000109);
    SetListenPattern(OBJECT_SELF, "5000 Split 5 8", 5000110);
    SetListenPattern(OBJECT_SELF, "5000 Split 6 9", 5000111);
    SetListenPattern(OBJECT_SELF, "5000 Split 7 8", 5000112);
    SetListenPattern(OBJECT_SELF, "5000 Split 7 10", 5000113);
    SetListenPattern(OBJECT_SELF, "5000 Split 8 9", 5000114);
    SetListenPattern(OBJECT_SELF, "5000 Split 8 11", 5000115);
    SetListenPattern(OBJECT_SELF, "5000 Split 9 12", 5000116);
    SetListenPattern(OBJECT_SELF, "5000 Split 10 11", 5000117);
    SetListenPattern(OBJECT_SELF, "5000 Split 10 13", 5000118);
    SetListenPattern(OBJECT_SELF, "5000 Split 11 12", 5000119);
    SetListenPattern(OBJECT_SELF, "5000 Split 11 14", 5000120);
    SetListenPattern(OBJECT_SELF, "5000 Split 12 15", 5000121);
    SetListenPattern(OBJECT_SELF, "5000 Split 13 14", 5000122);
    SetListenPattern(OBJECT_SELF, "5000 Split 13 16", 5000123);
    SetListenPattern(OBJECT_SELF, "5000 Split 14 15", 5000124);
    SetListenPattern(OBJECT_SELF, "5000 Split 14 17", 5000125);
    SetListenPattern(OBJECT_SELF, "5000 Split 15 18", 5000126);
    SetListenPattern(OBJECT_SELF, "5000 Split 16 17", 5000127);
    SetListenPattern(OBJECT_SELF, "5000 Split 16 19", 5000128);
    SetListenPattern(OBJECT_SELF, "5000 Split 17 18", 5000129);
    SetListenPattern(OBJECT_SELF, "5000 Split 17 20", 5000130);
    SetListenPattern(OBJECT_SELF, "5000 Split 18 21", 5000131);
    SetListenPattern(OBJECT_SELF, "5000 Split 19 20", 5000132);
    SetListenPattern(OBJECT_SELF, "5000 Split 19 22", 5000133);
    SetListenPattern(OBJECT_SELF, "5000 Split 20 21", 5000134);
    SetListenPattern(OBJECT_SELF, "5000 Split 20 23", 5000135);
    SetListenPattern(OBJECT_SELF, "5000 Split 21 24", 5000136);
    SetListenPattern(OBJECT_SELF, "5000 Split 22 23", 5000137);
    SetListenPattern(OBJECT_SELF, "5000 Split 22 25", 5000138);
    SetListenPattern(OBJECT_SELF, "5000 Split 23 24", 5000139);
    SetListenPattern(OBJECT_SELF, "5000 Split 23 26", 5000140);
    SetListenPattern(OBJECT_SELF, "5000 Split 24 27", 5000141);
    SetListenPattern(OBJECT_SELF, "5000 Split 25 26", 5000142);
    SetListenPattern(OBJECT_SELF, "5000 Split 25 28", 5000143);
    SetListenPattern(OBJECT_SELF, "5000 Split 26 27", 5000144);
    SetListenPattern(OBJECT_SELF, "5000 Split 26 29", 5000145);
    SetListenPattern(OBJECT_SELF, "5000 Split 27 30", 5000146);
    SetListenPattern(OBJECT_SELF, "5000 Split 28 29", 5000147);
    SetListenPattern(OBJECT_SELF, "5000 Split 28 31", 5000148);
    SetListenPattern(OBJECT_SELF, "5000 Split 29 30", 5000149);
    SetListenPattern(OBJECT_SELF, "5000 Split 29 32", 5000150);
    SetListenPattern(OBJECT_SELF, "5000 Split 30 33", 5000151);
    SetListenPattern(OBJECT_SELF, "5000 Split 31 33", 5000152);
    SetListenPattern(OBJECT_SELF, "5000 Split 31 34", 5000153);
    SetListenPattern(OBJECT_SELF, "5000 Split 32 33", 5000154);
    SetListenPattern(OBJECT_SELF, "5000 Split 32 35", 5000155);
    SetListenPattern(OBJECT_SELF, "5000 Split 33 36", 5000156);
    SetListenPattern(OBJECT_SELF, "5000 Split 34 35", 5000157);
    SetListenPattern(OBJECT_SELF, "5000 Split 35 36", 5000158);
    }
if (nBet10000)
    {
    SetListenPattern(OBJECT_SELF, "10000 Five", 10000001);
    SetListenPattern(OBJECT_SELF, "10000 Red", 10000002);
    SetListenPattern(OBJECT_SELF, "10000 Black", 10000003);
    SetListenPattern(OBJECT_SELF, "10000 Odd", 10000004);
    SetListenPattern(OBJECT_SELF, "10000 Even", 10000005);
    SetListenPattern(OBJECT_SELF, "10000 High", 10000006);
    SetListenPattern(OBJECT_SELF, "10000 Low", 10000007);
    SetListenPattern(OBJECT_SELF, "10000 Column 1", 10000008);
    SetListenPattern(OBJECT_SELF, "10000 Column 2", 10000009);
    SetListenPattern(OBJECT_SELF, "10000 Column 3", 10000010);
    SetListenPattern(OBJECT_SELF, "10000 Dozen 1", 10000011);
    SetListenPattern(OBJECT_SELF, "10000 Dozen 2", 10000012);
    SetListenPattern(OBJECT_SELF, "10000 Dozen 3", 10000013);
    SetListenPattern(OBJECT_SELF, "10000 Line 1-6", 10000014);
    SetListenPattern(OBJECT_SELF, "10000 Line 4-9", 10000015);
    SetListenPattern(OBJECT_SELF, "10000 Line 7-12", 10000016);
    SetListenPattern(OBJECT_SELF, "10000 Line 10-15", 10000017);
    SetListenPattern(OBJECT_SELF, "10000 Line 13-18", 10000018);
    SetListenPattern(OBJECT_SELF, "10000 Line 16-21", 10000019);
    SetListenPattern(OBJECT_SELF, "10000 Line 19-24", 10000020);
    SetListenPattern(OBJECT_SELF, "10000 Line 22-27", 10000021);
    SetListenPattern(OBJECT_SELF, "10000 Line 25-30", 10000022);
    SetListenPattern(OBJECT_SELF, "10000 Line 28-33", 10000023);
    SetListenPattern(OBJECT_SELF, "10000 Line 31-36", 10000024);
    SetListenPattern(OBJECT_SELF, "10000 Street 1-3", 10000025);
    SetListenPattern(OBJECT_SELF, "10000 Street 4-6", 10000026);
    SetListenPattern(OBJECT_SELF, "10000 Street 7-9", 10000027);
    SetListenPattern(OBJECT_SELF, "10000 Street 10-12", 10000028);
    SetListenPattern(OBJECT_SELF, "10000 Street 13-15", 10000029);
    SetListenPattern(OBJECT_SELF, "10000 Street 16-18", 10000030);
    SetListenPattern(OBJECT_SELF, "10000 Street 19-21", 10000031);
    SetListenPattern(OBJECT_SELF, "10000 Street 22-24", 10000032);
    SetListenPattern(OBJECT_SELF, "10000 Street 25-27", 10000033);
    SetListenPattern(OBJECT_SELF, "10000 Street 28-30", 10000034);
    SetListenPattern(OBJECT_SELF, "10000 Street 31-33", 10000035);
    SetListenPattern(OBJECT_SELF, "10000 Street 34-36", 10000036);
    SetListenPattern(OBJECT_SELF, "10000 Corner 1-5", 10000037);
    SetListenPattern(OBJECT_SELF, "10000 Corner 2-6", 10000038);
    SetListenPattern(OBJECT_SELF, "10000 Corner 4-8", 10000039);
    SetListenPattern(OBJECT_SELF, "10000 Corner 5-9", 10000040);
    SetListenPattern(OBJECT_SELF, "10000 Corner 7-11", 10000041);
    SetListenPattern(OBJECT_SELF, "10000 Corner 8-12", 10000042);
    SetListenPattern(OBJECT_SELF, "10000 Corner 10-14", 10000043);
    SetListenPattern(OBJECT_SELF, "10000 Corner 11-15", 10000044);
    SetListenPattern(OBJECT_SELF, "10000 Corner 13-17", 10000045);
    SetListenPattern(OBJECT_SELF, "10000 Corner 14-18", 10000046);
    SetListenPattern(OBJECT_SELF, "10000 Corner 16-20", 10000047);
    SetListenPattern(OBJECT_SELF, "10000 Corner 17-21", 10000048);
    SetListenPattern(OBJECT_SELF, "10000 Corner 19-23", 10000049);
    SetListenPattern(OBJECT_SELF, "10000 Corner 20-24", 10000050);
    SetListenPattern(OBJECT_SELF, "10000 Corner 22-26", 10000051);
    SetListenPattern(OBJECT_SELF, "10000 Corner 23-27", 10000052);
    SetListenPattern(OBJECT_SELF, "10000 Corner 25-29", 10000053);
    SetListenPattern(OBJECT_SELF, "10000 Corner 26-30", 10000054);
    SetListenPattern(OBJECT_SELF, "10000 Corner 28-32", 10000055);
    SetListenPattern(OBJECT_SELF, "10000 Corner 29-33", 10000056);
    SetListenPattern(OBJECT_SELF, "10000 Corner 31-35", 10000057);
    SetListenPattern(OBJECT_SELF, "10000 Corner 32-36", 10000058);
    SetListenPattern(OBJECT_SELF, "10000 Number 0", 10000059);
    SetListenPattern(OBJECT_SELF, "10000 Number 00", 10000060);
    SetListenPattern(OBJECT_SELF, "10000 Number 1", 10000061);
    SetListenPattern(OBJECT_SELF, "10000 Number 2", 10000062);
    SetListenPattern(OBJECT_SELF, "10000 Number 3", 10000063);
    SetListenPattern(OBJECT_SELF, "10000 Number 4", 10000064);
    SetListenPattern(OBJECT_SELF, "10000 Number 5", 10000065);
    SetListenPattern(OBJECT_SELF, "10000 Number 6", 10000066);
    SetListenPattern(OBJECT_SELF, "10000 Number 7", 10000067);
    SetListenPattern(OBJECT_SELF, "10000 Number 8", 10000068);
    SetListenPattern(OBJECT_SELF, "10000 Number 9", 10000069);
    SetListenPattern(OBJECT_SELF, "10000 Number 10", 10000070);
    SetListenPattern(OBJECT_SELF, "10000 Number 11", 10000071);
    SetListenPattern(OBJECT_SELF, "10000 Number 12", 10000072);
    SetListenPattern(OBJECT_SELF, "10000 Number 13", 10000073);
    SetListenPattern(OBJECT_SELF, "10000 Number 14", 10000074);
    SetListenPattern(OBJECT_SELF, "10000 Number 15", 10000075);
    SetListenPattern(OBJECT_SELF, "10000 Number 16", 10000076);
    SetListenPattern(OBJECT_SELF, "10000 Number 17", 10000077);
    SetListenPattern(OBJECT_SELF, "10000 Number 18", 10000078);
    SetListenPattern(OBJECT_SELF, "10000 Number 19", 10000079);
    SetListenPattern(OBJECT_SELF, "10000 Number 20", 10000080);
    SetListenPattern(OBJECT_SELF, "10000 Number 21", 10000081);
    SetListenPattern(OBJECT_SELF, "10000 Number 22", 10000082);
    SetListenPattern(OBJECT_SELF, "10000 Number 23", 10000083);
    SetListenPattern(OBJECT_SELF, "10000 Number 24", 10000084);
    SetListenPattern(OBJECT_SELF, "10000 Number 25", 10000085);
    SetListenPattern(OBJECT_SELF, "10000 Number 26", 10000086);
    SetListenPattern(OBJECT_SELF, "10000 Number 27", 10000087);
    SetListenPattern(OBJECT_SELF, "10000 Number 28", 10000088);
    SetListenPattern(OBJECT_SELF, "10000 Number 29", 10000089);
    SetListenPattern(OBJECT_SELF, "10000 Number 30", 10000090);
    SetListenPattern(OBJECT_SELF, "10000 Number 31", 10000091);
    SetListenPattern(OBJECT_SELF, "10000 Number 32", 10000092);
    SetListenPattern(OBJECT_SELF, "10000 Number 33", 10000093);
    SetListenPattern(OBJECT_SELF, "10000 Number 34", 10000094);
    SetListenPattern(OBJECT_SELF, "10000 Number 35", 10000095);
    SetListenPattern(OBJECT_SELF, "10000 Number 36", 10000096);
    SetListenPattern(OBJECT_SELF, "10000 Split 0 00", 10000097);
    SetListenPattern(OBJECT_SELF, "10000 Split 0 1", 10000098);
    SetListenPattern(OBJECT_SELF, "10000 Split 0 2", 10000099);
    SetListenPattern(OBJECT_SELF, "10000 Split 00 2", 10000100);
    SetListenPattern(OBJECT_SELF, "10000 Split 00 3", 10000101);
    SetListenPattern(OBJECT_SELF, "10000 Split 1 2", 10000102);
    SetListenPattern(OBJECT_SELF, "10000 Split 1 4", 10000103);
    SetListenPattern(OBJECT_SELF, "10000 Split 2 3", 10000104);
    SetListenPattern(OBJECT_SELF, "10000 Split 2 5", 10000105);
    SetListenPattern(OBJECT_SELF, "10000 Split 3 6", 10000106);
    SetListenPattern(OBJECT_SELF, "10000 Split 4 5", 10000107);
    SetListenPattern(OBJECT_SELF, "10000 Split 4 7", 10000108);
    SetListenPattern(OBJECT_SELF, "10000 Split 5 6", 10000109);
    SetListenPattern(OBJECT_SELF, "10000 Split 5 8", 10000110);
    SetListenPattern(OBJECT_SELF, "10000 Split 6 9", 10000111);
    SetListenPattern(OBJECT_SELF, "10000 Split 7 8", 10000112);
    SetListenPattern(OBJECT_SELF, "10000 Split 7 10", 10000113);
    SetListenPattern(OBJECT_SELF, "10000 Split 8 9", 10000114);
    SetListenPattern(OBJECT_SELF, "10000 Split 8 11", 10000115);
    SetListenPattern(OBJECT_SELF, "10000 Split 9 12", 10000116);
    SetListenPattern(OBJECT_SELF, "10000 Split 10 11", 10000117);
    SetListenPattern(OBJECT_SELF, "10000 Split 10 13", 10000118);
    SetListenPattern(OBJECT_SELF, "10000 Split 11 12", 10000119);
    SetListenPattern(OBJECT_SELF, "10000 Split 11 14", 10000120);
    SetListenPattern(OBJECT_SELF, "10000 Split 12 15", 10000121);
    SetListenPattern(OBJECT_SELF, "10000 Split 13 14", 10000122);
    SetListenPattern(OBJECT_SELF, "10000 Split 13 16", 10000123);
    SetListenPattern(OBJECT_SELF, "10000 Split 14 15", 10000124);
    SetListenPattern(OBJECT_SELF, "10000 Split 14 17", 10000125);
    SetListenPattern(OBJECT_SELF, "10000 Split 15 18", 10000126);
    SetListenPattern(OBJECT_SELF, "10000 Split 16 17", 10000127);
    SetListenPattern(OBJECT_SELF, "10000 Split 16 19", 10000128);
    SetListenPattern(OBJECT_SELF, "10000 Split 17 18", 10000129);
    SetListenPattern(OBJECT_SELF, "10000 Split 17 20", 10000130);
    SetListenPattern(OBJECT_SELF, "10000 Split 18 21", 10000131);
    SetListenPattern(OBJECT_SELF, "10000 Split 19 20", 10000132);
    SetListenPattern(OBJECT_SELF, "10000 Split 19 22", 10000133);
    SetListenPattern(OBJECT_SELF, "10000 Split 20 21", 10000134);
    SetListenPattern(OBJECT_SELF, "10000 Split 20 23", 10000135);
    SetListenPattern(OBJECT_SELF, "10000 Split 21 24", 10000136);
    SetListenPattern(OBJECT_SELF, "10000 Split 22 23", 10000137);
    SetListenPattern(OBJECT_SELF, "10000 Split 22 25", 10000138);
    SetListenPattern(OBJECT_SELF, "10000 Split 23 24", 10000139);
    SetListenPattern(OBJECT_SELF, "10000 Split 23 26", 10000140);
    SetListenPattern(OBJECT_SELF, "10000 Split 24 27", 10000141);
    SetListenPattern(OBJECT_SELF, "10000 Split 25 26", 10000142);
    SetListenPattern(OBJECT_SELF, "10000 Split 25 28", 10000143);
    SetListenPattern(OBJECT_SELF, "10000 Split 26 27", 10000144);
    SetListenPattern(OBJECT_SELF, "10000 Split 26 29", 10000145);
    SetListenPattern(OBJECT_SELF, "10000 Split 27 30", 10000146);
    SetListenPattern(OBJECT_SELF, "10000 Split 28 29", 10000147);
    SetListenPattern(OBJECT_SELF, "10000 Split 28 31", 10000148);
    SetListenPattern(OBJECT_SELF, "10000 Split 29 30", 10000149);
    SetListenPattern(OBJECT_SELF, "10000 Split 29 32", 10000150);
    SetListenPattern(OBJECT_SELF, "10000 Split 30 33", 10000151);
    SetListenPattern(OBJECT_SELF, "10000 Split 31 33", 10000152);
    SetListenPattern(OBJECT_SELF, "10000 Split 31 34", 10000153);
    SetListenPattern(OBJECT_SELF, "10000 Split 32 33", 10000154);
    SetListenPattern(OBJECT_SELF, "10000 Split 32 35", 10000155);
    SetListenPattern(OBJECT_SELF, "10000 Split 33 36", 10000156);
    SetListenPattern(OBJECT_SELF, "10000 Split 34 35", 10000157);
    SetListenPattern(OBJECT_SELF, "10000 Split 35 36", 10000158);
    }
}


