//::////////////////////////////////////////////////////////////////////////////
//:: TGW_OU_ALEKEG
/*
  slightly modified by caesarbear

  Synopsis: A PC clicks on a keg of ale.  If the PC has an empty bottle and 1gp,
  the PC exchanges the empty bottle for a bottle of ale and a message is sent
  to the PC.  If the PC is without either bottle or 1gp, a message is sent to
  the PC.  If a non-player character uses the keg, a statement is made by the
  NPC.

  This script is placed in the "OnUsed" script of a useable keg.  The keg needs
  to be placed on a table of some sort.  This makes the scene overall more
  realistic.  The name of the keg should be "Keg of Ale" or something to that
  effect.

  The novice user is encouraged to change any Descretionary Variables
  but should not alter other aspects of this script.

  To see where this script was first used, look for "CEP A TRUE GLOBAL WORLD" in
  the PW Action category online.

 */
//:: Created By: HercNav
//:: Created On: 08/06/2004
//db changes - cb
#include "x4_inc_functions"


void main()
{
//::////////////////////////////////////////////////////////////////////////////
//::////////////////////////////////////////////////////////////////////////////
//Descretionary variables
    //If the user is a non-player character, he/she says the following
    string sNPCSay = "Ahh, now that's a fine ale!";
    //If the PC has no empty bottle, he/she says the following
    string sPCFlask = "You must have an empty stein to use this keg of ale.";
    //If the PC has no money, he/she says the following
    string sPCgp = "You must have 1gp to use this keg of ale.";
    //If the PC has neither the money nor the empty bottle, he/she says the following
    string sPCBoth = "You must have an empty stein to use this keg of ale.";
//::////////////////////////////////////////////////////////////////////////////
//::////////////////////////////////////////////////////////////////////////////

//Non-descretionary variables
    //Designate the user as an object
    object oUser = GetLastUsedBy();
    //Make the empty bottle, owned by the PC, an object
    object oFlask = GetItemPossessedBy(oUser, "bastardalecup");
    int iTab; //for incrementing a "bartab" localint -cb
    //Find out if the user is a non-player character
    if (GetIsPC(oUser) == FALSE)
       {
       //Make the NPC "use" the keg
       AssignCommand(oUser, ActionPlayAnimation(ANIMATION_LOOPING_GET_MID,1.0f,3.0f));
       //Make a sound like hard water pouring
       DelayCommand(1.0f,PlaySound("fs_water_hard1"));
       //Make the NPC say the statement defined above
       AssignCommand(oUser,ActionSpeakString(sNPCSay));
       return;
       }
    //Find out if the user has any money
    if (FALSE) // allowing a tab  -cb
       {
       //Find out if the user has an empty bottle
       if (oFlask == OBJECT_INVALID)
          {
          //Make the PC say the statement defined above for having neither
          AssignCommand(oUser,ActionSpeakString(sPCBoth));
          return;
          }
       //Make the PC say the statement defined above for not having money
       AssignCommand(oUser,ActionSpeakString(sPCgp));
       return;
       }
    //Find out if the user has an empty bottle
    if (oFlask == OBJECT_INVALID)
       {
       //Make the PC say the statement defined above for not having a bottle
       AssignCommand(oUser,ActionSpeakString(sPCFlask));
       return;
       }
    //Make the PC "use" the keg
    AssignCommand(oUser, ActionPlayAnimation(ANIMATION_LOOPING_GET_MID,1.0f,3.0f));
    //Take 1gp from the PC - now a bar tab  -cb
    iTab = GetCampaignInt(CharacterDB(oUser), "BARTAB", oUser);
    iTab++;
    SetCampaignInt(CharacterDB(oUser), "BARTAB", iTab, oUser);
    SetLocalInt(GetModule(), "ZORCOTABSWRITE", 1);
    //Make a sound like hard water pouring
    DelayCommand(1.0f, PlaySound("fs_water_hard1"));
    //Take the empty bottle from the PC
    DestroyObject(oFlask);
    //Give the PC a new bottle of ale
    CreateItemOnObject("bastardale", oUser, 1);
    //Announce that the PC has just poured a fine ale
    DelayCommand(3.0f, FloatingTextStringOnCreature(GetName(oUser) +" pours a fine ale.",oUser,FALSE));
}
