//::////////////////////////////////////////////////////////////////////////////
//:: TGW_OU_JUKEBOX
/*
  Synopsis: A PC clicks on a gnomish contraption.  If the PC has no money,
  he/she states a message.  If the PC has money, a message is stated and the
  music in that area changes.  If the user is a non-player character, he/she
  makes a statement and the music changes.

  This script is placed in the "OnUsed" script of a gnomish contraption (or any
  useable object for that matter.)

  The novice user is encouraged to change any Descretionary Variables
  but should not alter other aspects of this script.

  To see where this object was first used, look for "CEP A TRUE GLOBAL WORLD" in
  the PW Action category online.

 */
//:: Created By: HercNav
//:: Created On: 08/06/2004
void main()
{
//::////////////////////////////////////////////////////////////////////////////
//::////////////////////////////////////////////////////////////////////////////
//Descretionary variables
    //PC makes this statement if he/she has at least one gold piece
    string sPCRich = "This gnomish contraption says it plays a randomly selected song for a gold coin.";
    //PC makes this statement if he/she has no money
    string sPCPoor = "This gnomish contraption says it needs a gold to activate, but I have no money";
    //NPC makes this statement when using the gnomish contraption
    string sNPCSay = "I'm tired of this song.  I think I'll change it...";
//::////////////////////////////////////////////////////////////////////////////
//::////////////////////////////////////////////////////////////////////////////

//Non-descretionary variables
    //There are 75 songs in Neverwinter Nights (HotU and SoU) choose one:
    int iRand;
    switch (Random(5))
    {
    case 0: iRand = 22; break;
    case 1: iRand = 23; break;
    case 2: iRand = 24; break;
    case 3: iRand = 56; break;
    case 4: iRand = 100; break;
    }

    //define the visual effect when used
    effect eMusic =  EffectVisualEffect(VFX_DUR_BARD_SONG);
    //make the last user an object
    object oUser = GetLastUsedBy();
    //make the area an object
    object oArea = GetArea(oUser);
    {
    //Find out if the last user is a PC
    if (GetIsPC(oUser) == TRUE)
       {
       //Find out if the PC has any money
       if (GetGold(oUser) <1)
          {
          //PC makes the "sPCPor" statement and terminate the script
          AssignCommand(oUser,ActionSpeakString(sPCPoor));
          return;
          }
          //PC makes the "sPCRich" statement
          AssignCommand(oUser,ActionSpeakString(sPCRich));
          //Take one gold piece from the PC
          TakeGoldFromCreature(1,oUser);
          //Make the PC act as if he/she is dropping a coin in the machine
          AssignCommand(oUser, ActionPlayAnimation(ANIMATION_LOOPING_GET_LOW,1.0f,3.0f));
          }
    //Find out if the last user is a NPC
    if (GetIsPC(oUser) == FALSE)
       {
       //NPC makes the "sNPCSay" statement
       AssignCommand(oUser,ActionSpeakString(sNPCSay));
       //Make the nPC act as if he/she is dropping a coin in the machine
       AssignCommand(oUser, ActionPlayAnimation(ANIMATION_LOOPING_GET_LOW,1.0f,3.0f));
       }
    //Musical notes come out of the machine
    DelayCommand(3.0f,ApplyEffectToObject(DURATION_TYPE_PERMANENT, eMusic, OBJECT_SELF));
    //Stop whatever music is currently playing
    MusicBackgroundStop(oArea);
    //Change the daytime music in the PC's area
    MusicBackgroundChangeDay(oArea, iRand);
    //Change the nighttime music in the PC's area
    MusicBackgroundChangeNight(oArea, iRand);
    //Play the area's music
    MusicBackgroundPlay(oArea);
    return;
    }
}
