//::///////////////////////////////////////////////
//:: Name x2_def_heartbeat
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Default Heartbeat script
*/
//:://////////////////////////////////////////////
//:: Created By: Keith Warner
//:: Created On: June 11/03
//:://////////////////////////////////////////////

#include "quest_inc"
void main()
{
    string sDB = GetLocalString(GetModule(), "DB");
    string sTown = GetLocalString(OBJECT_SELF, "Town");

    if (GetCampaignInt(sDB, sTown+"_FESTIVAL") == FALSE) DestroyObject(OBJECT_SELF);

    SetLocalInt(OBJECT_SELF, "HenchInv", FALSE);

    if(GetLocalInt(OBJECT_SELF, "EscortSuccessful") == TRUE && GetLocalInt(OBJECT_SELF, "InConvo") == FALSE)
    {
        ClearAllActions();
        ActionStartConversation(GetMaster(OBJECT_SELF), "", FALSE, TRUE);
    }

    if(GetLocalInt(OBJECT_SELF, "LostQuest") == TRUE && GetLocalInt(OBJECT_SELF, "Escorted") == TRUE)
    {
        if (GetMaster(OBJECT_SELF) == OBJECT_INVALID)
        {
            AddRandomQuestJournalEntry(GetLocalObject(OBJECT_SELF, "oPC"), 3);
            DestroyObject(OBJECT_SELF);
            return;
        }
        ExecuteScript("x0_ch_hen_heart", OBJECT_SELF);
        return;
    }

    if(GetLocalInt(OBJECT_SELF, "EscortQuest") == TRUE)
    {
        if (GetMaster(OBJECT_SELF) == OBJECT_INVALID)
        {
            DeleteQuest(GetLocalObject(OBJECT_SELF, "oPC"));
            RemoveJournalQuestEntry("random_quest", GetLocalObject(OBJECT_SELF, "oPC"), FALSE);
            DestroyObject(OBJECT_SELF);
            return;
        }
        ExecuteScript("x0_ch_hen_heart", OBJECT_SELF);
        return;
    }

    if(GetLocalInt(OBJECT_SELF, "Escorted") == TRUE)
    {
        if (GetMaster(OBJECT_SELF) == OBJECT_INVALID)
        {
            DestroyObject(OBJECT_SELF);
            return;
        }
        ExecuteScript("x0_ch_hen_heart", OBJECT_SELF);
        return;
    }

    if(GetLocalInt(OBJECT_SELF, "Client") == TRUE || GetLocalInt(OBJECT_SELF, "RansomQuest") == TRUE) return;
    else if(GetLocalInt(OBJECT_SELF, "X4_VANILLA_AI") == TRUE) ExecuteScript("nw_c2_default1_v", OBJECT_SELF);
    else ExecuteScript("nw_c2_default1", OBJECT_SELF);
}
