//:://////////////////////////////////////////////////
//:: X0_CH_HEN_HEART
/*

  OnHeartbeat event handler for henchmen/associates.

 */
//:://////////////////////////////////////////////////
//:: Copyright (c) 2002 Floodgate Entertainment
//:: Created By: Naomi Novik
//:: Created On: 01/05/2003
//:://////////////////////////////////////////////////
#include "X0_INC_HENAI"



void EpicBonuses()
{
    object oPC = OBJECT_SELF; //I know it's not a PC, but it makes it easier to just copy the code from the PC's heartbeat
    int nACBonus;
    int nSRBonus;
    int nLevel = GetHitDice(oPC);
    effect eEffect;

    //Remove all effects releated with DD damage reduction, dragon immunities and AC penalties - these are the effects supposed to be created by the module
        effect e = GetFirstEffect(oPC);
        while(GetIsEffectValid(e))//loop all effects
            {
                if(GetEffectCreator(e) == GetModule())
                {
                    RemoveEffect(oPC,e);//remove it
                }
                e = GetNextEffect(oPC);
            }

    if ( GetItemPossessedBy(oPC, "anc_it_epiche") != OBJECT_INVALID) //if the NPC has an epic helmet
    {
    switch (nLevel)
        {
        case 40: nACBonus = 12; break;
        case 39: nACBonus = 12; break;
        case 38: nACBonus = 11; break;
        case 37: nACBonus = 11; break;
        case 36: nACBonus = 11; break;
        case 35: nACBonus = 10; break;
        case 34: nACBonus = 9; break;
        case 33: nACBonus = 8; break;
        case 32: nACBonus = 8; break;
        case 31: nACBonus = 7; break;
        case 30: nACBonus = 7; break;
        case 29: nACBonus = 7; break;
        case 28: nACBonus = 7; break;
        case 27: nACBonus = 6; break;
        case 26: nACBonus = 6; break;
        case 25: nACBonus = 5; break;
        case 24: nACBonus = 5; break;
        case 23: nACBonus = 4; break;
        case 22: nACBonus = 4; break;
        default: nACBonus = 3; break;
        }

    eEffect = ExtraordinaryEffect(EffectACIncrease(nACBonus, AC_DEFLECTION_BONUS));
    AssignCommand(GetModule(), ApplyEffectToObject(DURATION_TYPE_PERMANENT, eEffect, oPC));

    }

    if (GetTag(GetItemInSlot(INVENTORY_SLOT_CHEST, oPC)) == "anc_it_epicar") //if the NPC has an epic armor equipped
    {
    switch (nLevel)
        {
        case 40: nACBonus = 13; break;
        case 39: nACBonus = 13; break;
        case 38: nACBonus = 12; break;
        case 37: nACBonus = 12; break;
        case 36: nACBonus = 12; break;
        case 35: nACBonus = 10; break;
        case 34: nACBonus = 9; break;
        case 33: nACBonus = 9; break;
        case 32: nACBonus = 9; break;
        case 31: nACBonus = 8; break;
        case 30: nACBonus = 8; break;
        case 29: nACBonus = 7; break;
        case 28: nACBonus = 7; break;
        case 27: nACBonus = 6; break;
        case 26: nACBonus = 6; break;
        case 25: nACBonus = 6; break;
        case 24: nACBonus = 6; break;
        case 23: nACBonus = 4; break;
        case 22: nACBonus = 4; break;
        default: nACBonus = 3; break;
        }

    eEffect = ExtraordinaryEffect(EffectACIncrease(nACBonus, AC_ARMOUR_ENCHANTMENT_BONUS));
    AssignCommand(GetModule(), ApplyEffectToObject(DURATION_TYPE_PERMANENT, eEffect, oPC));

    }

    if (GetTag(GetItemInSlot(INVENTORY_SLOT_BELT, oPC)) == "anc_it_epicsr") //if the NPC has an epic belt equipped
    {
    nSRBonus = nLevel-18;
    if (nLevel < 21) nSRBonus = 12;

    eEffect = ExtraordinaryEffect(EffectSpellResistanceIncrease(nSRBonus));
    AssignCommand(GetModule(), ApplyEffectToObject(DURATION_TYPE_PERMANENT, eEffect, oPC));
    }

    //Apply Dwarven Defender damage reduction
        if (GetHasFeat(1118, oPC))
            {
            int nReduction;
            switch (GetLevelByClass(CLASS_TYPE_DWARVEN_DEFENDER, oPC))
                {
                case 6: nReduction = 3; break;
                case 7: nReduction = 3; break;
                case 8: nReduction = 3; break;
                case 9: nReduction = 3; break;
                case 10: nReduction = 6; break;
                case 11: nReduction = 6; break;
                case 12: nReduction = 6; break;
                case 13: nReduction = 6; break;
                case 14: nReduction = 9; break;
                case 15: nReduction = 9; break;
                case 16: nReduction = 9; break;
                case 17: nReduction = 9; break;
                case 18: nReduction = 12; break;
                case 19: nReduction = 12; break;
                case 20: nReduction = 12; break;
                case 21: nReduction = 12; break;
                case 22: nReduction = 15; break;
                case 23: nReduction = 15; break;
                case 24: nReduction = 15; break;
                case 25: nReduction = 15; break;
                case 26: nReduction = 18; break;
                case 27: nReduction = 18; break;
                case 28: nReduction = 18; break;
                case 29: nReduction = 18; break;
                case 30: nReduction = 21; break;
                }
            effect eReduction = EffectDamageReduction(nReduction, DAMAGE_POWER_PLUS_FIVE);
            eReduction = SupernaturalEffect(eReduction);
            AssignCommand(GetModule(), ApplyEffectToObject(DURATION_TYPE_PERMANENT, eReduction, oPC));
            }
        //Done applying damage reduction

        //Check for Parry being used and apply bonus then
        if (GetActionMode(oPC, ACTION_MODE_PARRY)==TRUE)
        {
        int nParryAC = GetSkillRank(SKILL_PARRY, oPC) / 5;
        if(nParryAC>6)nParryAC=6;
        effect eParryAC = SupernaturalEffect(EffectACIncrease(nParryAC, AC_DODGE_BONUS));
        ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eParryAC, oPC, 7.0);
        }
        //End of Parry part

        //Halve the normal Tumble AC bonus and restrict Pale Master AC bonus to 6
        if (GetSkillRank(SKILL_TUMBLE, oPC, TRUE) != 0 || GetLevelByClass(CLASS_TYPE_PALE_MASTER, oPC) > 11)
        {
        int nOld = GetSkillRank(SKILL_TUMBLE, oPC, TRUE)/5;
        int nNew = GetSkillRank(SKILL_TUMBLE, oPC, TRUE)/10;
        int nPalePenalty;
        switch (GetLevelByClass(CLASS_TYPE_PALE_MASTER, oPC))
            {
            case 30: nPalePenalty = 10; break;
            case 29: nPalePenalty = 10; break;
            case 28: nPalePenalty = 10; break;
            case 27: nPalePenalty = 8; break;
            case 26: nPalePenalty = 8; break;
            case 25: nPalePenalty = 8; break;
            case 24: nPalePenalty = 8; break;
            case 23: nPalePenalty = 6; break;
            case 22: nPalePenalty = 6; break;
            case 21: nPalePenalty = 6; break;
            case 20: nPalePenalty = 6; break;
            case 19: nPalePenalty = 4; break;
            case 18: nPalePenalty = 4; break;
            case 17: nPalePenalty = 4; break;
            case 16: nPalePenalty = 4; break;
            case 15: nPalePenalty = 2; break;
            case 14: nPalePenalty = 2; break;
            case 13: nPalePenalty = 2; break;
            case 12: nPalePenalty = 2; break;
            }
        int nPenalty = nOld - nNew;
        if ( GetLevelByClass(CLASS_TYPE_PALE_MASTER, oPC) > 11) nPenalty = nPenalty + nPalePenalty;
        effect eEffect = SupernaturalEffect(EffectACDecrease(nPenalty, AC_DODGE_BONUS));
        AssignCommand(GetModule(), ApplyEffectToObject(DURATION_TYPE_PERMANENT, eEffect, oPC));
        }

        // Grant the PC dragon immunity if he has that feat
        if ( GetHasFeat(1116, oPC) == TRUE )
        {
        int nType;
        switch(GetCreatureWingType(oPC))
        {
        case 4: nType = DAMAGE_TYPE_FIRE; break; //red dragon disciple
        case 34: nType = DAMAGE_TYPE_ACID; break; //black dragon disciple
        case 35: nType = DAMAGE_TYPE_ELECTRICAL; break; //blue dragon disciple
        case 36: nType = DAMAGE_TYPE_FIRE; break; //brass dragon disciple
        case 37: nType = DAMAGE_TYPE_ELECTRICAL; break; //bronze dragon disciple
        case 38: nType = DAMAGE_TYPE_ACID; break; //copper dragon disciple
        case 39: nType = DAMAGE_TYPE_FIRE; break; //gold dragon disciple
        case 40: nType = DAMAGE_TYPE_ACID; break; //green dragon disciple
        case 41: nType = DAMAGE_TYPE_COLD; break; //silver dragon disciple
        case 42: nType = DAMAGE_TYPE_COLD; break; //white dragon disciple
        default: nType = DAMAGE_TYPE_FIRE; break;
        }
        effect eImmunity = ExtraordinaryEffect(EffectDamageImmunityIncrease(nType, 100));
        AssignCommand(GetModule(), ApplyEffectToObject(DURATION_TYPE_PERMANENT, eImmunity, oPC));
        }

}

void main()
{    // SpawnScriptDebugger();

    //Apply the bonuses of epic items properly
    EpicBonuses();
    // If the henchman is in dying mode, make sure
    // they are non commandable. Sometimes they seem to
    // 'slip' out of this mode
    int bDying = GetIsHenchmanDying();

    if (bDying == TRUE)
    {
        int bCommandable = GetCommandable();
        if (bCommandable == TRUE)
        {
            // lie down again
            ActionPlayAnimation(ANIMATION_LOOPING_DEAD_FRONT,
                                          1.0, 65.0);
           SetCommandable(FALSE);
        }
    }

    // If we're dying or busy, we return
    // (without sending the user-defined event)
    if(GetAssociateState(NW_ASC_IS_BUSY) ||
       bDying)
        return;






    // Check to see if should re-enter stealth mode
    if (GetIsInCombat() == FALSE)
    {
        int nStealth=GetLocalInt(OBJECT_SELF, "X2_HENCH_STEALTH_MODE");
        if((nStealth == 1 || nStealth == 2)
            && GetActionMode(OBJECT_SELF, ACTION_MODE_STEALTH) == FALSE)
            {
                SetActionMode(OBJECT_SELF, ACTION_MODE_STEALTH, TRUE);
            }
    }

    // * checks to see if a ranged weapon was being used
    // * if so, it equips it back
    if (GetIsInCombat() == FALSE)
    {        //   SpawnScriptDebugger();
        object oRight = GetLocalObject(OBJECT_SELF, "X0_L_RIGHTHAND");
        if (GetIsObjectValid(oRight) == TRUE)
        {    // * you always want to blank this value, if it not invalid
            SetLocalObject(OBJECT_SELF, "X0_L_RIGHTHAND", OBJECT_INVALID);
            if (GetWeaponRanged(oRight) == TRUE)
            {
                ClearAllActions();
                bkEquipRanged(OBJECT_INVALID, TRUE, TRUE);
                //ActionEquipItem(
                return;

            }
        }
    }



    ExecuteScript("nw_ch_ac1", OBJECT_SELF);
}



