//::///////////////////////////////////////////////
//:: x0_s2_fiend
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
Summons the 'fiendish' servant for the player.
This is a modified version of Planar Binding


At Level 5 the Blackguard gets a Succubus

At Level 9 the Blackguard will get a Vrock

Will remain for one hour per level of blackguard
*/
//:://////////////////////////////////////////////
//:: Created By: Brent
//:: Created On: April 2003
//:://////////////////////////////////////////////
//// Edited by Magical Master for the PW of Glorwing
//// Now summons a more powerful Epic Vrock assuming the caster has the feat
//// Vrock improves every 3 levels...16-18, 19-21, 22-24, 25-27, 28-30
/////////////////////////////////////////////////

void RegenSummon();

void main()
{
    int nLevel = GetLevelByClass(CLASS_TYPE_BLACKGUARD, OBJECT_SELF);
    effect eSummon;
    string sSummon = "NW_S_SUCCUBUS";
    float fDelay = 3.0;
    int nDuration = nLevel;

    if (nLevel > 15 && GetHasFeat(1003,OBJECT_SELF))
    {
        if (nLevel > 27)
        {
            sSummon = "fmsumbgvrock2224";
        }
        else if (nLevel > 25)
        {
            sSummon = "fmsumbgvrock1921";
        }
        else if (nLevel > 23)
        {
            sSummon = "fmsumbgvrock1618";
        }
        else
        {
            sSummon = "x2_s_vrock";
        }
    }
    else if (nLevel > 8 )
    {
        sSummon = "NW_S_VROCK";
    }

    eSummon = ExtraordinaryEffect(EffectSummonCreature(sSummon, VFX_FNF_SUMMON_GATE, fDelay));
    ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, eSummon, GetSpellTargetLocation(), HoursToSeconds(nDuration));

}
