//::///////////////////////////////////////////////
//:: Name x2_def_ondeath
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Default OnDeath script
*/
//:://////////////////////////////////////////////
//:: Created By: Keith Warner
//:: Created On: June 11/03
//:://////////////////////////////////////////////
#include "quest_inc"

void main()
{
    //Travelling merchants drop some gold
    if (GetTag(OBJECT_SELF) == "anc_trmerch" && GetLocalInt(GetArea(OBJECT_SELF), "MerchantTrouble") == FALSE)
    {
        int nGold = GetLocalInt(OBJECT_SELF, "Gold") + GetLocalInt(OBJECT_SELF, "HiddenGold");
        GiveGoldToCreature(OBJECT_SELF, nGold);
        object oItem = GetFirstItemInInventory();
        while (GetIsObjectValid(oItem))
        {
            if (GetTag(oItem) == "NW_IT_GOLD001") SetDroppableFlag(oItem, TRUE);
            oItem = GetNextItemInInventory();
        }
    }

    //If we are one of the monsters from the monsters quest
    if (GetLocalInt(OBJECT_SELF, "QuestMonster") == TRUE)
    {
        object oArea = GetArea(OBJECT_SELF);
        object oCreature = GetFirstObjectInArea(oArea);
        int AllKilled = TRUE;
        while (GetIsObjectValid(oCreature))
            {
                if (GetLocalInt(oCreature, "QuestMonster") == TRUE && !GetIsDead(oCreature) && oCreature != OBJECT_SELF)
                {
                    AllKilled = FALSE;
                    break;
                }
                oCreature = GetNextObjectInArea(oArea);
            }
        object oPC = GetLocalObject(OBJECT_SELF, "oPC");
        if (AllKilled == TRUE) AddRandomQuestJournalEntry(oPC, 2);
    }

    //If we are town defenders during an invasion
    if (GetLocalInt(OBJECT_SELF, "Defender") == TRUE)
    {
        string sTown = GetLocalString(GetArea(OBJECT_SELF), "Town");
        string sDB = GetLocalString(GetModule(), "DB");
        int nNumber = GetCampaignInt(sDB, sTown+"_INV_DEF");
        SetCampaignInt(sDB, sTown+"_INV_DEF", nNumber+1);
    }

    //If we are town invaders during an invasion
    if (GetLocalInt(OBJECT_SELF, "Invader") == TRUE)
    {
        string sTown = GetLocalString(GetArea(OBJECT_SELF), "Town");
        string sDB = GetLocalString(GetModule(), "DB");
        int nNumber = GetCampaignInt(sDB, sTown+"_INV_NUM");
        if (GetIsPC(GetLastKiller()) == TRUE || GetIsPC(GetMaster(GetLastKiller())) == TRUE || GetIsPC(GetMaster(GetMaster(GetLastKiller()))) == TRUE)
        SetCampaignInt(sDB, sTown+"_INV_NUM", nNumber+1); //if it's the PC or one of their associates, make the kill count
        else if (Random(2) == 1) SetCampaignInt(sDB, sTown+"_INV_NUM", nNumber+1); //else there's 50% chance that the kill will be counted
    }

    if(GetLocalInt(OBJECT_SELF, "X4_VANILLA_AI") == TRUE) ExecuteScript("nw_c2_default7_v", OBJECT_SELF);
    else ExecuteScript("nw_c2_default7", OBJECT_SELF);
}
