//::///////////////////////////////////////////////
//:: Name x4_def_heartbeat
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Default Heartbeat script
*/
//:://////////////////////////////////////////////
//:: Created By: Keith Warner
//:: Created On: June 11/03
//:: Modified by: Grani
//:: Modified on: 03.09.2015
//:://////////////////////////////////////////////

#include "x3_inc_horse"
#include "x4_inc_functions"
#include "x2_inc_itemprop"
void main()
{
    object oPC = OBJECT_SELF; //This is to make copying the heartbeat from the PC's hb easier
    int nRoll;
    int bNoCombat=GetLocalInt(GetModule(),"X3_NO_MOUNTED_COMBAT_FEAT");

    //This part is a substitute for lacking NPC OnEquip and OnUnequip
    int nACBonus;
    int nSRBonus;
    itemproperty ipAdd;
    int nLevel = GetHitDice(oPC);
    object oEventItem;

    if (GetTag(GetItemInSlot(INVENTORY_SLOT_HEAD, oPC)) == "anc_it_epiche" && GetItemCursedFlag(GetItemInSlot(INVENTORY_SLOT_HEAD, oPC)) == FALSE) //if the item is an equipped epic helmet
    {
    oEventItem = GetItemInSlot(INVENTORY_SLOT_HEAD, oPC);
    switch (nLevel)
        {
        case 40: nACBonus = 12; break;
        case 39: nACBonus = 12; break;
        case 38: nACBonus = 11; break;
        case 37: nACBonus = 11; break;
        case 36: nACBonus = 11; break;
        case 35: nACBonus = 10; break;
        case 34: nACBonus = 9; break;
        case 33: nACBonus = 8; break;
        case 32: nACBonus = 8; break;
        case 31: nACBonus = 7; break;
        case 30: nACBonus = 7; break;
        case 29: nACBonus = 7; break;
        case 28: nACBonus = 7; break;
        case 27: nACBonus = 6; break;
        case 26: nACBonus = 6; break;
        case 25: nACBonus = 5; break;
        case 24: nACBonus = 5; break;
        case 23: nACBonus = 4; break;
        case 22: nACBonus = 4; break;
        default: nACBonus = 3; break;
        }

    IPRemoveAllItemProperties(oEventItem, DURATION_TYPE_TEMPORARY);
    IPRemoveAllItemProperties(oEventItem, DURATION_TYPE_PERMANENT);

    SetItemCursedFlag(oEventItem, TRUE);
    ipAdd = ItemPropertyACBonus(nACBonus);
    IPSafeAddItemProperty(oEventItem, ipAdd);
    }

    if (GetTag(GetItemInSlot(INVENTORY_SLOT_CHEST, oPC)) == "anc_it_epicar" && GetItemCursedFlag(GetItemInSlot(INVENTORY_SLOT_CHEST, oPC)) == FALSE) //if the item is an equipped epic armor
    {
    oEventItem = GetItemInSlot(INVENTORY_SLOT_CHEST, oPC);
    switch (nLevel)
        {
        case 40: nACBonus = 13; break;
        case 39: nACBonus = 13; break;
        case 38: nACBonus = 12; break;
        case 37: nACBonus = 12; break;
        case 36: nACBonus = 12; break;
        case 35: nACBonus = 10; break;
        case 34: nACBonus = 9; break;
        case 33: nACBonus = 9; break;
        case 32: nACBonus = 9; break;
        case 31: nACBonus = 8; break;
        case 30: nACBonus = 8; break;
        case 29: nACBonus = 7; break;
        case 28: nACBonus = 7; break;
        case 27: nACBonus = 6; break;
        case 26: nACBonus = 6; break;
        case 25: nACBonus = 6; break;
        case 24: nACBonus = 6; break;
        case 23: nACBonus = 4; break;
        case 22: nACBonus = 4; break;
        default: nACBonus = 3; break;
        }

    IPRemoveAllItemProperties(oEventItem, DURATION_TYPE_TEMPORARY);
    IPRemoveAllItemProperties(oEventItem, DURATION_TYPE_PERMANENT);

    SetItemCursedFlag(oEventItem, TRUE);
    ipAdd = ItemPropertyACBonus(nACBonus);
    IPSafeAddItemProperty(oEventItem, ipAdd);
    }

    if (GetTag(GetItemInSlot(INVENTORY_SLOT_BELT, oPC)) == "anc_it_epicsr" && GetItemCursedFlag(GetItemInSlot(INVENTORY_SLOT_BELT, oPC)) == FALSE) //if the item is an equipped epic belt
    {
    oEventItem = GetItemInSlot(INVENTORY_SLOT_BELT, oPC);
    nSRBonus = nLevel-18;
    if (nLevel < 21) nSRBonus = 12;

    IPRemoveAllItemProperties(oEventItem, DURATION_TYPE_TEMPORARY);
    IPRemoveAllItemProperties(oEventItem, DURATION_TYPE_PERMANENT);

    SetItemCursedFlag(oEventItem, TRUE);
    ipAdd = ItemPropertyBonusSpellResistance(nSRBonus);
    IPSafeAddItemProperty(oEventItem, ipAdd);
    }

    oEventItem = GetFirstItemInInventory(oPC);
    while (oEventItem != OBJECT_INVALID)
        {
            if(GetTag(oEventItem) == "anc_it_epicsr" && GetItemCursedFlag(oEventItem) == TRUE) //if the item is an unequipped epic belt
                {
                SetItemCursedFlag(oEventItem, FALSE);
                IPRemoveAllItemProperties(oEventItem, DURATION_TYPE_TEMPORARY);
                IPRemoveAllItemProperties(oEventItem, DURATION_TYPE_PERMANENT);
                ipAdd = ItemPropertyBonusSpellResistance(IP_CONST_SPELLRESISTANCEBONUS_32);
                IPSafeAddItemProperty(oEventItem, ipAdd);
                }
            if((GetTag(oEventItem) == "anc_it_epicar" || GetTag(oEventItem) == "anc_it_epiche") && GetItemCursedFlag(oEventItem) == TRUE) //if the item is an unequipped epic armor or helmet
                {
                SetItemCursedFlag(oEventItem, FALSE);
                IPRemoveAllItemProperties(oEventItem, DURATION_TYPE_TEMPORARY);
                IPRemoveAllItemProperties(oEventItem, DURATION_TYPE_PERMANENT);
                ipAdd = ItemPropertyACBonus(3);
                IPSafeAddItemProperty(oEventItem, ipAdd);
                }
            oEventItem = GetNextItemInInventory(oPC);
        }
    //End of pseud-onequip and pseudo-onunequip part


    //This part applies AC penalties to NPCs as well as provides them with dragon immunity if applicable
    if (GetLocalInt(oPC,"bX3_STORE_MOUNT_INFO"))
        { // store
            DeleteLocalInt(oPC,"bX3_STORE_MOUNT_INFO");
            HorseSaveToDatabase(oPC,X3_HORSE_DATABASE);
        } // store
        if (!bNoCombat&&GetHasFeat(FEAT_MOUNTED_COMBAT,oPC)&&HorseGetIsMounted(oPC))
        { // check for AC increase
            nRoll=d20()+GetSkillRank(SKILL_RIDE,oPC);
            nRoll=nRoll-10;
            if (nRoll>4)
            { // ac increase
                nRoll=nRoll/5;
                if(nRoll>6)nRoll=6;
                ApplyEffectToObject(DURATION_TYPE_TEMPORARY,EffectACIncrease(nRoll),oPC,7.0);
            } // ac increase
        } // check for AC increase
        //Check for Dirty Fighting being used and apply bonus then
        if (GetActionMode(oPC, ACTION_MODE_DIRTY_FIGHTING)==TRUE)
        {
        itemproperty pDirty = ItemPropertyOnHitCastSpell(125, 1);
        object oWeapon = GetItemInSlot(4, oPC);
        AddItemProperty(1, pDirty, oWeapon, 6.0);
        SetLocalInt(oWeapon, "DFmode", 1);
        DelayCommand(5.9, SetLocalInt(oWeapon, "DFmode", 0));
        }
        //End of Dirty Fighting part

        //Remove all effects releated with DD damage reduction, dragon immunities and AC penalties - these are the effects supposed to be created by the module
        effect e = GetFirstEffect(oPC);
        while(GetIsEffectValid(e))//loop all effects
            {
                if(GetEffectCreator(e) == GetModule())
                {
                    RemoveEffect(oPC,e);//remove it
                }
                e = GetNextEffect(oPC);
            }

        //Apply Dwarven Defender damage reduction
        if (GetHasFeat(1118, oPC))
            {
            int nReduction;
            switch (GetLevelByClass(CLASS_TYPE_DWARVEN_DEFENDER, oPC))
                {
                case 6: nReduction = 3; break;
                case 7: nReduction = 3; break;
                case 8: nReduction = 3; break;
                case 9: nReduction = 3; break;
                case 10: nReduction = 6; break;
                case 11: nReduction = 6; break;
                case 12: nReduction = 6; break;
                case 13: nReduction = 6; break;
                case 14: nReduction = 9; break;
                case 15: nReduction = 9; break;
                case 16: nReduction = 9; break;
                case 17: nReduction = 9; break;
                case 18: nReduction = 12; break;
                case 19: nReduction = 12; break;
                case 20: nReduction = 12; break;
                case 21: nReduction = 12; break;
                case 22: nReduction = 15; break;
                case 23: nReduction = 15; break;
                case 24: nReduction = 15; break;
                case 25: nReduction = 15; break;
                case 26: nReduction = 18; break;
                case 27: nReduction = 18; break;
                case 28: nReduction = 18; break;
                case 29: nReduction = 18; break;
                case 30: nReduction = 21; break;
                }
            effect eReduction = EffectDamageReduction(nReduction, DAMAGE_POWER_PLUS_FIVE);
            eReduction = SupernaturalEffect(eReduction);
            AssignCommand(GetModule(), ApplyEffectToPCAndHideIcon(eReduction, oPC));
            }
        //Done applying damage reduction

        //Check for Parry being used and apply bonus then
        if (GetActionMode(oPC, ACTION_MODE_PARRY)==TRUE)
        {
        int nParryAC = GetSkillRank(SKILL_PARRY, oPC) / 5;
        if(nParryAC>6)nParryAC=6;
        effect eParryAC = SupernaturalEffect(EffectACIncrease(nParryAC, AC_DODGE_BONUS));
        ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eParryAC, oPC, 7.0);
        }
        //End of Parry part

        //Halve the normal Tumble AC bonus and restrict Pale Master AC bonus to 6
        if (GetSkillRank(SKILL_TUMBLE, oPC, TRUE) != 0 || GetLevelByClass(CLASS_TYPE_PALE_MASTER, oPC) > 11)
        {
        int nOld = GetSkillRank(SKILL_TUMBLE, oPC, TRUE)/5;
        int nNew = GetSkillRank(SKILL_TUMBLE, oPC, TRUE)/10;
        int nPalePenalty;
        switch (GetLevelByClass(CLASS_TYPE_PALE_MASTER, oPC))
            {
            case 30: nPalePenalty = 10; break;
            case 29: nPalePenalty = 10; break;
            case 28: nPalePenalty = 10; break;
            case 27: nPalePenalty = 8; break;
            case 26: nPalePenalty = 8; break;
            case 25: nPalePenalty = 8; break;
            case 24: nPalePenalty = 8; break;
            case 23: nPalePenalty = 6; break;
            case 22: nPalePenalty = 6; break;
            case 21: nPalePenalty = 6; break;
            case 20: nPalePenalty = 6; break;
            case 19: nPalePenalty = 4; break;
            case 18: nPalePenalty = 4; break;
            case 17: nPalePenalty = 4; break;
            case 16: nPalePenalty = 4; break;
            case 15: nPalePenalty = 2; break;
            case 14: nPalePenalty = 2; break;
            case 13: nPalePenalty = 2; break;
            case 12: nPalePenalty = 2; break;
            }
        int nPenalty = nOld - nNew;
        if ( GetLevelByClass(CLASS_TYPE_PALE_MASTER, oPC) > 11) nPenalty = nPenalty + nPalePenalty;
        effect eEffect = SupernaturalEffect(EffectACDecrease(nPenalty, AC_DODGE_BONUS));
        AssignCommand(GetModule(), ApplyEffectToPCAndHideIcon(eEffect, oPC));
        }

        // Grant the PC dragon immunity if he has that feat
        if ( GetHasFeat(1116, oPC) == TRUE )
        {
        int nType;
        switch(GetCreatureWingType(oPC))
        {
        case 4: nType = DAMAGE_TYPE_FIRE; break; //red dragon disciple
        case 34: nType = DAMAGE_TYPE_ACID; break; //black dragon disciple
        case 35: nType = DAMAGE_TYPE_ELECTRICAL; break; //blue dragon disciple
        case 36: nType = DAMAGE_TYPE_FIRE; break; //brass dragon disciple
        case 37: nType = DAMAGE_TYPE_ELECTRICAL; break; //bronze dragon disciple
        case 38: nType = DAMAGE_TYPE_ACID; break; //copper dragon disciple
        case 39: nType = DAMAGE_TYPE_FIRE; break; //gold dragon disciple
        case 40: nType = DAMAGE_TYPE_ACID; break; //green dragon disciple
        case 41: nType = DAMAGE_TYPE_COLD; break; //silver dragon disciple
        case 42: nType = DAMAGE_TYPE_COLD; break; //white dragon disciple
        default: nType = DAMAGE_TYPE_FIRE; break;
        }
        effect eImmunity = ExtraordinaryEffect(EffectDamageImmunityIncrease(nType, 100));
        AssignCommand(GetModule(), ApplyEffectToPCAndHideIcon(eImmunity, oPC));
        }

    ExecuteScript("nw_c2_default1", OBJECT_SELF);
}
