//::///////////////////////////////////////////////
//:: Default On Enter for Module
//:: x4_mod_def_enter
//:: Copyright (c) 2014 Bioware Corp.
//:://////////////////////////////////////////////
/*
     This script adds the horse menus to the PCs
     and binds CD-key to player login to avoid
     other players logging on accounts others than
     their own.
*/
//:://////////////////////////////////////////////
//:: Created By: Deva B. Winblood
//:: Created On: Dec 30th, 2007
//:: Last Update: April 21th, 2008
//:://////////////////////////////////////////////

#include "x3_inc_horse"
#include "x4_inc_secure"

void main()
{
    object oPC=GetEnteringObject();

    /* verify CD keys and double logins to stop hackers if the module switch is active */
    if (GetLocalString(GetModule(), "X4_SECURE_LOGIN") == "TRUE")
    {
    if (VerifyPlayernameAgainstCDKey(oPC))
        {
        if (GetIsObjectValid(oPC))
            BootPC(oPC);
        return;
        }
    }

    //Cancel any polymorphs the player might have
    RemoveSpecificEffect(EFFECT_TYPE_POLYMORPH, oPC);

    {
    // Put custom code here
    }

    ExecuteScript("x3_mod_pre_enter",OBJECT_SELF); // Override for other skin systems
    if ((GetIsPC(oPC)||GetIsDM(oPC))&&!GetHasFeat(FEAT_HORSE_MENU,oPC))
    { // add horse menu
        HorseAddHorseMenu(oPC);
        if (GetLocalInt(GetModule(),"X3_ENABLE_MOUNT_DB"))
        { // restore PC horse status from database
            DelayCommand(2.0,HorseReloadFromDatabase(oPC,X3_HORSE_DATABASE));
        } // restore PC horse status from database
    } // add horse menu
    if (GetIsPC(oPC))
    { // more details
        // restore appearance in case you export your character in mounted form, etc.
        if (!GetSkinInt(oPC,"bX3_IS_MOUNTED")) HorseIfNotDefaultAppearanceChange(oPC);
        // pre-cache horse animations for player as attaching a tail to the model
        HorsePreloadAnimations(oPC);
        DelayCommand(3.0,HorseRestoreHenchmenLocations(oPC));
    } // more details
}
