//::///////////////////////////////////////////////
//:: Heartbeat Event
//:: x4_mod_def_hb
//:: (c) 2008 Bioware Corp.
//:://////////////////////////////////////////////
/*
    This heartbeat exists only to make sure it
    handles in its own way the benefits of having
    the feat Mounted Combat.   See the script
    x3_inc_horse for complete details of variables
    and flags that can be used with this.   This script
    is also used to provide support for persistence.
*/
//:://////////////////////////////////////////////
//:: Created By: Deva Winblood
//:: Created On: April 2nd, 2008
//:://////////////////////////////////////////////

#include "x3_inc_horse"





/////////////////////////////////////////////////////////////[ MAIN ]///////////
void main()
{
    object oPC=GetFirstPC();
    int nRoll;
    int bNoCombat=GetLocalInt(GetModule(),"X3_NO_MOUNTED_COMBAT_FEAT");

    {
    // Put custom code that is NOT related to any PC here
    }

    while(GetIsObjectValid(oPC))
    { // PC traversal

        {
        // Put custom code RELATED to PCs here
        }

        if (GetLocalInt(oPC,"bX3_STORE_MOUNT_INFO"))
        { // store
            DeleteLocalInt(oPC,"bX3_STORE_MOUNT_INFO");
            HorseSaveToDatabase(oPC,X3_HORSE_DATABASE);
        } // store
        if (!bNoCombat&&GetHasFeat(FEAT_MOUNTED_COMBAT,oPC)&&HorseGetIsMounted(oPC))
        { // check for AC increase
            nRoll=d20()+GetSkillRank(SKILL_RIDE,oPC);
            nRoll=nRoll-10;
            if (nRoll>4)
            { // ac increase
                nRoll=nRoll/5;
                ApplyEffectToObject(DURATION_TYPE_TEMPORARY,EffectACIncrease(nRoll),oPC,7.0);
            } // ac increase
        } // check for AC increase
        //Check for Dirty Fighting being used and apply bonus then
        if (GetActionMode(oPC, ACTION_MODE_DIRTY_FIGHTING)==TRUE)
        {
        itemproperty pDirty = ItemPropertyOnHitCastSpell(125, 1);
        object oWeapon = GetItemInSlot(4, oPC);
        AddItemProperty(1, pDirty, oWeapon, 6.0);
        SetLocalInt(oWeapon, "DFmode", 1);
        DelayCommand(5.9, SetLocalInt(oWeapon, "DFmode", 0));
        }
        //End of Dirty Fighting part

        //Apply Dwarven Defender damage reduction
        if (GetHasFeat(1118, oPC))
            {
            int nReduction;
            switch (GetLevelByClass(CLASS_TYPE_DWARVEN_DEFENDER, oPC))
                {
                case 6: nReduction = 3; break;
                case 7: nReduction = 3; break;
                case 8: nReduction = 3; break;
                case 9: nReduction = 3; break;
                case 10: nReduction = 6; break;
                case 11: nReduction = 6; break;
                case 12: nReduction = 6; break;
                case 13: nReduction = 6; break;
                case 14: nReduction = 9; break;
                case 15: nReduction = 9; break;
                case 16: nReduction = 9; break;
                case 17: nReduction = 9; break;
                case 18: nReduction = 12; break;
                case 19: nReduction = 12; break;
                case 20: nReduction = 12; break;
                case 21: nReduction = 12; break;
                case 22: nReduction = 15; break;
                case 23: nReduction = 15; break;
                case 24: nReduction = 15; break;
                case 25: nReduction = 15; break;
                case 26: nReduction = 18; break;
                case 27: nReduction = 18; break;
                case 28: nReduction = 18; break;
                case 29: nReduction = 18; break;
                case 30: nReduction = 21; break;
                }
            effect eReduction = EffectDamageReduction(nReduction, DAMAGE_POWER_PLUS_FIVE);
            eReduction = SupernaturalEffect(eReduction);
            ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eReduction, oPC, 7.0);
            }
        //Done applying damage reduction

        //Check for Parry being used and apply bonus then
        if (GetActionMode(oPC, ACTION_MODE_PARRY)==TRUE)
        {
        int nParryAC = GetSkillRank(SKILL_PARRY, oPC) / 5;
        effect eParryAC = SupernaturalEffect(EffectACIncrease(nParryAC, AC_SHIELD_ENCHANTMENT_BONUS));
        ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eParryAC, oPC, 7.0);
        }
        //End of Parry part


        //Halve the normal Tumble AC bonus, restrict Pale Master AC bonus to 6
        if (GetSkillRank(SKILL_TUMBLE, oPC, TRUE) != 0 || GetLevelByClass(CLASS_TYPE_PALE_MASTER, oPC) > 11)
        {
        effect e = GetFirstEffect(oPC);
            while(GetIsEffectValid(e))//loop all effects
            {
                if(GetEffectCreator(e) == GetModule() && GetEffectType(e) == EFFECT_TYPE_AC_DECREASE)//if effect was created by this item
                {
                    RemoveEffect(oPC,e);//remove it
                }
                e = GetNextEffect(oPC);
            }
        int nOld = GetSkillRank(SKILL_TUMBLE, oPC, TRUE)/5;
        int nNew = GetSkillRank(SKILL_TUMBLE, oPC, TRUE)/10;
        int nPalePenalty;
        switch (GetLevelByClass(CLASS_TYPE_PALE_MASTER, oPC))
            {
            case 30: nPalePenalty = 10; break;
            case 29: nPalePenalty = 10; break;
            case 28: nPalePenalty = 10; break;
            case 27: nPalePenalty = 8; break;
            case 26: nPalePenalty = 8; break;
            case 25: nPalePenalty = 8; break;
            case 24: nPalePenalty = 8; break;
            case 23: nPalePenalty = 6; break;
            case 22: nPalePenalty = 6; break;
            case 21: nPalePenalty = 6; break;
            case 20: nPalePenalty = 6; break;
            case 19: nPalePenalty = 4; break;
            case 18: nPalePenalty = 4; break;
            case 17: nPalePenalty = 4; break;
            case 16: nPalePenalty = 4; break;
            case 15: nPalePenalty = 2; break;
            case 14: nPalePenalty = 2; break;
            case 13: nPalePenalty = 2; break;
            case 12: nPalePenalty = 2; break;
            }
        int nPenalty = nOld - nNew;
        if ( GetLevelByClass(CLASS_TYPE_PALE_MASTER, oPC) > 11) nPenalty = nPenalty + nPalePenalty;
        effect eEffect = SupernaturalEffect(EffectACDecrease(nPenalty, AC_DODGE_BONUS));
        AssignCommand(GetModule(), ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eEffect, oPC, 7.0));
        }

        // If the PC has less than 3 levels of red dragon disciple.
        if ( GetLevelByClass(CLASS_TYPE_DRAGON_DISCIPLE, oPC) < 3 )
        {
        SetCreatureWingType(CREATURE_WING_TYPE_NONE, oPC);
        }

        // Grant the PC dragon immunity if he has that feat
        if ( GetHasFeat(1116, oPC) == TRUE )
        {
        int nType;
        switch(GetCreatureWingType(oPC))
        {
        case 4: nType = DAMAGE_TYPE_FIRE; break; //red dragon disciple
        case 34: nType = DAMAGE_TYPE_ACID; break; //black dragon disciple
        case 35: nType = DAMAGE_TYPE_ELECTRICAL; break; //blue dragon disciple
        case 36: nType = DAMAGE_TYPE_FIRE; break; //brass dragon disciple
        case 37: nType = DAMAGE_TYPE_ELECTRICAL; break; //bronze dragon disciple
        case 38: nType = DAMAGE_TYPE_ACID; break; //copper dragon disciple
        case 39: nType = DAMAGE_TYPE_FIRE; break; //gold dragon disciple
        case 40: nType = DAMAGE_TYPE_ACID; break; //green dragon disciple
        case 41: nType = DAMAGE_TYPE_COLD; break; //silver dragon disciple
        case 42: nType = DAMAGE_TYPE_COLD; break; //white dragon disciple
        default: nType = DAMAGE_TYPE_FIRE; break;
        }
        effect eImmunity = SupernaturalEffect(EffectDamageImmunityIncrease(nType, 100));
        ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eImmunity, oPC, 7.0);
        }

        oPC=GetNextPC();
    } // PC traversal
}
/////////////////////////////////////////////////////////////[ MAIN ]///////////
