//::///////////////////////////////////////////////
//:: x4_mod_def_lvl.nss
//:: Copyright (c) 2014 Bioware Corp.
//:://////////////////////////////////////////////
/*
 This script fires whenever a player levels up.
 If the PC tries to break the minimum class level requirement, cancel the level-up.
 If the henchmen is capable of going up a level, they do.
 Place in the OnPlayerLevelUp event in Module Properties
*/
//:://////////////////////////////////////////////
//:: Created By:     Brent
//:: Created On:     2002
//:: Modified By: 69MEH69
//:://////////////////////////////////////////////
#include "69_hench_lib"
#include "69_leadership"
#include "x4_inc_functions"

void main()
{
    object oPC = GetPCLevellingUp();
    int nPC = GetHitDice(oPC);
    effect eEffect = GetFirstEffect(oPC);
    while (GetIsEffectValid(eEffect))
    {
        if (GetEffectType(eEffect) == EFFECT_TYPE_POLYMORPH)
        {
        FloatingTextStringOnCreature("You can't level-up under the polymorph effect!", oPC, TRUE);
        ReassignLevel(oPC, 1);
        return;
        }
        eEffect = GetNextEffect(oPC);
    }
    //Enforce minimum level in every class requirement and stop the script if the player is delevelled.
    EnforceAllowedLevel(oPC, GetLocalInt(GetModule(), "X4_MIN_CLASS_LEVEL"), 40);
    if (GetHitDice(oPC) != nPC) return;
    int nNth = 1;
    object oHench = GetHenchman(oPC, nNth);
    int nNewClass, nClassPackage;
    //Check for Leadership
    int nLeadership = GetLocalInt(GetModule(), "nLeadership");
    if(nLeadership == 1)
    {
     //Resets Maximum Henchmen
     SetMaxHenchmen69(oPC);
     GetMaxHenchmen69(oPC);
    }
    //Check for Henchman XP
    int HENCH_XP = GetLocalInt(GetModule(), "HENCHXP");
    if(HENCH_XP == 0)
    {
        while(GetIsObjectValid(oHench))
        {
            if(GetCanLevelUp69(oPC, oHench))
            {
              AssignCommand(oHench, SpeakString("I feel stronger now."));
              CheckHenchClass69(oHench);
              nNewClass = GetLocalInt(oHench, "NewClass");
              nClassPackage = GetLocalInt(oHench, "ClassPackage");
              LevelUpHenchman69(oHench, oPC);
            }
            oHench = GetHenchman(oPC, ++nNth);
         }
        }

    // If the PC has 3 levels of red dragon disciple AND doesn't have blood identifier alread:.
    if (( GetLevelByClass(CLASS_TYPE_DRAGON_DISCIPLE, oPC) == 3 ) && ( GetItemPossessedBy(oPC, "dd_identifier") == OBJECT_INVALID ) )
    {
       CreateItemOnObject("dd_identifier", oPC);
    }
}
