//::///////////////////////////////////////////////
//:: Example XP2 OnItemEquipped
//:: x4_mod_def_unequ
//:: (c) 2014 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Put into: OnUnEquip Event
*/
//:://////////////////////////////////////////////
//:: Created By: Georg Zoeller
//:: Created On: 2003-07-16
//:://////////////////////////////////////////////
//:: Modified By: Deva Winblood
//:: Modified On: April 15th, 2008
//:: Added Support for Mounted Archery Feat penalties
//:://////////////////////////////////////////////

#include "x2_inc_switches"
#include "x2_inc_intweapon"
#include "x3_inc_horse"
#include "x4_inc_functions"

void Eswf(object oPC)
{
int nSuperiorAttack = 0;
        if (GetHasFeat(1119, oPC))
            {
            switch (GetLevelByClass(CLASS_TYPE_WEAPON_MASTER, oPC))
                {
                case 13:
                case 14:
                case 15:
                case 16:
                case 17:
                case 18:
                case 19:
                case 20: nSuperiorAttack = 1; break;
                case 21:
                case 22:
                case 23:
                case 24:
                case 25:
                case 26:
                case 27:
                case 28:
                case 29: nSuperiorAttack = 2; break;
                case 30: nSuperiorAttack = 3; break;
                }
            effect eSuperiorAttack;
            int nWoC = GetHasWeaponOfChoiceEquipped(oPC);
            if (nWoC == 1) eSuperiorAttack = EffectAttackIncrease(nSuperiorAttack, ATTACK_BONUS_ONHAND);
            if (nWoC == 2) eSuperiorAttack = EffectAttackIncrease(nSuperiorAttack, ATTACK_BONUS_OFFHAND);
            if (nWoC == 3) eSuperiorAttack = EffectAttackIncrease(nSuperiorAttack, ATTACK_BONUS_MISC);
            eSuperiorAttack = SupernaturalEffect(eSuperiorAttack);
            if (nSuperiorAttack != 0 && nWoC != 0) AssignCommand(GetModule(), ApplyEffectToPCAndHideIcon(eSuperiorAttack, oPC));
            }
}

void main()
{
     object oItem = GetPCItemLastUnequipped();
     object oPC   = GetPCItemLastUnequippedBy();

     AssignCommand(oPC, ClearAllActions());

    // -------------------------------------------------------------------------
    //  Intelligent Weapon System
    // -------------------------------------------------------------------------
    if (IPGetIsIntelligentWeapon(oItem))
    {
            IWSetIntelligentWeaponEquipped(oPC,OBJECT_INVALID);
            IWPlayRandomUnequipComment(oPC,oItem);
    }

    // -------------------------------------------------------------------------
    // Mounted benefits control
    // -------------------------------------------------------------------------
    if (GetWeaponRanged(oItem))
    {
        DeleteLocalInt(oPC,"bX3_M_ARCHERY");
        HORSE_SupportAdjustMountedArcheryPenalty(oPC);
    }

    // -------------------------------------------------------------------------
    // Generic Item Script Execution Code
    // If MODULE_SWITCH_EXECUTE_TAGBASED_SCRIPTS is set to TRUE on the module,
    // it will execute a script that has the same name as the item's tag
    // inside this script you can manage scripts for all events by checking against
    // GetUserDefinedItemEventNumber(). See x2_it_example.nss
    // -------------------------------------------------------------------------
    if (GetModuleSwitchValue(MODULE_SWITCH_ENABLE_TAGBASED_SCRIPTS) == TRUE)
    {
        SetUserDefinedItemEventNumber(X2_ITEM_EVENT_UNEQUIP);
        int nRet =   ExecuteScriptAndReturnInt(GetUserDefinedItemEventScriptName(oItem),OBJECT_SELF);
        if (nRet == X2_EXECUTE_SCRIPT_END)
        {
           return;
        }
    }

    //Remove all effects releated with epic superior weapon focus (damage decrease)
        effect e = GetFirstEffect(oPC);
        while(GetIsEffectValid(e))//loop all effects
            {
                if(GetEffectCreator(e) == GetModule() && GetEffectType(e) == EFFECT_TYPE_ATTACK_INCREASE)
                {
                    RemoveEffect(oPC,e);//remove it
                }
                e = GetNextEffect(oPC);
            }
    //Apply Epic Superior Weapon Focus attack nerf - the bonus is now +1 at level 13, +2 at level 21, +3 at level 30
        DelayCommand(0.5, Eswf(oPC));

    {
     //Put your custom code here.
    }
}
