//::///////////////////////////////////////////////
//:: x0_skctrap_act_5
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Creates a deadly trap kit of the current 'trap type'

*/
//:://////////////////////////////////////////////
//:: Created By:
//:: Created On:
//:://////////////////////////////////////////////

#include "x0_inc_skills"

void skillCTRAPCreateTrapKit2(string sComponent, object oPC, int nTrapDifficulty)
{
    string sTrapKit = "";
    int nDifficulty = 40;

    if (sComponent == SKILL_CTRAP_FIRECOMPONENT)
    {
        sTrapKit = "anc_trapfire5";
    }
    else
    if (sComponent == SKILL_CTRAP_ELECTRICALCOMPONENT)
    {
        sTrapKit = "anc_trapelec5";
    }
    else
    if (sComponent == SKILL_CTRAP_FROSTCOMPONENT)
    {
        sTrapKit = "anc_trapfrost5";
    }
    else
    if (sComponent == SKILL_CTRAP_SONICCOMPONENT)
    {
        sTrapKit = "anc_trapsonic5";
    }

    // * do skill roll
//    SpeakString("UT: MY ROLL: "+ IntToString(GetSkillRank(mySKILL_CRAFT_TRAP)));


    if (GetIsSkillSuccessful(oPC, 22, nDifficulty) == TRUE)
    {
        // * "UT: Craft Trap Skill Success."
      FloatingTextStrRefOnCreature(2700, oPC);
      object oTrap = CreateItemOnObject(sTrapKit, oPC, 1);
      SetIdentified(oTrap, TRUE);
    }
    else
    // * trap failed
    {
        // * Did not lose components
        if (Random(100) < 90)
        {
            // "UT: Craft Trap Skill Failed."
            FloatingTextStrRefOnCreature(2701, oPC);
            ClearTrapMaking();
            return; // * means you didn't fail enough to lose components
        }
        // * 10% chance that components were lost
        else
            // "UT: Craft Trap Skill Failed. Components lost."
         FloatingTextStrRefOnCreature(2702, oPC);
    }
    ClearTrapMaking();
    // * removed components if succeeded or failed badly
    skillCTRAPTakeComponent(sComponent, oPC, nTrapDifficulty);

}

void main()
{
    if (skillCTRAPGetHasComponent(skillCTRAPGetCurrentTrapView(), GetPCSpeaker(), 9) == FALSE) return;
    skillCTRAPCreateTrapKit2(skillCTRAPGetCurrentTrapView(), GetPCSpeaker(), 9);
}

