//::///////////////////////////////////////////////
//:: Breath Weapon for Dragon Disciple Class
//:: x2_s2_discbreath
//:: Copyright (c) 2003Bioware Corp.
//:://////////////////////////////////////////////
/*

  Damage Type is Fire
  Save is Reflex
  Shape is cone, 30' == 10m

  Level      Damage      Save
  ---------------------------
  3          2d10         19
  7          4d10         19
  10          6d10        19

  after 10:
   damage: 6d10  + 1d10 per 3 levels after 10
   savedc: increasing by 1 every 4 levels after 10



*/
//:://////////////////////////////////////////////
//:: Created By: Georg Zoeller
//:: Created On: June, 17, 2003
//:://////////////////////////////////////////////
/*
Patch 1.70

- wrong target check (could affect other NPCs)
- damage was the same for all creatures in AoE
- old evasion behaviour (now that evasion is applied will appear in log)
*/

#include "x0_i0_spells"

void main()
{
    //This part is to avoid some weird stacking issues
    if (GetLocalInt(OBJECT_SELF, "ddbreath") == 1)
        {
            IncrementRemainingFeatUses(OBJECT_SELF, FEAT_DRAGON_DIS_BREATH);
            return;
        }
    location lLocation = GetSpellTargetLocation();
    SetLocalInt(OBJECT_SELF, "ddbreath", 1);
    switch (GetCreatureWingType(OBJECT_SELF))
    {
        case 4: ActionCastSpellAtLocation(239, lLocation, METAMAGIC_ANY, TRUE, PROJECTILE_PATH_TYPE_DEFAULT, TRUE);break; //red dragon breathing fire
        case 34: ActionCastSpellAtLocation(236, lLocation, METAMAGIC_ANY, TRUE, PROJECTILE_PATH_TYPE_DEFAULT, TRUE);break; //black dragon breathing acid
        case 35: ActionCastSpellAtLocation(241, lLocation, METAMAGIC_ANY, TRUE, PROJECTILE_PATH_TYPE_DEFAULT, TRUE);break; //blue dragon breathing lightning
        case 36: ActionCastSpellAtLocation(239, lLocation, METAMAGIC_ANY, TRUE, PROJECTILE_PATH_TYPE_DEFAULT, TRUE);break; //brass dragon breathing fire
        case 37: ActionCastSpellAtLocation(241, lLocation, METAMAGIC_ANY, TRUE, PROJECTILE_PATH_TYPE_DEFAULT, TRUE);break; //bronze dragon breathing lightning
        case 38: ActionCastSpellAtLocation(236, lLocation, METAMAGIC_ANY, TRUE, PROJECTILE_PATH_TYPE_DEFAULT, TRUE);break; //copper dragon breathing acid
        case 39: ActionCastSpellAtLocation(239, lLocation, METAMAGIC_ANY, TRUE, PROJECTILE_PATH_TYPE_DEFAULT, TRUE);break; //gold dragon breathing fire
        case 40: ActionCastSpellAtLocation(240, lLocation, METAMAGIC_ANY, TRUE, PROJECTILE_PATH_TYPE_DEFAULT, TRUE);break; //green dragon breathing gas
        case 41: ActionCastSpellAtLocation(237, lLocation, METAMAGIC_ANY, TRUE, PROJECTILE_PATH_TYPE_DEFAULT, TRUE);break; //silver dragon breathing cold
        case 42: ActionCastSpellAtLocation(237, lLocation, METAMAGIC_ANY, TRUE, PROJECTILE_PATH_TYPE_DEFAULT, TRUE);break; //white dragon breathing cold
    }

}
